/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

void DrawMyCursor(viewport, clear)
VIewportdata *viewport;
int clear;
{
	XSegment seg[6];
	int x, y;
	int size = 0, lineleft = 0;

	if(ISHZ(*(viewport->cursor.CurPtr)))
		size = (viewport->horOrder ? viewport->cursor.hzdata.point_height : viewport->cursor.hzdata.point_width);
	else size = viewport->cursor.hzdata.point_height;

	lineleft = viewport->cursor.LineHeight - size;

	if(viewport->viewp.ViewPortPage == viewport->cursor.ViewPortCurPage)
	{

		x = viewport->cursor.ViewPortCur_x - viewport->viewp.ViewPort_x;
		y = viewport->cursor.ViewPortCur_y - viewport->viewp.ViewPort_y + (viewport->horOrder ? lineleft : 0);

		if(x > -size/2 && x < viewport->viewp.ViewPortWidth + size/2 &&
	   	   y > -size && y < viewport->viewp.ViewPortHeight + size)
		{
			x = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (x * viewport->zoom / 100), XmPIXELS);
			y = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (y * viewport->zoom / 100), XmPIXELS);
			size = XmConvertUnits(viewport->resource.WorkArea, CONVERT_Y, Xm100TH_POINTS, (size * viewport->zoom / 100), XmPIXELS);
			
			if(viewport->horOrder)
			{
				seg[0].x1 = x; seg[0].y1 = y;
				seg[0].x2 = x; seg[0].y2 = y + size;
				seg[1].x1 = x - 6; seg[1].y1 = y + size;
				seg[1].x2 = x + 6; seg[1].y2 = y + size;
				seg[2].x1 = x - 2; seg[2].y1 = y + size - 1;
				seg[2].x2 = x - 1; seg[2].y2 = y + size - 2;
				seg[3].x1 = x + 2; seg[3].y1 = y + size - 1;
				seg[3].x2 = x + 1; seg[3].y2 = y + size - 2;

			}
			else
			{
				x -= 1;
				seg[0].x1 = x + size; seg[0].y1 = y;
				seg[0].x2 = x; seg[0].y2 = y;
				seg[1].x1 = x; seg[1].y1 = y - 6;
				seg[1].x2 = x; seg[1].y2 = y + 6;
				seg[2].x1 = x + 1; seg[2].y1 = y - 2;
				seg[2].x2 = x + 2; seg[2].y2 = y - 1;
				seg[3].x1 = x + 1; seg[3].y1 = y + 2;
				seg[3].x2 = x + 2; seg[3].y2 = y + 1;
			}

			if(clear) 
			{
				XDrawSegments(viewport->resource.dpy, viewport->resource.wind, viewport->resource.reverse_gc[0], seg, 4);
				viewport->cursor.Shown = False;	
			}	
			else 
			{
				XDrawSegments(viewport->resource.dpy, viewport->resource.wind, viewport->resource.gc[0], seg, 4);
				viewport->cursor.Shown = True;	
			}	
		}
	}
}

void CurFlash(viewport, id)
VIewportdata *viewport;
XtIntervalId *id;
{
	if(viewport->cursor.Shown) DrawMyCursor(viewport, True);
	else DrawMyCursor(viewport, False);

	viewport->cursor.TimerId = XtAppAddTimeOut(XtWidgetToApplicationContext(viewport->resource.WorkArea),
	500, CurFlash, viewport);
}

void HzCurFlash(viewport, id)
VIewportdata *viewport;
XtIntervalId *id;
{
	if(viewport->cursor.Shown) DrawMyCursor(viewport, True);
	else DrawMyCursor(viewport, False);

	HzTimerId = XtAppAddTimeOut(XtWidgetToApplicationContext(viewport->resource.WorkArea),
	500, HzCurFlash, viewport);
}

