/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

void CancelFindCB();
void FindCB();
void ChangeCB();
void ChangeFindCB();
void ChangeAllCB();

FIndPopup findset;

void CreateFinder(parent)
Widget parent;
{
	Widget label;

	Arg args[MAX_ARGS];
	register int n;

	findset.mapped = False;

	findset.PopUpWg = XtCreatePopupShell("Find Window", transientShellWidgetClass, parent, NULL, 0);

	n = 0;
	XtSetArg(args[n], XmNheight, 170); n++;
	XtSetArg(args[n], XmNwidth, 360); n++;
	XtSetArg(args[n], XmNhorizontalSpacing, 0); n++;
	XtSetArg(args[n], XmNverticalSpacing, 0); n++;
	XtSetArg(args[n], XmNrubberPositioning, True); n++;
	findset.Root = XmCreateForm(findset.PopUpWg, "FindSet", args, n);
	XtManageChild(findset.Root);
	XtAddCallback(findset.Root, XmNdestroyCallback, MainDestroyCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Find:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 15); n++;
	label = XmCreateLabelGadget(findset.Root, "Label", args, n);
	XtManageChild(label);
							
	n = 0;
	XtSetArg(args[n], XmNwidth, 330); n++;
	XtSetArg(args[n], XmNheight,23); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 35); n++;
	findset.FindWg = CreateSimpleHzWin(findset.Root, "Text", args, n, &findset.Findviewport);
	XtManageChild(findset.FindWg);
	
	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Change to:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 75); n++;
	label = XmCreateLabelGadget(findset.Root, "Label", args, n);
	XtManageChild(label);

	n = 0;
	XtSetArg(args[n], XmNwidth, 330); n++;
	XtSetArg(args[n], XmNheight,23); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 95); n++;
	findset.ChangeWg = CreateSimpleHzWin(findset.Root, "Text", args, n, &findset.Changeviewport); 
	XtManageChild(findset.ChangeWg);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Find", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 30); n++;
	XtSetArg(args[n], XmNy, 130); n++;
	label = XmCreatePushButtonGadget(findset.Root, "Btn", args, n);
	XtAddCallback(label, XmNactivateCallback, FindCB, NULL);
	XtManageChild(label);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Change", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNy, 130); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	label = XmCreatePushButtonGadget(findset.Root, "Btn", args, n);
	XtAddCallback(label, XmNactivateCallback, ChangeCB, NULL);
	XtManageChild(label);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Change & Find", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNy, 130); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	label = XmCreatePushButtonGadget(findset.Root, "Btn", args, n);
	XtAddCallback(label, XmNactivateCallback, ChangeFindCB, NULL);
	XtManageChild(label);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Change All", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNy, 130); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	label = XmCreatePushButtonGadget(findset.Root, "Btn", args, n);
	XtAddCallback(label, XmNactivateCallback, ChangeAllCB, NULL);
	XtManageChild(label);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Cancel", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNy, 130); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	label = XmCreatePushButtonGadget(findset.Root, "Btn", args, n);
	XtAddCallback(label, XmNactivateCallback, CancelFindCB, NULL);
	XtManageChild(label);

	XtRealizeWidget(findset.PopUpWg);

	AddSHwCallbacks(&findset.Changeviewport);
	AddSHwCallbacks(&findset.Findviewport);
}

void SetFindString(viewport)
VIewportdata *viewport;
{
	if(viewport->cursor.StartCurPtr != viewport->cursor.EndCurPtr)
	{
		unsigned short *DBprt, chmem;
		int count;

		count = (int)(viewport->cursor.EndCurPtr - viewport->cursor.StartCurPtr);

		chmem = *viewport->cursor.EndCurPtr;
		*viewport->cursor.EndCurPtr = '\0';

		DBprt = (unsigned short *)DBdup(viewport->cursor.StartCurPtr);

		*viewport->cursor.EndCurPtr = chmem;

		count -= rmtypedcomponent(DBprt, DBprt + count, UnderLineMask | SizeMask | FontMask | ColumnMask | AlignmentMask | ColorMask);

		if(count >= SHZW_MEM_UNIT) count = SHZW_MEM_UNIT - 1;

		DBcpy(findset.Findviewport.EditFile, DBprt, count);

		*(findset.Findviewport.EditFile + count + 1) = '\0';

		free(DBprt);

		if(findset.mapped) DrawSimpleHzWin(&(findset.Findviewport), TRUEDRAW);
	}
}

void FindPopupCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	SetFindString(client_data);
	
	if(findset.mapped) 
	{
		
		XRaiseWindow(XtDisplay(findset.PopUpWg), XtWindow(findset.PopUpWg));
		return;
	}

	active_viewport = (VIewportdata *)client_data;
	
	findset.mapped = True;
	findset.startedfind = False;

	PopupPosition(active_viewport->resource.PopUpShell, findset.PopUpWg);
	XtPopup(findset.PopUpWg, XtGrabNone); 
}

int MyFind(id)
int id;
{
	
	VIewportdata *viewport;
	unsigned short *tpt, *cp, *mpt;
	int match, cleardraw;

	if(active_viewport == NULL) { ErrorPopup("No Insertion Point!"); return(False); }

	if(*findset.Findviewport.EditFile == '\0') { ErrorPopup("Nothing To Find!"); return(False); }
	
	viewport = active_viewport;

	mpt = findset.Findviewport.EditFile;
	match = False;
	
	cp = viewport->cursor.StartCurPtr;
	
	if(findset.startedfind)
	{
		cp++;
	}
	else
	{
		if(viewport->cursor.StartCurPtr != viewport->cursor.EndCurPtr)
		{	
			findset.startpoint = viewport->cursor.EndCurPtr;
			findset.startedfind = 2;
		}
		else
		{
			findset.startpoint = viewport->cursor.StartCurPtr;
			findset.startedfind = 1;
		}
		
		viewport->cursor.Mohzdata = viewport->cursor.hzdata;
		viewport->cursor.MoveColNum = viewport->cursor.ColNum;
		viewport->cursor.MoveLineAlignment = viewport->cursor.LineAlignment;
		viewport->cursor.MoveColorNum = viewport->cursor.ColorNum;	
		viewport->cursor.MoveUnderLine = viewport->cursor.UnderLine;
	}

	if(viewport->cursor.StartCurPtr != viewport->cursor.EndCurPtr)
	{
		if(id) MyDrawPage(viewport, UNHIGHLITE);
		viewport->cursor.StartCurPtr = viewport->cursor.EndCurPtr = viewport->cursor.MoveCurPtr = viewport->cursor.CurPtr;
	}
	
	if(findset.startpoint <= viewport->cursor.StartCurPtr && findset.startedfind == 1)
	{
		for(; *cp != '\0'; cp++)
		{
			if(*cp == *mpt)
			{
				tpt = cp;

				while(*tpt == *mpt)
				{
					tpt++;
					mpt++;
	
					if(*mpt == '\0') { match = True; break; }
					if(*tpt == '\0') break;
				}

				if(match) break;
				mpt = findset.Findviewport.EditFile;
			}
		}

		if(*cp == '\0') cp = viewport->EditFile;
	
	}

	if(!match)
	{
		for(; cp < findset.startpoint; cp++)
		{
			if(*cp == *mpt)
			{
				tpt = cp;       
				
				while(*tpt == *mpt)
				{
					tpt++;
					mpt++;
					
					if(*mpt == '\0') { match = True; break; }
					if(*tpt == '\0') break;
				}
				
				if(match) break;
				mpt = findset.Findviewport.EditFile;
			}
		}
	}
	
	if(!match) { ErrorPopup("No More Match!"); return(False); }
	
	viewport->cursor.StartCurPtr = viewport->cursor.CurPtr = cp;
	viewport->cursor.EndCurPtr = viewport->cursor.MoveCurPtr = tpt;

	if(id)
	{
		cleardraw = CheckCurrentPage(viewport);

		MyDrawPage(viewport, REVCURSEARCH);

		if(viewport->pointer.Pointer_x < 0)
		{
			viewport->viewp.ViewPort_x += viewport->pointer.Pointer_x - viewport->viewp.ViewPortWidth / 4;
			cleardraw = True;	
		}

		if(viewport->pointer.Pointer_x > viewport->viewp.ViewPortWidth * 15 / 16)
		{
			viewport->viewp.ViewPort_x += viewport->pointer.Pointer_x - viewport->viewp.ViewPortWidth / 4;
			cleardraw = True;	
		}

		if(viewport->pointer.Pointer_y < 0)
		{
			viewport->viewp.ViewPort_y += viewport->pointer.Pointer_y - 2000;
			cleardraw = True;	
		}

		if(viewport->pointer.Pointer_y > viewport->viewp.ViewPortHeight - viewport->draw.LineHeight)
		{
			viewport->viewp.ViewPort_y += viewport->pointer.Pointer_y - 2000 - viewport->draw.LineHeight; 
			cleardraw = True;	
		}

		if(viewport->viewp.ViewPort_x < 0) { viewport->viewp.ViewPort_x = 0; cleardraw = True; }
		else 
		if(viewport->viewp.ViewPort_x > viewport->page.PageWidth - viewport->viewp.ViewPortWidth)
		{
			if(viewport->page.PageWidth - viewport->viewp.ViewPortWidth > 0)
			{
				viewport->viewp.ViewPort_x = viewport->page.PageWidth - viewport->viewp.ViewPortWidth;
			}
			else
			{
				viewport->viewp.ViewPort_x = 0;
			}
		}	

		if(viewport->viewp.ViewPort_y < 0) { viewport->viewp.ViewPort_y = 0; cleardraw = True; }

		if(cleardraw) MyDrawPage(viewport, CLEARDRAW);
		else MyDrawPage(viewport, ONLYHILITE);
	}

	return(True);
}

int MyChange(id)
int id;
{
	
	VIewportdata *viewport;
	unsigned short *tpt, *cp, *mpt;
	int match, cleardraw;

	if(active_viewport == NULL) { ErrorPopup("No Insertion Point!"); return(True); }

	viewport = active_viewport;

	if(viewport->cursor.StartCurPtr == viewport->cursor.EndCurPtr) { ErrorPopup("No Selection!"); return(True); }

	viewport->cursor.Mohzdata = viewport->cursor.hzdata;
	viewport->cursor.MoveColNum = viewport->cursor.ColNum;
	viewport->cursor.MoveLineAlignment = viewport->cursor.LineAlignment;
	viewport->cursor.MoveColorNum = viewport->cursor.ColorNum;
	viewport->cursor.MoveUnderLine = viewport->cursor.UnderLine;

	if(id)
	{
		viewport->cursor.RedrawCurPtr = viewport->cursor.CurPtr;
		
		if(*findset.Changeviewport.EditFile == '\0')
			MyDrawPage(viewport, Input(viewport, VIRINPUT, delID, 1));
		else
			MyDrawPage(viewport, Input(viewport, VIRINPUT, findset.Changeviewport.EditFile, DBlen(findset.Changeviewport.EditFile)));
	
		MyDrawPage(viewport, INVIRDRAW);
	}
	else
	{
		if(*findset.Changeviewport.EditFile == '\0')
			Input(viewport, VIRINPUT, delID, 1);
		else
			Input(viewport, VIRINPUT, findset.Changeviewport.EditFile, DBlen(findset.Changeviewport.EditFile));
	}

	if(findset.startedfind == 2)
	{
		if(*findset.Changeviewport.EditFile == '\0') findset.startpoint -= DBlen(findset.Findviewport.EditFile);
		else findset.startpoint += DBlen(findset.Changeviewport.EditFile) - DBlen(findset.Findviewport.EditFile);
	}

	viewport->cursor.StartCurPtr--;
	
	if(viewport->cursor.StartCurPtr < viewport->EditFile) viewport->cursor.StartCurPtr = viewport->EditFile;
	
	return(False);
}

void FindCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	int i;
	
	BusyWindows();
	MyFind(True);
	UnBusyWindows();
}

void ChangeCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	BusyWindows();
	MyChange(True);
	UnBusyWindows();
}

void ChangeFindCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	int i;

	BusyWindows();
	
	if(MyChange(True)) { UnBusyWindows(); return; }
	
	MyFind(True);
	UnBusyWindows();
}

void SureChangeAllCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	VIewportdata *viewport;
	
	if(active_viewport == NULL) { ErrorPopup("No Insertion Point!"); return; }
	
	viewport = active_viewport;

	BusyWindows();

	if(findset.startedfind != False && viewport->cursor.StartCurPtr != viewport->cursor.EndCurPtr) MyChange(False);

	if(!MyFind(False)) { UnBusyWindows(); return; }

	MyChange(False);

	while(MyFind(False)) MyChange(False);

	viewport->cursor.CurPtr = findset.startpoint;	
	
	MyDrawPage(viewport, VIRDRAW);
	CheckCurrentPage(viewport);
	MyDrawPage(viewport, CLEARDRAW);

	UnBusyWindows();
}

void ChangeAllCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	YESdoNOreturn(SureChangeAllCB, NULL, "Sure to do it?");
}

void CancelFindCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	findset.mapped = False;
	simple_active = False;
	active_simphzwin = NULL;
	XtPopdown(findset.PopUpWg);
}

