/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower 1.0
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#ifndef _MYXMFONT_H_
#define _MYXMFONT_H_

#include        "hbf.h"

#define HBFONT 1
#define TTFONT 2

typedef struct
{
	int ehcharpointsize;
	int ewcharpointsize;
	float ehinsertpoint;
	float ewinsertpoint;
	int hcharpointsize;
	int wcharpointsize;
	float hinsertpoint;
	float winsertpoint;
	int hz_width;
	int hz_height;
	int hz_swidth;
	int hz_sheight;
	int point_width;
	int point_height;
	int orighz_swidth;
	int orighz_sheight;
	char *FontId;
	int FontType;
	HBF *hbf;
} HZdata;

typedef struct MYFONTLIST
{
	HBF *Hbf;                       /* start position */
	char *FontId;
	char *FontName;
	int FontType;
	struct MYFONTLIST *Next;
}MYfontlist;

#endif /*_MYXMFONT_H_*/
