/* 
 * xvps.c - Postscript dialog box, file output functions
 *
 * callable functions:
 *
 *   CreatePSD(geom)           -  creates the psW window.  Doesn't map it.
 *   PSDialog()                -  maps psW
 *   PSCheckEvent(event)       -  called by event handler
 *   PSSaveParams(str,int)     -  tells PSDialog what to do when 'Ok' clicked
 *   PSResize()                -  called whenever ePic changes size
 *   LoadPS()                  -  attempts to load PS files using Ghostscript
 */

/***************************************************/
XImage *GetPicPSImage(theDisp, theVisual, pic, pictype, wide, high, rmap, gmap, bmap)
Display *theDisp;
Visual *theVisual;
byte          *pic, *rmap, *gmap, *bmap;
unsigned int   wide, high;
int pictype;
{
	/*
	 * this has to do the tricky bit of converting the data in 'pic8'
	 * into something usable for X.
	 *
	 */

	XImage *xim = NULL;
	byte  *imagedata = NULL;

	/* special case: 1-bit display */

	xim = XCreateImage(theDisp, theVisual, 1, XYBitmap, 0, NULL, 
		       wide, high, 8, 0);

/*	if (!xim) FatalError("couldn't create xim!");
*/
	imagedata = (byte *) malloc((size_t) (xim->bytes_per_line * high));

/*	if (!imagedata) FatalError("couldn't malloc imagedata");
*/
	xim->data = (char *) imagedata;
	xim->bitmap_bit_order = 0;
	
	floydDitherize(xim, pic, pictype, (int) wide, (int) high, rmap, gmap, bmap);

	return xim;
}

void PictureToPS(viewport, graph)
VIewport *viewport;
GRaphe *graph;
FILE *fp;
{
	XImage *ximage = NULL;
	byte *tp, *end;
	
	ximage = GetPicPSImage(viewport->resource.dpy,
		      DefaultVisual(viewport->resource.dpy, DefaultScreen(viewport->resource.dpy)),
		      graph->pic, graph->picType, graph->w, graph->h, graph->r, graph->g, graph->b);

	tp = ximage->data;

	end = tp + (ximage->bytes_per_line * graph->h);

	fprintf(fp,"[%d 0 0 %d 0 %d]\n\n", graph->w, -graph->h, graph->h);

    	fprintf(fp,"{currentfile pix readhexstring pop}\n");
    	fprintf(fp,"image\n");

	for(; tp < end; tp++)
	{
		fprintf(psfile.fp, "%02x", *tp);
	}

	free(ximage->data);
	XFree(ximage);
}

