/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include 	"chpower.h"
int HBFGetBitmap();

#define myENTER 	0x00
#define myIDS 		0x01

int CriticalGoing = False;

void DrawPicture(dpy, wind, gc, x, y, curgra)
Display *dpy;
Drawable wind;
GC gc;
int x, y;
GRaphe *curgra;
{
	XPutImage(dpy, wind, gc, curgra->Image, 0, 0, x, y, curgra->curW, curgra->curH); 
}

void TitlerPsWrite(viewport, hzdata, text, colornum, underline, start_x, start_y)
VIewportdata *viewport;
HZdata *hzdata;
unsigned short *text;
int colornum, underline;
int start_x, start_y;
{
	unsigned short *cp;
	int i;
	int Global_Ps_English;
        
	if(printset.ColorPS)
	{
		XGCValues gc_value;
		XColor color;

		XGetGCValues(viewport->resource.dpy,
		             viewport->resource.gc[colornum], 
			     GCForeground, &gc_value);

		color.pixel = gc_value.foreground;
		XQueryColor(viewport->resource.dpy,
			    DefaultColormap(viewport->resource.dpy,
			    DefaultScreen(viewport->resource.dpy)),
			    &color);

		fprintf(printset.psfile, "%4.2f %4.2f %4.2f C ", (float)color.red/65535.,
		        (float)color.green/65535., (float)color.blue/65535.);
	}
	
	fprintf(printset.psfile, "%d %d M /P {%d} J\n/SZ {%d %d} J\n/TZ {%.1f %.1f} J\nW [%d 0 0 %d 0 0] Z\n/H {%d} J\n/K {%d} J\n",
	start_x, start_y,
	hzdata->point_width,
	hzdata->point_width,
	hzdata->point_height,
	(float)hzdata->point_width/1000,	
	(float)hzdata->point_height/1000,
	hzdata->point_width * 100 / ENGLISHPSPARA,
	hzdata->point_height * 5/4,
	hzdata->point_height/8,
	-hzdata->point_height/8);

	cp = text;

	Global_Ps_English = False;

	while(*cp != '\0')
	{
		if(ISHZ(*cp))
		{
			if(Global_Ps_English) { Global_Ps_English = False; fprintf(printset.psfile, ") S T "); }
			if(hzdata->FontType == TTFONT && !(ttfset.Font[SearchFontList(hzdata->FontId)-1].BitMap))
				fprintf(printset.psfile, "%sx%xdict B %sx%x E X ", hzdata->FontId, *cp, hzdata->FontId, *cp);	
			else fprintf(printset.psfile, "%sx%x X ", hzdata->FontId, *cp);
		}
		else
		{
			if(!Global_Ps_English) { Global_Ps_English = True; fprintf(printset.psfile, "Y ("); }
			if(*cp == '(' || *cp == ')' || *cp == '\\') fprintf(printset.psfile, "\\%c", (char)*cp);
			else if(*cp != '\r') fprintf(printset.psfile, "%c", (char)*cp);
		}

		cp++;
	}

	if(Global_Ps_English) { Global_Ps_English = False; fprintf(printset.psfile, ") S T "); }

	if(underline)
	{
		fprintf(printset.psfile, "%d %d M ", start_x, start_y);
		fprintf(printset.psfile, "%d 0 RS ", DBbytelen(text)*hzdata->point_width/2);
	}	
}

int PsGetPos(viewport, pos, num, width)
VIewportdata *viewport;
int pos, width, num;
{
	switch(pos)
	{
		case LeftAlign:
	
		return(viewport->page.PageMarginWidth);
		
		case CenterAlign:
		
		return(viewport->page.PageMarginWidth + ((viewport->page.PageWidth - 2*viewport->page.PageMarginWidth - (num * width /
		2))/2));
	}

	return(viewport->page.PageWidth - viewport->page.PageMarginWidth - (num * width / 2));
}

void PsWriteFooter(viewport, pagenum)
VIewportdata *viewport;
int pagenum;
{
	int n, y;
	char line[5];
	unsigned short *tmp;

	if(!viewport->pndata.FirstShow && pagenum == 1) return;

	if(viewport->titler.text)
	{
		TitlerPsWrite(viewport, &viewport->titler.hzdata, viewport->titler.text, viewport->titler.ColorNum, viewport->titler.underline,
		PsGetPos(viewport, viewport->titler.Position, (int)DBbytelen(viewport->titler.text), viewport->titler.hzdata.point_width),
		viewport->page.PageHeight - viewport->page.PageMarginHeight * 3/4 - viewport->titler.hzdata.point_height);
	}

	if(viewport->footer.text)
	{
		TitlerPsWrite(viewport, &viewport->footer.hzdata, viewport->footer.text, viewport->footer.ColorNum, viewport->footer.underline, 
		PsGetPos(viewport, viewport->footer.Position, (int)DBbytelen(viewport->footer.text), viewport->footer.hzdata.point_width),
		viewport->page.PageMarginHeight * 3 / 4 - viewport->footer.hzdata.point_height);
	}

	if(viewport->pndata.ShowIt)
	{
		if(!viewport->pndata.FirstShow) pagenum--;
		
		sprintf(line, "%d\0", pagenum);
		
		n = 0;
		if(viewport->pndata.texta) n += DBlen(viewport->pndata.texta);
		if(viewport->pndata.textb) n += DBlen(viewport->pndata.textb);
		n += strlen(line);
	
		tmp = (unsigned short*)malloc((n+1)*sizeof(unsigned short));

		if(tmp)
		{
			*tmp = '\0';

			if(viewport->pndata.textb) DBcat(tmp, viewport->pndata.textb);
			DBstrcat(tmp, line);
			if(viewport->pndata.texta) DBstrcat(tmp, viewport->pndata.texta);

			if(viewport->pndata.Position) y = viewport->page.PageMarginHeight * 3 / 4 - viewport->pndata.hzdata.point_height;
			else y = viewport->page.PageHeight - viewport->page.PageMarginHeight * 3/4 - viewport->pndata.hzdata.point_height;
		
			TitlerPsWrite(viewport, &viewport->pndata.hzdata, tmp, 0, False,
					PsGetPos(viewport, viewport->pndata.Align, n, viewport->pndata.hzdata.point_width), y);
			free(tmp);
		}	
	}
}

void GifClear(viewport)
VIewportdata *viewport;
{
	XFillRectangle(viewport->resource.dpy, gifset.pixmap, viewport->resource.reverse_gc[0], 0, 0, gifset.draw.width, gifset.draw.height);
}

void LeftCurMove(viewport)
VIewportdata *viewport;
{
	viewport->cursor.CurPtr = escbackhead(viewport->cursor.CurPtr);
}

void RightCurMove(viewport)
VIewportdata *viewport;
{
	viewport->cursor.CurPtr = escforehead(viewport->cursor.CurPtr);
}

int CheckLayoutIds(viewport, start, colnum, actionid)
VIewportdata *viewport;
unsigned short **start;
int colnum, actionid;
{
	unsigned short *cp;
	int i;

	cp = *start;
	if(*cp++ == '@' && *cp++ == '[')
	{
		switch(*cp)
		{
			case 'C':
			
			cp++;
			
			if(*cp >= '1' && *cp <= '9' && *(cp+1) == ']')
			{
				(*start) += 5;
				
				if(colnum != (*cp - '0')) 
				{
					viewport->layout.ColNum = *cp - '0';
					return(*cp - '0');
				}
				else 
				{
					if(actionid) return(0);
					else return(-1);
				}	
			}	
			(*start)++;	
			break;	
	
			case 'A':

			cp++;

			if(*cp >= '0' && *cp <= '2' && *(cp+1) == ']')
			{
				(*start) += 5;
				
				if(viewport->layout.LineAlignment != *cp - '0') 
				{
					viewport->layout.LineAlignment = *cp - '0';
					return(-1);
				}
				else 
				{
					if(actionid) return(0);
					else return(-1);

				}
			}

			cp--;

			case 'U':
			case 'G':

			break;

			default:
			if(*cp <= 'Y' && *cp >= 'A')
			{
				for(cp = *start, i = 0; *cp != ']' && i < MAXIDNUM; cp++, i++);
				if(i >= MAXIDNUM) (*start)++;
				else *start = cp + 1;
			}	
			break;
		}
	}
	return 0;
}

void FontCalc(w,hzdata, zoom)
Widget w;
HZdata *hzdata;
int zoom;
{
	hzdata->orighz_swidth = XmConvertUnits(w, XmHORIZONTAL, Xm100TH_POINTS, hzdata->point_width, XmPIXELS);
	hzdata->orighz_sheight = XmConvertUnits(w, XmVERTICAL, Xm100TH_POINTS, hzdata->point_height, XmPIXELS);
	
	HzDataZoom(hzdata, zoom);
}

void MyDrawCharacter(dpy, wind, gc, x, y, s, hzdata, englishver)
Display *dpy;
Drawable wind;
GC gc;
int x, y, englishver;
HZdata *hzdata;
unsigned short s;
{
	static unsigned char font[100*800];
	static BOOL ok;
	static XImage *myfont;
	static hz_sheight, hz_swidth;
	static i;

	if(hzdata->hbf == NULL) return;

	if(hzdata->hz_sheight >= 800 || hzdata->hz_swidth >= 800)
	{
		XFillRectangle(dpy, wind, gc, x, y, hzdata->hz_swidth, hzdata->hz_sheight);
		return;
	}

	hz_sheight = hzdata->hz_sheight;

	if ISHZ(s)
	{
		hz_swidth = hzdata->hz_swidth;
	}
	else
	{
		if(englishver)
		{
			hz_swidth = hzdata->hz_swidth / 2;
		}
		else
		{
			hz_swidth = hz_sheight;
			hz_sheight = hzdata->hz_swidth / 2;
		}
	}

	myfont = XCreateImage(dpy, DefaultVisual(dpy, DefaultScreen(dpy)), 1, XYBitmap, 0, (char *)font, hz_swidth, hz_sheight, 8, 0);

	if(myfont == NULL) return;
	
	if ISHZ(s)
	{
		if(hzdata->FontType == HBFONT)
		{
			ok = HBFGetBitmap(hzdata, font, s, myfont->bitmap_bit_order, englishver);
		}
		else
		{
			ok = TTF_GetBitmap(hzdata, font, s, myfont->bitmap_bit_order);
		}
	}
	else
	{
		switch(s)
		{
			case '\t': 
			
			ok = HBFGetBitmap(hzdata, font, ' ', myfont->bitmap_bit_order, englishver);	
	    		break;

			case '\0':

			ok = HBFGetBitmap(hzdata, font, 0xb6, myfont->bitmap_bit_order, englishver);
			break;

	     		case 0x01:

			ok = HBFGetBitmap(hzdata, font, 0xa7, myfont->bitmap_bit_order, englishver);
			break;

			default:
			
			ok = HBFGetBitmap(hzdata, font, s, myfont->bitmap_bit_order, englishver);
		}
	}


	if(s != '\t') XPutImage(dpy, wind, gc, myfont, 0, 0, x, y, hz_swidth, hz_sheight);
	else
	{
		for(i = 0; i < TAB_SIZE * 2; i++) 
		{
			if(englishver) XPutImage(dpy, wind, gc, myfont, 0, 0, x + i * hz_swidth, y, hz_swidth, hz_sheight);	
			else XPutImage(dpy, wind, gc, myfont, 0, 0, x, y + i * hz_sheight, hz_swidth, hz_sheight);
		}
	}

	XFree(myfont);	
}

int HBFGetBitmap(hzdata, font, s, byte_order, englishver)
HZdata *hzdata;
unsigned char *font;
unsigned short s;
int byte_order, englishver;
{
	static unsigned char mask_LSB[]={0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80};
	static unsigned char mask_MSB[]={0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};

	static unsigned char *mask, image[12*96];
	static unsigned char *prt;
	static int c, i, k, numbyte, numbyteatrow, rowadjust, coladjust, row, col, subrowinc, subcolinc;
	static int subrow, subcol, rowcount, torow, colcount, tocol;
	static float left_row, left_col;
	static unsigned char w;
	static BOOL ok;
	static hz_sheight, hz_swidth, hz_height, hz_width;
	static int hcharpointsize;
	static int wcharpointsize;
	static float hinsertpoint;
	static float winsertpoint;

	hz_sheight = hzdata->hz_sheight;

	if(byte_order == MSBFirst)
	{
		mask = mask_MSB;
	}
	else
	{
		mask = mask_LSB;
	}

	if ISHZ(s)
	{
		hz_swidth = hzdata->hz_swidth;

		hz_width = hzdata->hz_width;
		hz_height = hzdata->hz_height;
		hcharpointsize = hzdata->hcharpointsize;
		wcharpointsize = hzdata->wcharpointsize;
		hinsertpoint = hzdata->hinsertpoint;
		winsertpoint = hzdata->winsertpoint;

		ok = (HBF_GetBitmap(hzdata->hbf, s, image) == 0);
			
		if (!ok)
		{
			ok = (HBF_GetBitmap(hzdata->hbf, GB_SQUARE, image) == 0);
		}
	}
	else
	{			
		ok = (HBF_GetBitmap(EnglishFontHbf, s, image) == 0);

		if(englishver)
		{
			hz_swidth = hzdata->hz_swidth / 2;
			hz_width = ENGLISH_FONT_WIDTH;
			hz_height = ENGLISH_FONT_HEIGHT;
			hcharpointsize = hzdata->ehcharpointsize;
			wcharpointsize = hzdata->ewcharpointsize;
			hinsertpoint = hzdata->ehinsertpoint;
			winsertpoint = hzdata->ewinsertpoint;
		}
		else
		{
			hz_swidth = hz_sheight;
			hz_sheight = hzdata->hz_swidth / 2;
			hz_width = ENGLISH_FONT_HEIGHT;
			hz_height = ENGLISH_FONT_WIDTH;
			hcharpointsize = hzdata->ewcharpointsize;
			wcharpointsize = hzdata->ehcharpointsize;
			hinsertpoint = hzdata->ewinsertpoint;
			winsertpoint = hzdata->ehinsertpoint;

			torow = (ENGLISH_FONT_WIDTH + 7)/8;
			tocol = (ENGLISH_FONT_HEIGHT + 7)/8;
			numbyte = ENGLISH_FONT_HEIGHT * torow;

			memset(font, 0, numbyte);

			for(i = 0; i < ENGLISH_FONT_HEIGHT; i++)
				for(k = 0; k < torow; k++)
				{
					col = (ENGLISH_FONT_HEIGHT - i - 1)%8;

					rowcount = ((ENGLISH_FONT_HEIGHT - i - 1)/8) + (k * 8 * tocol);

					colcount = i * torow + k;

					for(row = 0; row < 8; row++) 
					{
						if(mask_MSB[row] & image[colcount])
							font[rowcount + row * tocol] |= mask_MSB[col];
					}
				}

			memcpy(image, font, numbyte);
		}				
	}

	memset(font, 0, hz_sheight*((hz_swidth + 7)/8));

	if (ok)
	{

		i = 1;
		prt = image;
		left_row = 0.5;
		rowcount = 1;
		torow = 0;
		k = 0;

		for (row = 0; row < hz_height; row++)
		{
			left_row += hinsertpoint;
			left_col = 0;
			tocol = 0;
			colcount = 0;
				
			if((int)left_row > rowcount)
			{
				rowcount++;
				subrowinc = 1;
			}
			else subrowinc = 0;

			rowadjust = hcharpointsize + subrowinc;
			if(rowadjust <= 0) rowadjust = 1;

			for (col = 0; col < hz_width; col++)
			{
				if (k == 0)
				{
					w = *prt;
					prt++;
					k = 8;  /* because there are 8 bits per byte */
				}
			
				left_col += winsertpoint;

				if((int)left_col > colcount)
				{
					colcount++;
					subcolinc = 1;
				}
				else subcolinc = 0;

				coladjust = wcharpointsize + subcolinc;
				if(coladjust <= 0) coladjust = 1;
					
				if (w & 0x80)
				{
					for (subrow = 0; subrow < rowadjust; subrow++)	
					{
						numbyteatrow = (torow+subrow) * ((hz_swidth + 7)/8);

						for (subcol = 0; subcol < coladjust; subcol++)
						{
							numbyte = numbyteatrow + ((tocol+subcol) / 8);
							font[numbyte] = font[numbyte] | mask[(tocol+subcol) % 8];
						}
					}
						
				}
					
				tocol = tocol + wcharpointsize + subcolinc;
				w <<= 1; k--;
			}
			torow = torow + hcharpointsize + subrowinc;                     
		}
	}

	return(ok);
}

int UpDownAroInput(viewport, upheight, downheight) 
VIewportdata *viewport;
int upheight, downheight;
{
	int adjust = 100;

	switch(viewport->cursor.CurActionId)
	{
		case UP:
		if(viewport->horOrder)
		{
			viewport->pointer.Pointer_x = viewport->pointer.DrawCur_x - viewport->viewp.ViewPort_x + 100;
			viewport->pointer.Pointer_y = viewport->cursor.ViewPortCur_y - viewport->viewp.ViewPort_y - upheight + adjust;
			if(viewport->pointer.Pointer_y < 0) 
			{
				DrawMyCursor(viewport, True);
				viewport->pointer.Pointer_y += upheight;	
				PageMoveUp(viewport, (long)upheight);
				MyDrawPage(viewport, TRUEDRAW);
			}
		}
		else
		{
			viewport->pointer.Pointer_y = viewport->cursor.ViewPortCur_x - viewport->viewp.ViewPort_x + upheight + adjust;
			viewport->pointer.Pointer_x = viewport->pointer.DrawCur_x - viewport->viewp.ViewPort_y + 100;

			if(viewport->pointer.Pointer_y > viewport->viewp.ViewPortWidth - upheight)
			{
				DrawMyCursor(viewport, True);
				viewport->pointer.Pointer_y -= upheight;
				PageMoveRight(viewport, (long)upheight);
				MyDrawPage(viewport, TRUEDRAW);
			}
		}	
		break;

		case DOWN:
		if(viewport->horOrder)
		{
			viewport->pointer.Pointer_x = viewport->pointer.DrawCur_x - viewport->viewp.ViewPort_x + 100;
			viewport->pointer.Pointer_y = viewport->cursor.ViewPortCur_y - viewport->viewp.ViewPort_y + downheight + adjust;
			if(viewport->pointer.Pointer_y > viewport->viewp.ViewPortHeight - downheight)
			{
				DrawMyCursor(viewport, True);
				viewport->pointer.Pointer_y -= downheight;
				PageMoveDown(viewport, (long)downheight);
				MyDrawPage(viewport, TRUEDRAW);
			}
		}
		else
		{
			viewport->pointer.Pointer_y = viewport->cursor.ViewPortCur_x - viewport->viewp.ViewPort_x - downheight + adjust;
			viewport->pointer.Pointer_x = viewport->pointer.DrawCur_x - viewport->viewp.ViewPort_y +
100;
			if(viewport->pointer.Pointer_y < 0)
			{
				DrawMyCursor(viewport, True);
				viewport->pointer.Pointer_y += downheight;
				PageMoveLeft(viewport, (long)downheight);
				MyDrawPage(viewport, TRUEDRAW);
			}
		}
		break;
	}

	MyDrawPage(viewport, CURSEARCH);
	if(viewport->cursor.StartCurPtr != viewport->cursor.EndCurPtr) MyDrawPage(viewport, UNHIGHLITE);
	viewport->cursor.MoveCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.StartCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.EndCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.LastStartCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.LastEndCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.Mohzdata = viewport->cursor.hzdata;
	viewport->cursor.MoveColNum = viewport->cursor.ColNum;
	viewport->cursor.MoveLineAlignment = viewport->cursor.LineAlignment;
	viewport->cursor.MoveColorNum = viewport->cursor.ColorNum;
	viewport->cursor.MoveUnderLine = viewport->cursor.UnderLine;
}

void LeftRightAroInput(viewport, drawalso)
VIewportdata *viewport;
int drawalso;
{
	int escout = 1;
	
	switch(viewport->cursor.CurActionId)
	{
		case LEFT:  
			if(viewport->cursor.CurPtr > viewport->EditFile)
			{
				if(viewport->viewp.CurPage->PageStart == viewport->cursor.CurPtr) 
				{
					escout = 0;
					viewport->pointer.Pointer_y = - 2*viewport->page.PageMarginHeight - 2 * viewport->draw.LineHeight;
				}
				LeftCurMove(viewport);
			}
			break;
		case RIGHT:
			if(*viewport->cursor.CurPtr != '\0')
			{
				RightCurMove(viewport);
			}
			break;
	}
	
	if(viewport->cursor.StartCurPtr != viewport->cursor.EndCurPtr) MyDrawPage(viewport, UNHIGHLITE);
	if(escout) MyDrawPage(viewport, REVCURSEARCH);
	viewport->cursor.StartCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.EndCurPtr = viewport->cursor.CurPtr;

	if(viewport->pointer.Pointer_x < 0) 
	{
		PageMoveLeft(viewport, 4*viewport->cursor.hzdata.point_width - viewport->pointer.Pointer_x);
		if(drawalso) MyDrawPage(viewport, TRUEDRAW);
	}
	
	if(viewport->pointer.Pointer_x > viewport->viewp.ViewPortWidth) 
	{
		PageMoveRight(viewport, viewport->pointer.Pointer_x - viewport->viewp.ViewPortWidth +
		4*viewport->cursor.hzdata.point_width);
		if(drawalso) MyDrawPage(viewport, TRUEDRAW);
	}

	if(viewport->pointer.Pointer_y < 0)
	{
		PageMoveUp(viewport, (long)(4*viewport->cursor.hzdata.point_height-viewport->pointer.Pointer_y));
		if(drawalso) MyDrawPage(viewport, TRUEDRAW);
	}

	if(viewport->pointer.Pointer_y > viewport->viewp.ViewPortHeight - viewport->draw.LineHeight) 
	{
		PageMoveDown(viewport, (long)(4*viewport->cursor.hzdata.point_height+viewport->pointer.Pointer_y-viewport->viewp.ViewPortHeight));
		if(drawalso) MyDrawPage(viewport, TRUEDRAW);
	}
	
	viewport->cursor.ViewPortCurPage = viewport->viewp.ViewPortPage;
	viewport->pointer.DrawCur_x =  (viewport->horOrder ? viewport->cursor.ViewPortCur_x : viewport->cursor.ViewPortCur_y); 
	viewport->cursor.MoveCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.StartCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.EndCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.LastStartCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.LastEndCurPtr = viewport->cursor.CurPtr;
	viewport->cursor.Mohzdata = viewport->cursor.hzdata;
	viewport->cursor.MoveColNum = viewport->cursor.ColNum;
	viewport->cursor.MoveLineAlignment = viewport->cursor.LineAlignment;
	viewport->cursor.MoveColorNum = viewport->cursor.ColorNum;
	viewport->cursor.MoveUnderLine = viewport->cursor.UnderLine;
}

void DrawPageLine(viewport, separa)
VIewportdata *viewport;
int separa;
{
	int x, y, n;
	XSegment seg[3];

	if(separa >= viewport->draw.DrawPos_y &&	
	   separa <= viewport->draw.DrawPos_y + viewport->draw.DrawLen_y + viewport->page.PageHeight)
	{
		n = 3;
		x = viewport->page.PageWidth - viewport->viewp.ViewPort_x;
		if(x > viewport->viewp.ViewPortWidth) 
		{
			x = viewport->viewp.ViewPortWidth;
			n = 2;
		}

		y = separa - viewport->page.PageHeight + 1;
		if(y < viewport->draw.DrawPos_y + 1) y = viewport->draw.DrawPos_y;
		
		if(separa < viewport->draw.DrawPos_y + viewport->draw.DrawLen_y)
		{
			x = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (x * viewport->zoom / 100), XmPIXELS);	
			y = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (y * viewport->zoom / 100), XmPIXELS); 
			separa = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (separa * viewport->zoom / 100),
			XmPIXELS);
			seg[0].x1 = 0; seg[0].y1 = separa - 1;
			seg[0].x2 = x; seg[0].y2 = separa - 1;
			seg[1].x1 = 0; seg[1].y1 = separa + 1;
			seg[1].x2 = x; seg[1].y2 = separa + 1;
			seg[2].x1 = x; seg[2].y1 = separa - 1;
			seg[2].x2 = x; seg[2].y2 = y;
			
			XDrawSegments(viewport->resource.dpy, viewport->resource.wind, viewport->resource.gc[0], seg, n);
		}
		else
		{
			x = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (x * viewport->zoom / 100), XmPIXELS);    
			y = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (y * viewport->zoom / 100), XmPIXELS);     
			separa = viewport->draw.DrawPos_y + viewport->draw.DrawLen_y;
			separa = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (separa * viewport->zoom / 100),
			XmPIXELS);     
			seg[0].x1 = x; seg[0].y1 = separa;
			seg[0].x2 = x; seg[0].y2 = y;
			if(n == 3) XDrawSegments(viewport->resource.dpy, viewport->resource.wind, viewport->resource.gc[0], seg, 1);
		}
	}
}

void DrawSinMarginLine(viewport, start_y, end_y, start_x, end_x)
VIewportdata *viewport;
int start_y, end_y, start_x, end_x;
{
	int n, colnum;
	XSegment seg[4];

		
	if(end_y >= viewport->draw.DrawPos_y &&
	   start_y <= viewport->draw.DrawPos_y + viewport->draw.DrawLen_y &&
	   start_x <= viewport->draw.DrawPos_x + viewport->draw.DrawLen_x &&
	   end_x >= viewport->draw.DrawPos_x)
	{
		n = 0;

		if(start_y >= 0)
		{
			seg[n].y1 = seg[n].y2 = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (start_y * viewport->zoom
			/ 100), XmPIXELS);
			
			if(start_x <= 0) seg[n].x1 = 0;
			else seg[n].x1 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (start_x *
			viewport->zoom / 100), XmPIXELS);

			if(end_x < viewport->viewp.ViewPortWidth) seg[n].x2 = XmConvertUnits(viewport->resource.WorkArea,
			XmHORIZONTAL, Xm100TH_POINTS, (end_x * viewport->zoom/100), XmPIXELS);
			else seg[n].x2 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS,
			(viewport->viewp.ViewPortWidth * viewport->zoom/100), XmPIXELS) + 1;

			n++;	
		}
	
		if(end_x <= viewport->viewp.ViewPortWidth)
		{
			seg[n].x1 = seg[n].x2 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (end_x * viewport->zoom
			/ 100), XmPIXELS);
			
			if(start_y <= 0) seg[n].y1 = 0;
			else seg[n].y1 = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (start_y *
			viewport->zoom / 100), XmPIXELS);

			if(end_y < viewport->viewp.ViewPortHeight) seg[n].y2 = XmConvertUnits(viewport->resource.WorkArea,
			XmVERTICAL, Xm100TH_POINTS, (end_y * viewport->zoom/100), XmPIXELS);
			else seg[n].y2 = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS,
			(viewport->viewp.ViewPortHeight * viewport->zoom/100), XmPIXELS) + 1;

			n++;	
		}
	
		if(end_y <= viewport->viewp.ViewPortHeight)
		{
			seg[n].y1 = seg[n].y2 = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (end_y * viewport->zoom
			/ 100), XmPIXELS);
			
			if(start_x <= 0) seg[n].x1 = 0;
			else seg[n].x1 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (start_x *
			viewport->zoom / 100), XmPIXELS);

			if(end_x < viewport->viewp.ViewPortWidth) seg[n].x2 = XmConvertUnits(viewport->resource.WorkArea,
			XmHORIZONTAL, Xm100TH_POINTS, (end_x * viewport->zoom/100), XmPIXELS);
			else seg[n].x2 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS,
			(viewport->viewp.ViewPortWidth * viewport->zoom/100), XmPIXELS) + 1;

			n++;	
		}
	
		if(start_x >= 0)
		{
			seg[n].x1 = seg[n].x2 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (start_x * viewport->zoom
			/ 100), XmPIXELS);
			
			if(start_y <= 0) seg[n].y1 = 0;
			else seg[n].y1 = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (start_y *
			viewport->zoom / 100), XmPIXELS);

			if(end_y < viewport->viewp.ViewPortHeight) seg[n].y2 = XmConvertUnits(viewport->resource.WorkArea,
			XmVERTICAL, Xm100TH_POINTS, (end_y * viewport->zoom/100), XmPIXELS);
			else seg[n].y2 = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS,
			(viewport->viewp.ViewPortHeight * viewport->zoom/100), XmPIXELS) + 1;

			n++;	
		}
		
		XDrawSegments(viewport->resource.dpy, viewport->resource.wind, viewport->resource.dash_gc, seg, n);
	}
}

void DrawMarginLine(viewport, start, end, first, width)
VIewportdata *viewport;
int start, end, first, width;
{
	int i;

	for(i = 0; i < viewport->layout.ColNum; i++)
	{
		if(viewport->horOrder) DrawSinMarginLine(viewport, start, end, first, first + width);
		else DrawSinMarginLine(viewport, first, first + width, start, end);
		first += width + viewport->page.PageColSpacing;
	}
}
 
void DrawPageFooter(viewport, pagenumline, pagenum, actionid)
VIewportdata *viewport;
int pagenumline, pagenum, actionid;
{
        int x, y, n,draw_x, draw_y, i;
	unsigned short *cp, *tmp;
	char line[7];
	Window  wind;
	XSegment seg[1];

	if(!viewport->pndata.FirstShow && pagenum == 1) return;

	if(actionid != GIFPAGEDRAW) wind = viewport->resource.wind;
	else wind = gifset.pixmap;

	y = pagenumline - viewport->page.PageHeight + (viewport->page.PageMarginHeight * 3/4);

	if(y > viewport->draw.DrawPos_y - viewport->titler.hzdata.point_height &&
	   y < viewport->draw.DrawPos_y + viewport->draw.DrawLen_y || actionid == GIFPAGEDRAW)
	{
		if(viewport->titler.text)
		{
			n = DBbytelen(viewport->titler.text);
			x = PsGetPos(viewport, viewport->titler.Position, n, viewport->titler.hzdata.point_width);
			if(actionid != GIFPAGEDRAW) x -= viewport->viewp.ViewPort_x;
			n = -(n * viewport->titler.hzdata.point_width / 2);

			if(x >= n && x <= viewport->viewp.ViewPortWidth || actionid == GIFPAGEDRAW)
			{
				draw_y = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (y * viewport->zoom / 100),
				XmPIXELS);

				cp = viewport->titler.text;
				draw_x = x;

				while(*cp != '\0')
				{
					MyDrawCharacter(viewport->resource.dpy,
							wind,
							viewport->resource.gc[viewport->titler.ColorNum],
							XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS,
							(draw_x * viewport->zoom/100), XmPIXELS),
							draw_y,
							*cp,
							&(viewport->titler.hzdata),
							1);
					if(ISHZ(*cp)) 
					{
						draw_x += viewport->titler.hzdata.point_width;
					}
					else 
					{
						draw_x += viewport->titler.hzdata.point_width/2;
					}
					cp++;	
				}	
			
				if(viewport->titler.underline)
				{
					seg[0].x1 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (x *
					viewport->zoom/100), XmPIXELS);
					seg[0].y1 = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, ((y +
					viewport->titler.hzdata.point_height) * viewport->zoom/100), XmPIXELS);
					
					seg[0].x2 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, ((x - n) *
					viewport->zoom/100), XmPIXELS);
					seg[0].y2 = seg[0].y1;
					
					XDrawSegments(viewport->resource.dpy, wind, viewport->resource.gc[viewport->titler.ColorNum], seg, 1);
				}
			}	
		}	
	}

	if(viewport->pndata.Position) y = pagenumline - (viewport->page.PageMarginHeight * 3 / 4);
	else y = pagenumline - viewport->page.PageHeight + (viewport->page.PageMarginHeight * 3/4);
	
	if(viewport->pndata.ShowIt && (y > viewport->draw.DrawPos_y - viewport->pndata.hzdata.point_height &&
	   y < viewport->draw.DrawPos_y + viewport->draw.DrawLen_y || actionid == GIFPAGEDRAW))
	{
		if(!viewport->pndata.FirstShow) pagenum--;

		sprintf(line, "%d\0", pagenum);
		n = 0; 
		i = 0;
		if(viewport->pndata.texta) 
		{
			n = DBbytelen(viewport->pndata.texta);
			i += DBlen(viewport->pndata.texta);

		}
		if(viewport->pndata.textb) 
		{
			n += DBbytelen(viewport->pndata.textb);
			i += DBlen(viewport->pndata.textb);

		}
		n += strlen(line);
		i += strlen(line);

		x = PsGetPos(viewport, viewport->pndata.Align, n, viewport->pndata.hzdata.point_width);
		if(actionid != GIFPAGEDRAW) x -= viewport->viewp.ViewPort_x;
		n = -(n * viewport->pndata.hzdata.point_width / 2);

		if(x >= n && x <= viewport->viewp.ViewPortWidth || actionid == GIFPAGEDRAW)
		{
			draw_y = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (y * viewport->zoom / 100),
			XmPIXELS);
			draw_x = x;	
			tmp = (unsigned short*)malloc((i+1)*sizeof(unsigned short));

			if(tmp)
			{
				*tmp = '\0';

				if(viewport->pndata.textb) DBcat(tmp, viewport->pndata.textb);
				DBstrcat(tmp, line);
				if(viewport->pndata.texta) DBcat(tmp, viewport->pndata.texta);
			
				cp = tmp;
	
				while(*cp != '\0')
				{
					MyDrawCharacter(viewport->resource.dpy,
							wind,
							viewport->resource.gc[viewport->pndata.ColorNum],
							XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS,
							(draw_x * viewport->zoom/100), XmPIXELS),
							draw_y,
							*cp,
							&(viewport->pndata.hzdata), 1);
					if(ISHZ(*cp)) 
					{
						draw_x += viewport->pndata.hzdata.point_width;
					}
					else 
					{
						draw_x += viewport->pndata.hzdata.point_width/2;
					}
					cp++;	
				}
				
				free(tmp);	
			}	
		}	
	}

	y = pagenumline - viewport->page.PageMarginHeight * 3 / 4;

	if(y > viewport->draw.DrawPos_y + viewport->footer.hzdata.point_height &&
	   y < viewport->draw.DrawPos_y + viewport->draw.DrawLen_y || actionid == GIFPAGEDRAW)
	{
		if(viewport->footer.text)
		{
			n = DBbytelen(viewport->footer.text);
			x = PsGetPos(viewport, viewport->footer.Position, n, viewport->footer.hzdata.point_width);
			if(actionid != GIFPAGEDRAW) x -= viewport->viewp.ViewPort_x;
			n = -(n * viewport->footer.hzdata.point_width / 2);

			if(x >= n && x <= viewport->viewp.ViewPortWidth || actionid == GIFPAGEDRAW)
			{
				draw_y = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (y * viewport->zoom / 100),
				XmPIXELS);

				cp = viewport->footer.text;
				draw_x = x;

				while(*cp != '\0')
				{
					MyDrawCharacter(viewport->resource.dpy,
							wind,
							viewport->resource.gc[viewport->footer.ColorNum],
							XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS,
							(draw_x * viewport->zoom/100), XmPIXELS),
							draw_y,
							*cp,
							&(viewport->footer.hzdata), 1);
					if(ISHZ(*cp)) 
					{
						draw_x += viewport->footer.hzdata.point_width;
					}
					else 
					{
						draw_x += viewport->footer.hzdata.point_width/2;
					}
					cp++;	
				}	
				
				if(viewport->footer.underline)
				{
					seg[0].x1 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (x *
					viewport->zoom/100), XmPIXELS);
					seg[0].y1 = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, ((y +
					viewport->footer.hzdata.point_height) * viewport->zoom/100), XmPIXELS);
					
					seg[0].x2 = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, ((x - n) *
					viewport->zoom/100), XmPIXELS);
					seg[0].y2 = seg[0].y1;
					
					XDrawSegments(viewport->resource.dpy, wind, viewport->resource.gc[viewport->footer.ColorNum], seg, 1);
				}
			}	
		}	
	}
}

void MyDrawInputLine(viewport, gc, x, y, cp, numofbyte)
TScreen *viewport;
GC gc;
int x, y, numofbyte;
unsigned char *cp;
{
	int cur_length = 0, charwidth, i;
	unsigned short sample;

	sample = *cp;   
	
	if (*cp > 0xa0)
	{
		charwidth = viewport->hzdata.hz_swidth;
		sample <<= 8;
		sample |= *(cp+1);
	}
	else
	{
		charwidth = viewport->hzdata.hz_swidth/2;
	}

	i = 0;

	while((*cp != '\0') && (i <= numofbyte))
	{
		MyDrawCharacter(viewport->display, 
				viewport->window, 
				gc, 
				x + cur_length,
				y,
				sample,
				&(viewport->hzdata), 1);

		cur_length += charwidth;

		if (*cp > 0xa0)
		{
			cp += 2;
			i += 2;
		}
		else
		{
			cp ++;
			i ++;
		}

		sample = *cp;


		if (*cp > 0xa0)
		{
			charwidth = viewport->hzdata.hz_swidth;
			sample <<= 8;
			sample |= *(cp+1);	
		}	
		else
			charwidth = viewport->hzdata.hz_swidth/2;
		
	}
}


int DrawTextUnderLine(viewport, x, oldx, y, x_pixel, y_pixel, NewUnderLine, actionid, Global_Ps_English)
VIewportdata *viewport;
int x, y, NewUnderLine, oldx, x_pixel, y_pixel, actionid, *Global_Ps_English;
{
	int line_y;
	XSegment seg[1];

	switch(viewport->layout.UnderLine)
	{
		case LINEUNDER:

		line_y = y + (viewport->horOrder ? viewport->draw.LineHeight : 0);
		break;

		case LINEMIDDLE:

		line_y = y + viewport->draw.LineHeight/2;
		break;
	}

	if(viewport->layout.UnderLine && x - oldx >= 3)
	{
		switch(actionid)
		{
			case HIGHLITE:
			case UNHIGHLITE:
			case ONLYHILITE:

			if(!*Global_Ps_English) break;

			case TRUEDRAW:
			case ASIS:

			if(!((viewport->horOrder && 
			  !(x < viewport->draw.DrawPos_x - 1 ||
			   oldx > viewport->draw.DrawPos_x + viewport->draw.DrawLen_x + 1) &&
			   line_y > viewport->draw.DrawPos_y - 1 &&
			   line_y < viewport->draw.DrawPos_y + viewport->draw.DrawLen_y + 1) ||
			   (!viewport->horOrder && !(x < viewport->draw.DrawPos_y - 1 ||
			    oldx > viewport->draw.DrawPos_y + viewport->draw.DrawLen_y + 1 ||
			   line_y < viewport->draw.DrawPos_x - 1 ||
			   line_y > viewport->draw.DrawPos_x + viewport->draw.DrawLen_x + 1))))
				break;

			case GIFPAGEDRAW:

			seg[0].x1 = XmConvertUnits(viewport->resource.WorkArea, CONVERT_X, Xm100TH_POINTS, (oldx * viewport->zoom / 100), XmPIXELS);
			seg[0].y1 = XmConvertUnits(viewport->resource.WorkArea, CONVERT_Y, Xm100TH_POINTS, (line_y * viewport->zoom / 100), XmPIXELS);
			seg[0].x2 = x_pixel;

			if(viewport->horOrder)
			{
				seg[0].y1 -= 2;
				seg[0].y2 = seg[0].y1;
			}
			else
			{
				line_y = seg[0].x1;
				seg[0].x1 = seg[0].y1;
				seg[0].y1 = line_y;
				seg[0].x2 = seg[0].x1;
				seg[0].y2 = y_pixel;
			}

			if(actionid == GIFPAGEDRAW)
				XDrawSegments(viewport->resource.dpy, 
					      gifset.pixmap,
					      viewport->resource.gc[viewport->ColorNum],
					      seg, 1);
			else
				XDrawSegments(viewport->resource.dpy,
						viewport->resource.wind,
						viewport->resource.gc[viewport->ColorNum],
						seg, 1);
			break;

			case PSDRAW:

			if(viewport->horOrder)
			{
				if(*Global_Ps_English) { *Global_Ps_English = False;
							fprintf(printset.psfile, ") S T"); }

				fprintf(printset.psfile, "\n%d %d M %d 0 RS ", 
					oldx + viewport->viewp.ViewPort_x, 
					viewport->page.PageHeight - viewport->viewp.ViewPort_y - line_y,
					x - oldx);

				fprintf(printset.psfile, "%d %d M\n", x + viewport->viewp.ViewPort_x,
					viewport->page.PageHeight - viewport->viewp.ViewPort_y - y - viewport->draw.LineHeight);
			}
			else
			{
				if(*Global_Ps_English) { *Global_Ps_English = False;
							fprintf(printset.psfile, ") VS"); }

				fprintf(printset.psfile, "\n%d %d M 0 %d RS ",
					line_y + viewport->viewp.ViewPort_x,
					viewport->page.PageHeight - viewport->viewp.ViewPort_y - oldx,
					oldx - x);

				fprintf(printset.psfile, "%d %d M\n",
					y + viewport->viewp.ViewPort_x,
					viewport->page.PageHeight - viewport->viewp.ViewPort_y - x);
			}
			break;
		}
	}
	viewport->layout.UnderLine = NewUnderLine;

	return(x);
}

int MyDrawLine(viewport, x, y, textstr, linewidth, actionid, layoutchange, GraphHeight)
VIewportdata *viewport;
int linewidth, x, y, actionid;
unsigned short **textstr;
int *layoutchange, *GraphHeight;
{
	unsigned short *cp, *searchprt, *escaph, chrmem;
	int cur_length = 0, nosize = True, notPic = True, sizechange = False, realtext = False;
	int charwidth, prewidth, i, j, x_disp, y_disp, x_pixel, y_pixel, pic_y_pixel;
	int x_cur_pixel, y_cur_pixel, layoutmet = False, searchid = False;
	int Global_Ps_English = False;
	HZdata hzdata, Curhzdata;
	int ColNum = viewport->layout.ColNum;
	int ColorNum = viewport->ColorNum;
	int CurColorNum = viewport->ColorNum;
	int CurUnderLine = viewport->layout.UnderLine;
	int UnderLine = viewport->layout.UnderLine;
	int UnderLineX = x;
	unsigned short *startcp = *textstr;
	unsigned short *curcp = *textstr;
	int Alin = viewport->layout.LineAlignment;
	int max_height;
	unsigned short mysym;
	unsigned char *sp;
	GRaphe *picPrt;

	cp = *textstr;

	hzdata = viewport->hzdata;
	Curhzdata = viewport->hzdata;

	if(actionid == PSDRAW)
	{
		if(viewport->horOrder)
		{
			fprintf(printset.psfile, "%d %d M\n", x + viewport->viewp.ViewPort_x,
				viewport->page.PageHeight - viewport->viewp.ViewPort_y - y - viewport->draw.LineHeight);
		}
		else 
		{
			fprintf(printset.psfile, "%d %d M\n", y + viewport->viewp.ViewPort_x,
				viewport->page.PageHeight - viewport->viewp.ViewPort_y - x);
		}
	}	

	prewidth = viewport->horOrder ? viewport->hzdata.point_width : viewport->hzdata.point_height;

	if ISHZ(*cp)
	{
		charwidth = (viewport->horOrder ? viewport->hzdata.point_width : viewport->hzdata.point_height) * (100 + viewport->page.CharSpacing) / 100;
		max_height = (viewport->horOrder ? viewport->hzdata.point_height : viewport->hzdata.point_width);
	}
	else
	{
		if(*cp != '\t') charwidth = viewport->hzdata.point_width * (100 + viewport->page.CharSpacing) / 200;
		else	charwidth = viewport->hzdata.point_width * TAB_SIZE * (100 + viewport->page.CharSpacing) / 100;

		max_height = viewport->hzdata.point_height;
	}

	if(!viewport->horOrder && (max_height < viewport->hzdata.point_height || max_height < viewport->hzdata.point_width))
	{
		sizechange = True;
	}
	
	if(viewport->horOrder)
	{
		x_cur_pixel = x + viewport->viewp.ViewPort_x;
		y_cur_pixel = y + viewport->viewp.ViewPort_y;
		y_pixel = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, ((y + viewport->draw.LineHeight - viewport->hzdata.point_height) * viewport->zoom / 100), XmPIXELS);
		x_pixel = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (x * viewport->zoom / 100), XmPIXELS);
	}
	else
	{
		x_cur_pixel = y + viewport->viewp.ViewPort_x;
		y_cur_pixel = x + viewport->viewp.ViewPort_y;
		x_pixel = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (y * viewport->zoom / 100), XmPIXELS);
		y_pixel = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (x * viewport->zoom / 100), XmPIXELS);
	}

	while(*cp != '\0' && *cp != '\n' && ((cur_length <= linewidth - charwidth/2) || (cur_length <= 0) || *cp == '@' || searchid))
	{
		if(*cp == '@')
		{
			searchprt = cp;
			escaph = cp;
			searchprt++;
			if(*searchprt == '[')
			{
				if(!searchid) 
				{
					searchid = True;
					curcp = cp;
				}

				cp += 2;
				if(*cp >= '0' && *cp <= '9')
				{
					for(searchprt = cp, i = 0; *searchprt != '\0' && *searchprt != ']' && i < MAXIDNUM; searchprt++, i++);

					if(i >= MAXIDNUM)
					{
						*textstr = cp;
						continue;
					}

					chrmem = *searchprt;
					*searchprt = '\0';

					sp = DBstrdup(cp);
					if(sscanf(sp, "%d,%d", &i, &j) == 2)
					{
						if(i <= MAX_FONT_SIZE || j <= MAX_FONT_SIZE)
						{
							viewport->hzdata.point_width = i * 100;
							viewport->hzdata.point_height = j * 100;
						}	
					}
					else
					{
						if(i <= MAX_FONT_SIZE)
						{
							viewport->hzdata.point_width = viewport->hzdata.point_height = i * 100;
						}
					}
					free(sp);

					*searchprt = chrmem;
					cp = searchprt + 1;
					*textstr = cp;
					FontCalc(viewport->resource.WorkArea, &viewport->hzdata, viewport->zoom);
					sizechange = True;

					if(nosize && !realtext) 
					{
						if(viewport->horOrder)
						{
							sizechange = False;
							max_height = viewport->hzdata.point_height;
						}
						else
						{
							max_height = viewport->hzdata.point_height;

							if( max_height > viewport->hzdata.point_width)
							{
								max_height =  viewport->hzdata.point_width;
							}
						}

						nosize = False;
					}

					if(actionid == PSDRAW)
					{
						if(Global_Ps_English)
						{
							Global_Ps_English = False;
							if(viewport->horOrder) fprintf(printset.psfile, ") S T");
							else fprintf(printset.psfile, ") VS");
						}

						fprintf(printset.psfile, "\n/P {%d} J\n/F {%d} J\n/SZ {%d %d} J\n/TZ {%.1f %.1f} J\nW [%d 0 0 %d 0 0] Z\n/H {%d} J\n/K {%d} J\n", 
						viewport->hzdata.point_width * (100 + viewport->page.CharSpacing) / 100,
						-viewport->hzdata.point_height * (100 + viewport->page.CharSpacing) / 100,
						viewport->hzdata.point_width, viewport->hzdata.point_height, 
						(float)viewport->hzdata.point_width/1000,	
						(float)viewport->hzdata.point_height/1000,	
						viewport->hzdata.point_width*
						(100 + viewport->page.CharSpacing)/ENGLISHPSPARA, viewport->hzdata.point_height*5/4,
						viewport->hzdata.point_height/8, -viewport->hzdata.point_height/8);
					}	

					if(viewport->horOrder) 
						y_pixel = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, ((y + viewport->draw.LineHeight - viewport->hzdata.point_height) * viewport->zoom / 100), XmPIXELS);

				}
				else if(*cp >= 'a' && *cp <= 'z')
				{
					for(searchprt = cp, i = 0; *searchprt != '\0' && *searchprt != ']' && i < MAXIDNUM; searchprt++, i++);

					if(i >= MAXIDNUM)
					{
						*textstr = cp;
						continue;
					}

					chrmem = *searchprt;
					*searchprt = '\0';
					
					sp = DBstrdup(cp);

					if(SearchFontList(sp)) 
					{
						viewport->hzdata.hbf = GetFontHandle(sp, &viewport->hzdata.FontId,
						&viewport->hzdata.FontType);

						if(viewport->hzdata.FontType == HBFONT) 
							HBF_GetBitmapBoundingBox(viewport->hzdata.hbf, &(viewport->hzdata.hz_width), &(viewport->hzdata.hz_height), &x_disp, &y_disp);
						else viewport->hzdata.hz_width = viewport->hzdata.hz_height = 24;

						FontCalc(viewport->resource.WorkArea, &viewport->hzdata, viewport->zoom);
					}
					free(sp);	
					*searchprt = chrmem; 	
					cp = searchprt + 1;
					*textstr = cp;
				}
				else if(*cp == 'Z')
				{
					cp++;
					searchprt = cp + 1;

					if(*cp >= '0' && *cp <= '6' && *searchprt == ']')
					{
						if(actionid != PSDRAW || printset.ColorPS)
						{
							UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, actionid, &Global_Ps_English);
						}

						viewport->ColorNum = (int)(*cp) - (int)('0');

						if(actionid == PSDRAW && printset.ColorPS)
						{
						        XGCValues gc_value;
							XColor color;

							XGetGCValues(viewport->resource.dpy,
							             viewport->resource.gc[viewport->ColorNum], 
								     GCForeground, &gc_value);

							color.pixel = gc_value.foreground;
							XQueryColor(viewport->resource.dpy,
								    DefaultColormap(viewport->resource.dpy,
								    DefaultScreen(viewport->resource.dpy)),
								    &color);

							if(Global_Ps_English) 
							{
								Global_Ps_English = False;
								if(viewport->horOrder) fprintf(printset.psfile, ") S T");
								else fprintf(printset.psfile, ") VS");
							}

							fprintf(printset.psfile, "\n%4.2f %4.2f %4.2f C\n", (float)color.red/65535.,
							        (float)color.green/65535., (float)color.blue/65535.);
						}
					}

					cp = searchprt + 1;
					*textstr = cp;
				}	
				else if(*cp == 'U')
				{
					cp++;
					searchprt = cp + 1;

					if(*cp >= '0' && *cp <= '2' && *searchprt == ']')
					{
						UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, (int)(*cp) - (int)('0'), actionid, &Global_Ps_English);
					}

					cp = searchprt + 1;
					*textstr = cp;
				}
				else if(*cp == 'G')
				{
					cp++;

					if(*cp != ']' && *cp != '\0')
					{
						for(searchprt = cp, i = 0; *searchprt != '\0' && *searchprt != ']' && i < MAXIDNUM; searchprt++, i++);

						if(i >= MAXIDNUM)
						{
							*textstr = cp;
							continue;
						}

						chrmem = *searchprt;
						*searchprt = '\0';

						sp = DBstrdup(cp);

						*searchprt = chrmem;
						searchprt ++;

						cp = searchprt;

						if(sp)
						{
							picPrt = SearchPicture(viewport, sp);

							if(picPrt && picPrt->Image)
							{
								notPic = False;
								cp = searchprt;

								i = viewport->horOrder ? picPrt->h : picPrt->w;

								i *= PICSCALE;

								if(i > *GraphHeight && !layoutmet) *GraphHeight = i;

								charwidth = viewport->horOrder ? picPrt->w : picPrt->h;
								charwidth *= PICSCALE;	

								if(viewport->horOrder)
								{
									pic_y_pixel = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, ((y + viewport->draw.LineHeight - picPrt->h * PICSCALE ) * viewport->zoom / 100), XmPIXELS);
								}
								else
								{
									pic_y_pixel = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (x + cur_length) * viewport->zoom / 100, XmPIXELS);
								}

								if(picPrt->zoomNum != viewport->zoom)
								{
									graphicsZoom(viewport, picPrt, viewport->zoom);
								}
							}
							free(sp);
						}
					}
					else
					{
						*textstr = cp;
					}
				}
				else
				{												
					cp -= 2;
					i = CheckLayoutIds(viewport, &cp, viewport->layout.ColNum, 1);
					*textstr = cp;
					if(i != 0) layoutmet = True;
					if((*layoutchange == 0 && i != 0) ||
					   (*layoutchange != 0 && i > 0)) *layoutchange = i;
				}
				
				if(notPic)
				{
					if ISHZ(*cp)
						charwidth = (viewport->horOrder ? viewport->hzdata.point_width : viewport->hzdata.point_height) * (100 + viewport->page.CharSpacing) / 100;
					else
						if(*cp != '\t') charwidth = viewport->hzdata.point_width * (100 + viewport->page.CharSpacing) / 200;
						else    charwidth = viewport->hzdata.point_width * TAB_SIZE * (100 + viewport->page.CharSpacing) / 100;
				}

				prewidth = charwidth;

				switch(actionid)
				{
					case SMALLAFF:
					case BIGAFF:
					if(escaph <= viewport->cursor.CurPtr && cp > viewport->cursor.CurPtr) 
					{
						return(-viewport->draw.LineHeight);
					}
					break;
					
			/*		case TRUEDRAW:
			*/		case ASIS:
					if(escaph <= viewport->cursor.CurPtr && cp > viewport->cursor.CurPtr)
					{
						viewport->cursor.CurPtr = escaph;
						viewport->cursor.ViewPortCur_x = x_cur_pixel;
						viewport->cursor.ViewPortCur_y = y_cur_pixel;
						viewport->cursor.hzdata = viewport->hzdata;	
						viewport->cursor.LineHeight = viewport->draw.LineHeight;
						viewport->cursor.ColNum = viewport->layout.ColNum;
						viewport->cursor.LineAlignment = viewport->layout.LineAlignment;
						viewport->cursor.ColorNum = viewport->ColorNum;	
						viewport->cursor.UnderLine = viewport->layout.UnderLine;
					}
					break;

					case REVCURSEARCH:
					if(escaph <= viewport->cursor.CurPtr && cp > viewport->cursor.CurPtr)
					{
						viewport->cursor.CurPtr = escaph;
						DrawMyCursor(viewport, True);
						viewport->pointer.Pointer_x = (viewport->horOrder ? x + cur_length : y);
						viewport->pointer.Pointer_y = (viewport->horOrder ? y : x + cur_length);
						viewport->cursor.ViewPortCur_x = x_cur_pixel;
						viewport->cursor.ViewPortCur_y = y_cur_pixel;
						viewport->cursor.hzdata = viewport->hzdata;
						viewport->cursor.LineHeight = viewport->draw.LineHeight;
						viewport->cursor.ColNum = viewport->layout.ColNum;
						viewport->cursor.LineAlignment = viewport->layout.LineAlignment;
						viewport->cursor.ColorNum = viewport->ColorNum;
						viewport->cursor.UnderLine = viewport->layout.UnderLine;
						RenewCharSet(viewport);
						DrawMyCursor(viewport, False);
						return(0);	
					}
					break;
				}
				if(notPic) continue;
				else cp = escaph;
			}
		}

		if(layoutmet || ((cur_length > linewidth - charwidth/2) && cur_length > 0))
		{
			break;
		}

		realtext = True;
		
		if(searchid)
		{
			Curhzdata = viewport->hzdata;
			CurColorNum = viewport->ColorNum;
			CurUnderLine = viewport->layout.UnderLine;
			searchid = False;
		}

		if(sizechange) 
		{
			if(ISHZ(*cp))
			{
				if(max_height < ((viewport->horOrder) ? viewport->hzdata.point_height : viewport->hzdata.point_width)) 
				{
					max_height = (viewport->horOrder) ? viewport->hzdata.point_height : viewport->hzdata.point_width;
				}
			}
			else
			{
				if(max_height < viewport->hzdata.point_height)
					max_height = viewport->hzdata.point_height;
			}

			if(viewport->horOrder) sizechange = False;
			else
			{
				if(max_height >= viewport->hzdata.point_height && max_height >= viewport->hzdata.point_width)
				{
					sizechange = False;
				}
			}
		}

		switch(actionid)
		{
			case CURSEARCH:
			case MOVESEARCH:
			case SMALLAFF:
			case BIGAFF:
			case HIGHLITE:
			case UNHIGHLITE:
			case ASIS:
			case TRUEDRAW:
			case ONLYHILITE:

			if ((viewport->horOrder && (x + cur_length > viewport->draw.DrawPos_x - prewidth) && 
		  	    (x + cur_length < viewport->draw.DrawPos_x + viewport->draw.DrawLen_x + charwidth) && 
			    (y > viewport->draw.DrawPos_y - viewport->draw.LineHeight) && 
			    (y < viewport->draw.DrawPos_y + viewport->draw.DrawLen_y)) ||
			    (!viewport->horOrder && (x + cur_length > viewport->draw.DrawPos_y - prewidth) &&
			     (x + cur_length < viewport->draw.DrawPos_y + viewport->draw.DrawLen_y + charwidth) &&
			     (y > viewport->draw.DrawPos_x - viewport->draw.LineHeight) &&
			     (y < viewport->draw.DrawPos_x + viewport->draw.DrawLen_x)))
			{
				switch(actionid)
				{
					case CURSEARCH: 
						
						if((viewport->pointer.Pointer_x > x + cur_length) &&
						   (viewport->pointer.Pointer_x <= x + cur_length + charwidth) &&
						   (viewport->pointer.Pointer_y > y) &&
						   (viewport->pointer.Pointer_y <= y + viewport->draw.LineHeight))
						{
							DrawMyCursor(viewport, True);
							viewport->cursor.ViewPortCur_x = x_cur_pixel;
							viewport->cursor.ViewPortCur_y = y_cur_pixel;
							viewport->cursor.ViewPortCurPage = viewport->viewp.ViewPortPage;
							viewport->cursor.CurPtr = cp;
							viewport->cursor.hzdata = viewport->hzdata;	
							viewport->cursor.LineHeight = viewport->draw.LineHeight;       
							viewport->cursor.ColNum = viewport->layout.ColNum;
							viewport->cursor.LineAlignment = viewport->layout.LineAlignment;       
							viewport->cursor.ColorNum = viewport->ColorNum;	
							viewport->cursor.UnderLine = viewport->layout.UnderLine;
							RenewCharSet(viewport);
							DrawMyCursor(viewport, False);
							return(0);
						}
						break;

					case MOVESEARCH: 
						
						if((viewport->pointer.MovePo_x > x + cur_length) &&
						   (viewport->pointer.MovePo_x <= x + cur_length + charwidth) &&
						   (viewport->pointer.MovePo_y > y) &&
						   (viewport->pointer.MovePo_y <= y + viewport->draw.LineHeight))
						{
							viewport->cursor.MoveCur_x = x_cur_pixel;
							viewport->cursor.MoveCur_y = y_cur_pixel;
							viewport->cursor.MoveCurPage = viewport->viewp.ViewPortPage;
							viewport->cursor.MoveCurPtr = cp;
							viewport->cursor.Mohzdata = viewport->hzdata;
							viewport->cursor.MoveColNum = viewport->layout.ColNum;
							viewport->cursor.MoveLineAlignment = viewport->layout.LineAlignment;       
							viewport->cursor.MoveColorNum = viewport->ColorNum;
							viewport->cursor.MoveUnderLine = viewport->layout.UnderLine;
							return(0);
						}
						break;
					
					case SMALLAFF:
					case BIGAFF:
					
						if(cp == viewport->cursor.CurPtr || cp == (viewport->cursor.CurPtr + 1)) 
						{
							return(-viewport->draw.LineHeight);
						}
						break;
					
					case HIGHLITE:
						
						if(viewport->cursor.LastStartCurPtr == viewport->cursor.StartCurPtr)
						{
							if(viewport->cursor.LastEndCurPtr > viewport->cursor.EndCurPtr)
							{
								if(cp >= viewport->cursor.EndCurPtr && cp < viewport->cursor.LastEndCurPtr)
								{
									Global_Ps_English = True;
									if(notPic)
										MyDrawCharacter(viewport->resource.dpy,
											viewport->resource.wind,
											viewport->resource.gc[viewport->ColorNum],
											x_pixel,
											y_pixel,
											*cp,
											&(viewport->hzdata),
											viewport->horOrder);
									else
										DrawPicture(viewport->resource.dpy,
											viewport->resource.wind,
											viewport->resource.gc[viewport->ColorNum],
											x_pixel,
											pic_y_pixel,
											picPrt);
								}
								else if(cp >= viewport->cursor.LastEndCurPtr) 
								{
									UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
									return(0);	
								}
							}
							else if(cp >= viewport->cursor.LastEndCurPtr && cp < viewport->cursor.EndCurPtr)
							{
								Global_Ps_English = True;
								if(notPic)
									MyDrawCharacter(viewport->resource.dpy,
										viewport->resource.wind,
										viewport->resource.reverse_gc[viewport->ColorNum],
										x_pixel,
										y_pixel,
										*cp,
										&(viewport->hzdata),
										viewport->horOrder);
								else
									DrawPicture(viewport->resource.dpy,
										viewport->resource.wind,
										viewport->resource.reverse_gc[viewport->ColorNum],
										x_pixel,
										pic_y_pixel,
										picPrt);
							}
							else if(cp >= viewport->cursor.EndCurPtr) 
							{
								UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
								return(0);
							}
						}
						else if(viewport->cursor.LastEndCurPtr == viewport->cursor.EndCurPtr)
						{
							if(viewport->cursor.LastStartCurPtr < viewport->cursor.StartCurPtr)
							{
								if(cp >= viewport->cursor.LastStartCurPtr && cp < viewport->cursor.StartCurPtr)
								{
									Global_Ps_English = True;
									if(notPic)
										MyDrawCharacter(viewport->resource.dpy,
											viewport->resource.wind,
											viewport->resource.gc[viewport->ColorNum],
											x_pixel,
											y_pixel,
											*cp,
											&(viewport->hzdata),
											viewport->horOrder);
									else
										DrawPicture(viewport->resource.dpy,
											viewport->resource.wind,
											viewport->resource.gc[viewport->ColorNum],
											x_pixel,
											pic_y_pixel,
											picPrt);
								}
								else if(cp >= viewport->cursor.StartCurPtr) 
								{
									UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
									return(0);	
								}
							}
							else if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.LastStartCurPtr)
							{
								Global_Ps_English = True;
								if(notPic)MyDrawCharacter(viewport->resource.dpy,
										viewport->resource.wind,
										viewport->resource.reverse_gc[viewport->ColorNum],
										x_pixel,
										y_pixel,
										*cp,
										&(viewport->hzdata),
										viewport->horOrder);
									else
										DrawPicture(viewport->resource.dpy,
											viewport->resource.wind,
											viewport->resource.reverse_gc[viewport->ColorNum],
											x_pixel,
											pic_y_pixel,
											picPrt);
							}
							else if(cp >= viewport->cursor.LastStartCurPtr) 
							{
								UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
								return(0);
							}
						}
						else if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.EndCurPtr)
						{
							Global_Ps_English = True;
							if(notPic)
								MyDrawCharacter(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.reverse_gc[viewport->ColorNum],
									x_pixel,
									y_pixel,
									*cp,
									&(viewport->hzdata),
									viewport->horOrder);
							else
								DrawPicture(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.reverse_gc[viewport->ColorNum],
									x_pixel,
									pic_y_pixel,
									picPrt);
						}
						else if(cp >= viewport->cursor.LastStartCurPtr && cp < viewport->cursor.LastEndCurPtr)
						{
							Global_Ps_English = True;
							if(notPic)
								MyDrawCharacter(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.gc[viewport->ColorNum],
									x_pixel,
									y_pixel,
									*cp,
									&(viewport->hzdata),
									viewport->horOrder);
							else
								DrawPicture(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.gc[viewport->ColorNum],
									x_pixel,
									pic_y_pixel,
									picPrt);
						}
						else if(viewport->cursor.LastStartCurPtr == viewport->cursor.EndCurPtr)
						{ 
							if(cp >= viewport->cursor.LastEndCurPtr) 
							{
								UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
								return(0);
							}
							else if(cp >= viewport->cursor.EndCurPtr)
							{
								UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
								return(0);
							}
						}
						break;
					
					case UNHIGHLITE: 

						if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.EndCurPtr)
						{
							Global_Ps_English = True;
							if(notPic)
								MyDrawCharacter(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.gc[viewport->ColorNum],
									x_pixel,
									y_pixel,
									*cp,
									&(viewport->hzdata),
									viewport->horOrder);
							else
								DrawPicture(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.gc[viewport->ColorNum],
									x_pixel,
									pic_y_pixel,
									picPrt);
						}
						else if (cp >= viewport->cursor.EndCurPtr) 
						{
							UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);

							return(0);
						}
						break;
					
					case ONLYHILITE:

						if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.EndCurPtr)
						{
							Global_Ps_English = True;
							if(notPic)
								MyDrawCharacter(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.reverse_gc[viewport->ColorNum],
									x_pixel,
									y_pixel,
									*cp,
									&(viewport->hzdata),
									viewport->horOrder);
							else
								DrawPicture(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.reverse_gc[viewport->ColorNum],
									x_pixel,
									pic_y_pixel,
									picPrt);
						}
						else if (cp >= viewport->cursor.EndCurPtr) 
						{
							UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
							return(0);
						}
						break;

				/*	case TRUEDRAW:
				*/	case ASIS:
						if(cp == viewport->cursor.CurPtr)
						{
							viewport->cursor.ViewPortCur_x = x_cur_pixel;
							viewport->cursor.ViewPortCur_y = y_cur_pixel;
							viewport->cursor.hzdata = viewport->hzdata;     
							viewport->cursor.LineHeight = viewport->draw.LineHeight;
							viewport->cursor.ColNum = viewport->layout.ColNum;
							viewport->cursor.LineAlignment = viewport->layout.LineAlignment;
							viewport->cursor.ColorNum = viewport->ColorNum;
							viewport->cursor.UnderLine = viewport->layout.UnderLine;
						}
					case TRUEDRAW: 
					
						if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.EndCurPtr && viewport->cursor.StartCurPtr != viewport->cursor.EndCurPtr)
						{
							if(notPic)
								MyDrawCharacter(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.reverse_gc[viewport->ColorNum],
									x_pixel,
									y_pixel,
									*cp,
									&(viewport->hzdata),
									viewport->horOrder);
							else
								DrawPicture(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.reverse_gc[viewport->ColorNum],
									x_pixel,
									pic_y_pixel,
									picPrt);
						}
						else
						{
							if(notPic)
								MyDrawCharacter(viewport->resource.dpy,
									viewport->resource.wind, 
									viewport->resource.gc[viewport->ColorNum], 
									x_pixel,
									y_pixel,
									*cp, 
									&(viewport->hzdata),
									viewport->horOrder);
							else
								DrawPicture(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.gc[viewport->ColorNum],
									x_pixel,
									pic_y_pixel,
									picPrt);
						}
						break;
				}
			}
			
			default:
			
			switch(actionid)
			{
				case GIFLINEDRAW:
				case GIFPAGEDRAW:

				if(notPic)
					MyDrawCharacter(viewport->resource.dpy,
						gifset.pixmap,
						viewport->resource.gc[viewport->ColorNum],
						x_pixel,
						y_pixel,
						*cp,
						&(viewport->hzdata),
						viewport->horOrder);
				else
					DrawPicture(viewport->resource.dpy,
						gifset.pixmap,
						viewport->resource.gc[viewport->ColorNum],
						x_pixel,
						pic_y_pixel,
						picPrt);
				break;
				
				case PSDRAW:
				
				if(!notPic)
				{
					if(Global_Ps_English)
					{
						Global_Ps_English = False;
						if(viewport->horOrder) fprintf(printset.psfile, ") S T");
						else fprintf(printset.psfile, ") VS");
					}

					PictureToPS(viewport, picPrt);

				}
				else if(ISHZ(*cp))
				{
					if(Global_Ps_English)
					{
						Global_Ps_English = False;
						if(viewport->horOrder) fprintf(printset.psfile, ") S T ");
						else fprintf(printset.psfile, ") VS ");
					}

					if(!viewport->horOrder) fprintf(printset.psfile, "V ");

					if(viewport->hzdata.FontType == TTFONT && !(ttfset.Font[SearchFontList(viewport->hzdata.FontId)-1].BitMap))
						fprintf(printset.psfile, "%sx%xdict B %sx%x E ", viewport->hzdata.FontId, *cp,
						viewport->hzdata.FontId, *cp);
					else fprintf(printset.psfile, "%sx%x ", viewport->hzdata.FontId, *cp);

					if(viewport->horOrder) fprintf(printset.psfile, "X ");
				}
				else if(*cp != '\t')
				{
					if(!Global_Ps_English) 
					{
						Global_Ps_English = True;
						if(viewport->horOrder) fprintf(printset.psfile, "Y (");
						else fprintf(printset.psfile, "(");
					}

					if(*cp == '(' || *cp == ')' || *cp == '\\')
					{
						fprintf(printset.psfile, "\\%c", (char)*cp);
					}
					else if(*cp != '\r')
					{
						fprintf(printset.psfile, "%c", (char)*cp);
					}
				}
				else 
				{
					if(Global_Ps_English)
					{
						Global_Ps_English = False;
						if(viewport->horOrder) fprintf(printset.psfile, ") S T ");
						else fprintf(printset.psfile, ") VS ");
					}
					
					if(viewport->horOrder) fprintf(printset.psfile, "%d 0 R ", charwidth);
					else fprintf(printset.psfile, "0 %d R ", -charwidth);
				}
				break;

				case REVCURSEARCH:
				if(cp == viewport->cursor.CurPtr)
				{
					DrawMyCursor(viewport, True);
					viewport->pointer.Pointer_x = (viewport->horOrder ? x + cur_length : y);
					viewport->pointer.Pointer_y = (viewport->horOrder ? y : x + cur_length);
					viewport->cursor.ViewPortCur_x = x_cur_pixel;
					viewport->cursor.ViewPortCur_y = y_cur_pixel;
					viewport->cursor.hzdata = viewport->hzdata;
					viewport->cursor.LineHeight = viewport->draw.LineHeight;
					viewport->cursor.ColNum = viewport->layout.ColNum;
					viewport->cursor.LineAlignment = viewport->layout.LineAlignment;
					viewport->cursor.ColorNum = viewport->ColorNum;
					viewport->cursor.UnderLine = viewport->layout.UnderLine;
					RenewCharSet(viewport);
					DrawMyCursor(viewport, False);
					return(0);	
				}
				break;
		
				case UPDOWNAR:
				if(viewport->horOrder) 
				{
					if(viewport->cursor.ViewPortCur_y <= y + viewport->viewp.ViewPort_y) return(-viewport->draw.LineHeight);
				}
				else 
				{
					if(viewport->cursor.ViewPortCur_x >= y + viewport->viewp.ViewPort_x) return(-viewport->draw.LineHeight);
				}
				break;
			}	
		}

		prewidth = charwidth;
		
		cur_length += charwidth;

		if(notPic)
		{
			(*textstr) ++;
			cp++;
		}
		else
		{
			notPic = True;
			*textstr = cp = searchprt;
		}

		if ISHZ(*cp) charwidth = (viewport->horOrder ? viewport->hzdata.point_width : viewport->hzdata.point_height) * (100 + viewport->page.CharSpacing) / 100;
		else if(*cp != '\t') charwidth = viewport->hzdata.point_width * (100 + viewport->page.CharSpacing) / 200;
		else    charwidth = viewport->hzdata.point_width * TAB_SIZE * (100 + viewport->page.CharSpacing) / 100;
		
		i = XmConvertUnits(viewport->resource.WorkArea, CONVERT_X, Xm100TH_POINTS, ((x + cur_length) * viewport->zoom / 100), XmPIXELS);

		if(viewport->horOrder) 
		{
			x_cur_pixel = x + cur_length + viewport->viewp.ViewPort_x;
			x_pixel = i;
		}
		else
		{
			y_cur_pixel = x + cur_length + viewport->viewp.ViewPort_y;
			y_pixel = i;
		}
	}

	if(viewport->horOrder) y_pixel = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, ((y + viewport->draw.LineHeight - (layoutmet ? Curhzdata.point_height : viewport->hzdata.point_height) ) * viewport->zoom / 100), XmPIXELS);

	switch(actionid)
	{
		case SCANEND:
		
		if(*cp == '\n' || layoutmet || *cp == '\0')
		{
			i = (viewport->horOrder ? viewport->hzdata.point_width : viewport->hzdata.point_height) * (100 + viewport->page.CharSpacing) / 200;
			
			switch(viewport->undo.lastmode)
			{
				case UDDELETE:

				i *= DBbytelen(viewport->undo.ContentPtr);
				
				if(i + cur_length <= linewidth - charwidth/2) return(-viewport->draw.LineHeight);
				
				break;
				
				case UDINPUT:
				
				i *= (viewport->undo.numofbyteinput + 2);
				
				if(i < cur_length) return(-viewport->draw.LineHeight);

				break;

				case UDBOTH:

				j = i;

				i *= DBbytelen(viewport->undo.ContentPtr);
				i -= j * viewport->undo.numofbyteinput;

				if(i == 0) return(-viewport->draw.LineHeight);
				
				if(i > 0)
				{
					if(i + cur_length <= linewidth - charwidth/2) return(-viewport->draw.LineHeight);
				}
				
				if(i < 0)
				{
					if(-i + charwidth < cur_length) return(-viewport->draw.LineHeight);
				}
				break;	
			
				default: return(-viewport->draw.LineHeight);
			}
			return(0);	
		}
		break;

		case SMALLAFF:
		case BIGAFF:
					
		if((cp == viewport->cursor.CurPtr || cp == (viewport->cursor.CurPtr + 1)) && !layoutmet) 
		{
			return(-viewport->draw.LineHeight);
		}
		break;
					
		case CURSEARCH:
		
		switch(Alin)
		{
			case CenterAlign:

			prewidth = (linewidth - viewport->draw.LineWidth)/2;
			linewidth -= prewidth;
			break;

			case RightAlign:

			prewidth = linewidth - viewport->draw.LineWidth;
			linewidth = viewport->draw.LineWidth;
			break;
		
			default: prewidth = 0;	
		}

		if(viewport->pointer.Pointer_y >= y &&
		   viewport->pointer.Pointer_y <= y + viewport->draw.LineHeight &&
		   ((viewport->pointer.Pointer_x >= x + cur_length && 
		     viewport->pointer.Pointer_x < x + linewidth + viewport->page.PageColSpacing) ||
		    (viewport->pointer.Pointer_x >= x - prewidth &&
		     viewport->pointer.Pointer_x < x)))
		{
			DrawMyCursor(viewport, True);
			viewport->cursor.ViewPortCur_x = x_cur_pixel;
			viewport->cursor.ViewPortCur_y = y_cur_pixel;
			viewport->cursor.ViewPortCurPage = viewport->viewp.ViewPortPage;
			viewport->cursor.LineHeight = viewport->draw.LineHeight;

			if(layoutmet) 
			{
				viewport->cursor.CurPtr = curcp;
				viewport->cursor.hzdata = Curhzdata;
				viewport->cursor.ColNum = ColNum;
				viewport->cursor.LineAlignment = Alin;
				viewport->cursor.ColorNum = CurColorNum;
				viewport->cursor.UnderLine = CurUnderLine;
			}
			else
			{
				viewport->cursor.CurPtr = cp;
				viewport->cursor.hzdata = viewport->hzdata;
				viewport->cursor.ColNum = viewport->layout.ColNum;
				viewport->cursor.LineAlignment = viewport->layout.LineAlignment;
				viewport->cursor.ColorNum = viewport->ColorNum;
				viewport->cursor.UnderLine = viewport->layout.UnderLine;
			}
			
			if(viewport->pointer.Pointer_x >= x - prewidth && viewport->pointer.Pointer_x < x)
			{
				if(viewport->horOrder) viewport->cursor.ViewPortCur_x = x + viewport->viewp.ViewPort_x;
				else viewport->cursor.ViewPortCur_y = x + viewport->viewp.ViewPort_y;

				viewport->cursor.hzdata = hzdata;
				viewport->cursor.ColorNum = ColorNum;
				viewport->cursor.ColNum = ColNum;
				viewport->cursor.LineAlignment = Alin;
				viewport->cursor.UnderLine = UnderLine;
				viewport->cursor.CurPtr = startcp;
			}
			else
			{
				if(viewport->viewSym && (*cp == '\n' || layoutmet))
				{
					charwidth = ( layoutmet ? Curhzdata.point_width : viewport->hzdata.point_width) * (100 + viewport->page.CharSpacing) / 200;

					if(viewport->pointer.Pointer_x >= x + cur_length + charwidth)
					{
						if(viewport->horOrder) viewport->cursor.ViewPortCur_x = x_cur_pixel + charwidth;
						else viewport->cursor.ViewPortCur_y = y_cur_pixel + charwidth;
						if(layoutmet)
						{
							viewport->cursor.CurPtr = cp;
							viewport->cursor.hzdata = viewport->hzdata;
							viewport->cursor.ColNum = viewport->layout.ColNum;
							viewport->cursor.LineAlignment = viewport->layout.LineAlignment;
							viewport->cursor.ColorNum = viewport->ColorNum;
							viewport->cursor.UnderLine = viewport->layout.UnderLine;
						}
						else viewport->cursor.CurPtr ++;
					
					}
				}
			
			}
			RenewCharSet(viewport);
			DrawMyCursor(viewport, False);
			return(0);
		}
		break;

		case MOVESEARCH:

		switch(Alin)
		{
			case CenterAlign:

			linewidth -= (linewidth - viewport->draw.LineWidth)/2;
			break;

			case RightAlign:

			linewidth = viewport->draw.LineWidth;
			break;
		}

		if(viewport->pointer.MovePo_y >= y &&
		   viewport->pointer.MovePo_y <= y + viewport->draw.LineHeight &&
		   viewport->pointer.MovePo_x >= x + cur_length &&
		   viewport->pointer.MovePo_x < x + linewidth + viewport->page.PageColSpacing)
		{
			viewport->cursor.MoveCur_x = x_cur_pixel;
			viewport->cursor.MoveCur_y = y_cur_pixel;
			viewport->cursor.MoveCurPage = viewport->viewp.ViewPortPage;
		
			if(layoutmet)
			{
				viewport->cursor.MoveCurPtr = curcp;
				viewport->cursor.Mohzdata = Curhzdata;
				viewport->cursor.MoveColNum = ColNum;
				viewport->cursor.MoveLineAlignment = Alin;
				viewport->cursor.MoveColorNum = CurColorNum;
				viewport->cursor.MoveUnderLine = CurUnderLine;
			}
			else
			{
				viewport->cursor.MoveCurPtr = cp;
				viewport->cursor.Mohzdata = viewport->hzdata;
				viewport->cursor.MoveColNum = viewport->layout.ColNum;
				viewport->cursor.MoveLineAlignment = viewport->layout.LineAlignment;       
				viewport->cursor.MoveColorNum = viewport->ColorNum;    
				viewport->cursor.MoveUnderLine = viewport->layout.UnderLine;
			}

			if(viewport->viewSym && (*cp == '\n' || layoutmet))
			{
				charwidth = ( layoutmet ? Curhzdata.point_width : viewport->hzdata.point_width) * (100 + viewport->page.CharSpacing) / 200;
	
				if(viewport->pointer.MovePo_x >= x + cur_length + charwidth)
				{
					if(viewport->horOrder) viewport->cursor.MoveCur_x = x_cur_pixel + charwidth;
					else viewport->cursor.MoveCur_y = y_cur_pixel + charwidth;

					if(layoutmet) 
					{
						viewport->cursor.MoveCurPtr = cp;
						viewport->cursor.Mohzdata = viewport->hzdata;
						viewport->cursor.MoveColNum = viewport->layout.ColNum;
						viewport->cursor.MoveLineAlignment = viewport->layout.LineAlignment;
						viewport->cursor.MoveColorNum = viewport->ColorNum;
						viewport->cursor.MoveUnderLine = viewport->layout.UnderLine;
					} 
					else viewport->cursor.MoveCurPtr ++;
				}
			}	
			return(0);
		}
		break;

		case REVCURSEARCH:
		
		if(cp == viewport->cursor.CurPtr && (*cp == '\n' || *cp == '\0') && !layoutmet)
		{
			DrawMyCursor(viewport, True);
			viewport->pointer.Pointer_x = (viewport->horOrder ? x + cur_length : y);
			viewport->pointer.Pointer_y = (viewport->horOrder ? y : x + cur_length);
			viewport->cursor.ViewPortCur_x = x_cur_pixel;
			viewport->cursor.ViewPortCur_y = y_cur_pixel;
			viewport->cursor.hzdata = viewport->hzdata;
			viewport->cursor.LineHeight = viewport->draw.LineHeight;
			viewport->cursor.ColNum = viewport->layout.ColNum;
			viewport->cursor.LineAlignment = viewport->layout.LineAlignment;
			viewport->cursor.ColorNum = viewport->ColorNum;
			viewport->cursor.UnderLine = viewport->layout.UnderLine;
			RenewCharSet(viewport);
			DrawMyCursor(viewport, False);
			return(0);	
		}
		break;

		case PSDRAW:
		if(Global_Ps_English)
		{
			Global_Ps_English = False;
			if(viewport->horOrder) fprintf(printset.psfile, ") S T");
			else fprintf(printset.psfile, ") VS");
		}

		fprintf(printset.psfile, "\n");
		UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, PSDRAW, &Global_Ps_English);
		break;
	
		case GIFPAGEDRAW:
		UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, GIFPAGEDRAW, NULL);
		break;
	
		case HIGHLITE:

		if(layoutmet) mysym = myIDS;
		else mysym = myENTER;

		if(viewport->cursor.LastStartCurPtr == viewport->cursor.StartCurPtr)
		{
			if(viewport->cursor.LastEndCurPtr > viewport->cursor.EndCurPtr)
			{
				if(cp >= viewport->cursor.EndCurPtr && cp < viewport->cursor.LastEndCurPtr)
				{
					UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
					if(viewport->viewSym && (*cp == '\n' || layoutmet))
						MyDrawCharacter(viewport->resource.dpy,
								viewport->resource.wind,
								viewport->resource.gc[layoutmet ? CurColorNum : viewport->ColorNum],
								x_pixel,
								y_pixel,
								mysym,
								( layoutmet ? &Curhzdata : &(viewport->hzdata)),
								viewport->horOrder);
				}
				else if(cp >= viewport->cursor.LastEndCurPtr) 
				{
					UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
					return(0);	
				}
			}
			else if(cp >= viewport->cursor.LastEndCurPtr && cp < viewport->cursor.EndCurPtr)
			{
				UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
				if(viewport->viewSym && (*cp == '\n' || layoutmet))
					MyDrawCharacter(viewport->resource.dpy,
							viewport->resource.wind,
							viewport->resource.reverse_gc[layoutmet ? CurColorNum : viewport->ColorNum],
							x_pixel,
							y_pixel,
							mysym,
							( layoutmet ? &Curhzdata : &(viewport->hzdata)),
							viewport->horOrder);
			}
			else if(cp >= viewport->cursor.EndCurPtr) 
			{
				UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
				return(0);
			}
		}
		else if(viewport->cursor.LastEndCurPtr == viewport->cursor.EndCurPtr)
		{
			if(viewport->cursor.LastStartCurPtr < viewport->cursor.StartCurPtr)
			{
				if(cp >= viewport->cursor.LastStartCurPtr && cp < viewport->cursor.StartCurPtr)
				{
					UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
					if(viewport->viewSym && (*cp == '\n' || layoutmet))
						MyDrawCharacter(viewport->resource.dpy,
								viewport->resource.wind,
								viewport->resource.gc[layoutmet ? CurColorNum : viewport->ColorNum],
								x_pixel,
								y_pixel,
								mysym,
								( layoutmet ? &Curhzdata : &(viewport->hzdata)),
								viewport->horOrder);
				}
				else if(cp >= viewport->cursor.StartCurPtr) 
				{
					UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
					return(0);	
				}
			}
			else if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.LastStartCurPtr)
			{
				UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
				if(viewport->viewSym && (*cp == '\n' || layoutmet))
					MyDrawCharacter(viewport->resource.dpy,
							viewport->resource.wind,
							viewport->resource.reverse_gc[layoutmet ? CurColorNum : viewport->ColorNum],
							x_pixel,
							y_pixel,
							mysym,
							( layoutmet ? &Curhzdata : &(viewport->hzdata)),
							viewport->horOrder);
			}
			else if(cp >= viewport->cursor.LastStartCurPtr) 
			{
				UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
				return(0);
			}
		} 
		else if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.EndCurPtr)
		{
			UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
			if(viewport->viewSym && (*cp == '\n' || layoutmet))
				MyDrawCharacter(viewport->resource.dpy,
						viewport->resource.wind,
						viewport->resource.reverse_gc[layoutmet ? CurColorNum : viewport->ColorNum],
						x_pixel,
						y_pixel,
						mysym,
						( layoutmet ? &Curhzdata : &(viewport->hzdata)),
						viewport->horOrder);
		}
		else if(cp >= viewport->cursor.LastStartCurPtr && cp < viewport->cursor.LastEndCurPtr)
		{
			UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
			if(viewport->viewSym && (*cp == '\n' || layoutmet))
				MyDrawCharacter(viewport->resource.dpy,
						viewport->resource.wind,
						viewport->resource.gc[layoutmet ? CurColorNum : viewport->ColorNum],
						x_pixel,
						y_pixel,
						mysym,
						( layoutmet ? &Curhzdata : &(viewport->hzdata)),
						viewport->horOrder);
		}
		else if(viewport->cursor.LastStartCurPtr == viewport->cursor.EndCurPtr)
		{
			if(cp >= viewport->cursor.LastEndCurPtr) 
			{
				UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
				return(0);
			}
			else if(cp >= viewport->cursor.EndCurPtr)
			{
				UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
				return(0);
			}
		}
		break;
		
		case UNHIGHLITE: 
	
		if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.EndCurPtr)
		{
			UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
	
			if(viewport->viewSym && (*cp == '\n' || layoutmet))
			{
				if(layoutmet) mysym = myIDS;    
				else mysym = myENTER;

				MyDrawCharacter(viewport->resource.dpy,
						viewport->resource.wind,
						viewport->resource.gc[layoutmet ? CurColorNum : viewport->ColorNum],
						x_pixel,
						y_pixel,
						mysym,
						( layoutmet ? &Curhzdata : &(viewport->hzdata)),
						viewport->horOrder);
			}
		} 
		else if (cp >= viewport->cursor.EndCurPtr) 
		{
			UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
			return(0);
		}
		break;
		
		case ONLYHILITE:

		if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.EndCurPtr)
		{
			UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);

			if(viewport->viewSym && (*cp == '\n' || layoutmet))
			{
				if(layoutmet) mysym = myIDS;    
				else mysym = myENTER;

				MyDrawCharacter(viewport->resource.dpy,
						viewport->resource.wind,
						viewport->resource.reverse_gc[layoutmet ? CurColorNum : viewport->ColorNum],
						x_pixel,
						y_pixel,
						mysym,
						( layoutmet ? &Curhzdata : &(viewport->hzdata)),
						viewport->horOrder);
			}
		} 
		else if (cp >= viewport->cursor.EndCurPtr) 
		{
			UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);
			return(0);
		}
		break;

		case ASIS:

		if(cp == viewport->cursor.CurPtr && !layoutmet)
		{
			viewport->cursor.ViewPortCur_x = x_cur_pixel;
			viewport->cursor.ViewPortCur_y = y_cur_pixel;
			viewport->cursor.hzdata = viewport->hzdata;     
			viewport->cursor.LineHeight = viewport->draw.LineHeight;
			viewport->cursor.ColNum = viewport->layout.ColNum;
			viewport->cursor.LineAlignment = viewport->layout.LineAlignment;
			viewport->cursor.ColorNum = viewport->ColorNum;
			viewport->cursor.UnderLine = viewport->layout.UnderLine;
		}
	
		case TRUEDRAW: 

		UnderLineX = DrawTextUnderLine(viewport, x + cur_length, UnderLineX, y, x_pixel, y_pixel, viewport->layout.UnderLine, TRUEDRAW, NULL);

		if(viewport->viewSym && (*cp == '\n' || layoutmet))
		{
			if(layoutmet) mysym = myIDS;    
			else mysym = myENTER;
			
			if(cp >= viewport->cursor.StartCurPtr && cp < viewport->cursor.EndCurPtr && viewport->cursor.StartCurPtr !=
			viewport->cursor.EndCurPtr)
			{
				MyDrawCharacter(viewport->resource.dpy,
						viewport->resource.wind,
						viewport->resource.reverse_gc[layoutmet ? CurColorNum : viewport->ColorNum],
						x_pixel,
						y_pixel,
						mysym,
						( layoutmet ? &Curhzdata : &(viewport->hzdata)),
						viewport->horOrder);
			}
			else
			{
				MyDrawCharacter(viewport->resource.dpy,
						viewport->resource.wind,
						viewport->resource.gc[layoutmet ? CurColorNum : viewport->ColorNum],
						x_pixel,
						y_pixel,
						mysym,
						( layoutmet ? &Curhzdata : &(viewport->hzdata)),
						viewport->horOrder);
			}
		}

		break;
		
		case UPDOWNAR:
		if(viewport->horOrder)
		{
			if(viewport->cursor.ViewPortCur_y <= y + viewport->viewp.ViewPort_y) return(-viewport->draw.LineHeight);
		}
		else
		{
			if(viewport->cursor.ViewPortCur_x >= y + viewport->viewp.ViewPort_x) return(-viewport->draw.LineHeight);
		}
		break;
	}
	viewport->draw.LineWidth = cur_length;
	
	return(max_height);
}

void MyDrawPage(viewport, actionid)
VIewportdata *viewport;
int actionid;
{
	unsigned short *text, *cp, *blockstart;
	int i, linegifnum = 1, updown = 0, linecur_x, linecur_y, lastline_y = 0, lastheight, laslastheight, lineinc=24, pagenum, origpage, lasthtmp;
	int linestart_x, linestart_y, blockstart_y, blockend_y, blockheight, max_block_height, max_lineinc, mycol, col_width, inputlasth;
	int newpage, zoom = 100, NotWarned = True, overcol, startcol, nofirst, scanfirst, layoutchange, alin, coln, linespacing, yespacing, graphHeight;
	PAgedata *curpage, *pagetmp;
	Arg args[1];
	char num[20];
	HZdata hzdata;
	int x_s, x_l, x_e, y_s, y_l, y_e, colr, undl;
	int counter = 0;

	if( CriticalGoing ) return;

	switch(actionid)
	{
		case GIFLINEDRAW:
		case GIFPAGEDRAW:
		case PSDRAW:

			CriticalGoing = True;

		case TRUEDRAW:
		case CLEARDRAW:
		case INVIRDRAW:
		case VIRDRAW:
		case EXPOSEDR:

		BusyWindows();
	}

	switch(actionid)
	{
		case NONEACT:

		return;

		case LEFTRIGHTAR:

		LeftRightAroInput(viewport, True); 
		return;

		case CLEARDRAW:

		viewport->draw.DrawScr_x = viewport->draw.DrawPos_x;
		viewport->draw.DrawScr_y = viewport->draw.DrawPos_y;
		actionid = TRUEDRAW;	

		case TRUEDRAW:

		if((viewport->draw.DrawScr_x == viewport->draw.DrawPos_x) && (viewport->draw.DrawScr_y == viewport->draw.DrawPos_y))
		{
			XClearWindow(viewport->resource.dpy, viewport->resource.wind);
			
			viewport->draw.DrawPos_x = 0;
			viewport->draw.DrawPos_y = 0;
			viewport->draw.DrawLen_x = viewport->viewp.ViewPortWidth;
			viewport->draw.DrawLen_y = viewport->viewp.ViewPortHeight;
		}
		else
		{
			if(viewport->draw.DrawScr_x > viewport->draw.DrawPos_x)
				viewport->draw.DrawLen_x = viewport->viewp.ViewPortWidth - viewport->draw.DrawScr_x;
			else
				viewport->draw.DrawLen_x = viewport->viewp.ViewPortWidth - viewport->draw.DrawPos_x;
			
			if(viewport->draw.DrawScr_y > viewport->draw.DrawPos_y)
				viewport->draw.DrawLen_y = viewport->viewp.ViewPortHeight - viewport->draw.DrawScr_y;
			else
				viewport->draw.DrawLen_y = viewport->viewp.ViewPortHeight - viewport->draw.DrawPos_y;

			if(viewport->draw.DrawScr_x == 0) x_s = 0;
			else x_s = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (viewport->draw.DrawScr_x * 
			viewport->zoom / 100), XmPIXELS);

			if(viewport->draw.DrawScr_y == 0) y_s = 0;
			else y_s = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (viewport->draw.DrawScr_y *
			viewport->zoom / 100), XmPIXELS);

			if(viewport->draw.DrawLen_x == 0) x_l = 0;
			else x_l = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (viewport->draw.DrawLen_x *
			viewport->zoom / 100), XmPIXELS)+1;

			if(viewport->draw.DrawLen_y == 0) y_l = 0;
			else y_l = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (viewport->draw.DrawLen_y *
			viewport->zoom / 100), XmPIXELS)+1;

			if(viewport->draw.DrawPos_x == 0) x_e = 0;
			else x_e = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (viewport->draw.DrawPos_x * 
			viewport->zoom / 100), XmPIXELS);

			if(viewport->draw.DrawPos_y == 0) y_e = 0;
			else y_e = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (viewport->draw.DrawPos_y *
			viewport->zoom / 100), XmPIXELS);

			XCopyArea(viewport->resource.dpy, viewport->resource.wind, viewport->resource.wind, viewport->resource.gc[1],
			  	  x_s, y_s,
			  	  x_l, y_l,
			  	  x_e, y_e);
			
			if(viewport->draw.DrawScr_x > viewport->draw.DrawPos_x)
			{
				i = viewport->draw.DrawPos_x + viewport->draw.DrawLen_x;
				viewport->draw.DrawLen_x = viewport->draw.DrawScr_x - viewport->draw.DrawPos_x;
				viewport->draw.DrawPos_x = i;
			}
			else
			{
				if(viewport->draw.DrawScr_x < viewport->draw.DrawPos_x)
				{
					viewport->draw.DrawLen_x = viewport->draw.DrawPos_x - viewport->draw.DrawScr_x;
					viewport->draw.DrawPos_x = viewport->draw.DrawScr_x;
				}
				else
				{
					viewport->draw.DrawLen_x = viewport->viewp.ViewPortWidth;
					viewport->draw.DrawPos_x = 0;
				}
			}

			if(viewport->draw.DrawScr_y > viewport->draw.DrawPos_y)
			{
				i = viewport->draw.DrawPos_y + viewport->draw.DrawLen_y;
				viewport->draw.DrawLen_y = viewport->draw.DrawScr_y - viewport->draw.DrawPos_y;
				viewport->draw.DrawPos_y = i;
			}
			else
			{
				if(viewport->draw.DrawScr_y < viewport->draw.DrawPos_y)
				{
					viewport->draw.DrawLen_y = viewport->draw.DrawPos_y - viewport->draw.DrawScr_y;
					viewport->draw.DrawPos_y = viewport->draw.DrawScr_y;
				}
				else 
				{
					viewport->draw.DrawLen_y = viewport->viewp.ViewPortHeight;
					viewport->draw.DrawPos_y = 0;
				}
			}

			if(viewport->draw.DrawPos_x == 0) x_s = 0;
			else x_s = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (viewport->draw.DrawPos_x * viewport->zoom
			/ 100), XmPIXELS);

			if(viewport->draw.DrawPos_y == 0) y_s = 0;
			else y_s = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (viewport->draw.DrawPos_y *
			viewport->zoom / 100), XmPIXELS);

			if(viewport->draw.DrawLen_x == 0) x_e = 0;
			else x_e = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (viewport->draw.DrawLen_x *
			viewport->zoom / 100), XmPIXELS) + 1;

			if(viewport->draw.DrawLen_y == 0) y_e = 0;
			else y_e = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (viewport->draw.DrawLen_y *
			viewport->zoom / 100), XmPIXELS) + 1;

			XClearArea(viewport->resource.dpy, viewport->resource.wind,
				   x_s, y_s, 
				   x_e, y_e,
				   False);
		}

		break;

		case ASIS:

		break;

		case EXPOSEDR:

		actionid = TRUEDRAW;	

		default:

		viewport->draw.DrawPos_x = 0;
		viewport->draw.DrawPos_y = 0;
		viewport->draw.DrawLen_x = viewport->viewp.ViewPortWidth;
		viewport->draw.DrawLen_y = viewport->viewp.ViewPortHeight;
	}	

	switch(actionid)
	{
		case PSDRAW:
		
		if(printset.AllPage) 
		{
			curpage = viewport->page.PageRoot;
			pagenum = 1;
		}
		else
		{
			for(curpage = viewport->page.PageRoot, pagenum = curpage->PageNum; pagenum < printset.StartPage && curpage->Next != NULL;
			    curpage = curpage->Next, pagenum = curpage->PageNum);
		}

		break;

		case GIFLINEDRAW:
		case GIFPAGEDRAW:

		if(gifset.AllPage)
		{
			curpage = viewport->page.PageRoot;
			pagenum = 1;
		}
		else
		{
			for(curpage = viewport->page.PageRoot, pagenum = curpage->PageNum; pagenum < gifset.StartPage && curpage->Next !=
			NULL; curpage = curpage->Next, pagenum = curpage->PageNum);
		}
	
		break;

		case INVIRDRAW:
		
		viewport->virdrawn = True;
		for(curpage = viewport->page.PageRoot; viewport->cursor.RedrawCurPtr >= curpage->PageStart && curpage->Next != NULL; curpage =
		curpage->Next);

		if(curpage->Last != NULL) curpage = curpage->Last;
		pagenum = curpage->PageNum;
		break;
		
		case VIRDRAW:

		viewport->virdrawn = True;
		curpage = viewport->page.PageRoot;
		curpage->PageStart = viewport->EditFile;
		pagenum = 1;
		break;

		case TRUEDRAW:

		pagenum = viewport->viewp.ViewPortPage;
		curpage = viewport->viewp.CurPage;
		break;

		default:

		pagenum = viewport->viewp.ViewPortPage;
		curpage = viewport->viewp.CurPage;
	}

	blockstart = curpage->PageStart;
	viewport->ColorNum = curpage->ColorNum;	
	viewport->layout.UnderLine = curpage->UnderLine;
	viewport->hzdata = curpage->hzdata;
	viewport->layout.ColNum = curpage->ColNum;
	viewport->layout.LineAlignment = curpage->LineAlignment;
	origpage = viewport->page.MaxPageNum;
	nofirst = False;
	newpage = True;

	if(viewport->horOrder) 
	{
		blockstart_y = viewport->page.PageMarginHeight;
		lastheight = 2*viewport->page.PageMarginHeight + viewport->hzdata.point_height;
	}
	else
	{
		blockstart_y = viewport->page.PageMarginWidth;
		lastheight = 0;
	}

	switch(actionid)
	{
		case PSDRAW:

		fprintf(printset.psfile, "%%%%Page: %d\nsave\n0.01 0.01 scale\n50 setlinewidth\n", pagenum);       
		if(!viewport->origpage.Portrait) fprintf(printset.psfile, "0 %d translate -90 rotate\n", PageData[viewport->origpage.PageSetId][1]
		* 100);
		fprintf(printset.psfile, "/P {%d} J\n/F {%d} J\n/SZ {%d %d} J\n/TZ {%.1f %.1f} J\nW [%d 0 0 %d 0 0] Z\n/H {%d} J\n/K {%d} J\n", 
		viewport->hzdata.point_width * (100 + viewport->page.CharSpacing) / 100, 
		-viewport->hzdata.point_height * (100 + viewport->page.CharSpacing) / 100,
		viewport->hzdata.point_width, 
		viewport->hzdata.point_height, 
		(float)viewport->hzdata.point_width/1000,
		(float)viewport->hzdata.point_height/1000,
		viewport->hzdata.point_width*(100 + viewport->page.CharSpacing)/ENGLISHPSPARA, 
		viewport->hzdata.point_height*5/4,
		viewport->hzdata.point_height/8,
		-viewport->hzdata.point_height/8);

		if(printset.ColorPS)
		{
			XGCValues gc_value;
			XColor color;

			XGetGCValues(viewport->resource.dpy,
				     viewport->resource.reverse_gc[0], 
				     GCForeground, &gc_value);

			color.pixel = gc_value.foreground;
			XQueryColor(viewport->resource.dpy,
				    DefaultColormap(viewport->resource.dpy,
				    DefaultScreen(viewport->resource.dpy)),
				    &color);

			fprintf(printset.psfile, "%4.2f %4.2f %4.2f C\n", (float)color.red/65535.,
				(float)color.green/65535., (float)color.blue/65535.);

			fprintf(printset.psfile, "0 0 M ");

			if(viewport->origpage.Portrait)
			{
				fprintf(printset.psfile, "0 %d L %d %d L %d 0 L ",
					PageData[viewport->origpage.PageSetId][1] * 100,  
					PageData[viewport->origpage.PageSetId][0] * 100,
					PageData[viewport->origpage.PageSetId][1] * 100,
					PageData[viewport->origpage.PageSetId][0] * 100);
			}
			else
			{
				fprintf(printset.psfile, "0 %d L %d %d L %d 0 L ",
					PageData[viewport->origpage.PageSetId][0] * 100,
					PageData[viewport->origpage.PageSetId][1] * 100,
					PageData[viewport->origpage.PageSetId][0] * 100,
					PageData[viewport->origpage.PageSetId][1] * 100);
			}

			fprintf(printset.psfile, "closepath fill\n");

			XGetGCValues(viewport->resource.dpy,
				     viewport->resource.gc[viewport->ColorNum], 
				     GCForeground, &gc_value);

			color.pixel = gc_value.foreground;
			XQueryColor(viewport->resource.dpy,
				    DefaultColormap(viewport->resource.dpy,
				    DefaultScreen(viewport->resource.dpy)),
				    &color);

			fprintf(printset.psfile, "%4.2f %4.2f %4.2f C\n", (float)color.red/65535.,
				(float)color.green/65535., (float)color.blue/65535.);

		}
		
		break;

		case GIFPAGEDRAW:
		
		gifset.draw.width = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, viewport->page.PageWidth,
		XmPIXELS);
		gifset.draw.height = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, viewport->page.PageHeight,
		XmPIXELS);
		gifset.pixmap = XCreatePixmap(viewport->resource.dpy, viewport->resource.wind,
				       gifset.draw.width,
				       gifset.draw.height,
				       DisplayPlanes(viewport->resource.dpy, DefaultScreen(viewport->resource.dpy)));

		GifClear(viewport);

		case GIFLINEDRAW:      

		if(viewport->zoom != 100)
		{
			zoom = viewport->zoom;
			viewport->zoom = 100;	
			ZoomOpr(viewport, 0);
		}
		break;	
	}

	
	if(blockstart != NULL)
	{
		do
		{
			if(newpage)
			{
				newpage = False;

				i = CheckLayoutIds(viewport, &blockstart, viewport->layout.ColNum, 0);

				while(i > 0 || i == -1)
				{
					if(i > 0) viewport->layout.ColNum = i;
					i = CheckLayoutIds(viewport, &blockstart, viewport->layout.ColNum, 0);
				}
			}

			if(viewport->horOrder)
			{
				max_block_height = (viewport->page.PageHeight - blockstart_y + lastline_y - viewport->page.PageMarginHeight) * viewport->layout.ColNum;
				col_width = (viewport->page.PageWidth - 2*viewport->page.PageMarginWidth - viewport->page.PageColSpacing * (viewport->layout.ColNum - 1))/
				viewport->layout.ColNum;
			}
			else
			{
				max_block_height = (viewport->page.PageWidth - blockstart_y - viewport->page.PageMarginWidth) * viewport->layout.ColNum;
				col_width = (viewport->page.PageHeight - 2*viewport->page.PageMarginHeight - viewport->page.PageColSpacing * (viewport->layout.ColNum - 1))/viewport->layout.ColNum;
			}	

			cp = blockstart;
			blockheight = 0;
			max_lineinc = 0;

			hzdata = viewport->hzdata;
			colr = viewport->ColorNum;
			coln = viewport->layout.ColNum;
			alin = viewport->layout.LineAlignment;
			undl = viewport->layout.UnderLine;
			scanfirst = nofirst;
			yespacing = False;

			do
			{
				if(*cp == '\n' && scanfirst) cp++;
				if(!scanfirst) scanfirst = True;

				layoutchange = 0;
				graphHeight = 0;
				
				lineinc = MyDrawLine(
					  viewport,
					  0,
					  0,
					  &cp,
					  col_width,
					  VIRDRAW,
					  &layoutchange,
					  &graphHeight);
			
				if(yespacing) lineinc += lineinc * viewport->page.PageLineSpacing / 100;

				graphHeight = graphHeight * 110 / 100;

				if(graphHeight > lineinc) lineinc = graphHeight;

				if(max_lineinc < lineinc) max_lineinc = lineinc;

				blockheight += lineinc;
				
				if(blockheight + max_lineinc * (coln - 1) >= max_block_height &&
				   !(blockstart_y == (viewport->horOrder ? 
				    viewport->page.PageMarginHeight : 
				    viewport->page.PageMarginWidth) && !yespacing))
				{
					if(viewport->horOrder)
						blockend_y = lastline_y + viewport->page.PageHeight - viewport->page.PageMarginHeight;
					else
						blockend_y = viewport->page.PageWidth - viewport->page.PageMarginWidth;
					break;
				}

				yespacing = True;

				if(layoutchange > 0)
				{
					blockend_y = blockstart_y + (blockheight/coln);
					break;
				}
					
				if(layoutchange < 0) scanfirst = False;

				if(*cp == '\0') blockend_y = blockstart_y + (blockheight/coln);
			} while(*cp != '\0');

			viewport->layout.ColNum = coln;
			viewport->hzdata = hzdata;
			viewport->ColorNum = colr;
			viewport->layout.LineAlignment = alin;
			viewport->layout.UnderLine = undl;

			if(viewport->horOrder) linecur_x = viewport->page.PageMarginWidth;
			else linecur_x = lastline_y + viewport->page.PageMarginHeight;

			linecur_y = blockstart_y;
			cp = blockstart;
			mycol = 1;
			yespacing = False;
	
			if(viewport->borderOn && (actionid == TRUEDRAW || actionid == ASIS)) 
				if(viewport->horOrder) DrawMarginLine(viewport, blockstart_y - 
					viewport->viewp.ViewPort_y, blockend_y - viewport->viewp.ViewPort_y,
					viewport->page.PageMarginWidth - viewport->viewp.ViewPort_x, col_width);
				else DrawMarginLine(viewport, viewport->page.PageWidth - blockend_y - viewport->viewp.ViewPort_x,
						    viewport->page.PageWidth - blockstart_y - viewport->viewp.ViewPort_x,  
						    linecur_x - viewport->viewp.ViewPort_y, col_width);

			do
			{
				if(*cp == '\n' && nofirst) cp++;
				if(!nofirst) nofirst = True;

				text = cp;
				hzdata = viewport->hzdata;
				colr = viewport->ColorNum;
				coln = viewport->layout.ColNum;
				alin = viewport->layout.LineAlignment;
				undl = viewport->layout.UnderLine;
				graphHeight = 0;

				lineinc = MyDrawLine(
				  	viewport,
				  	0,
				  	0,
				  	&text,
				  	col_width,
				  	VIRDRAW,
					&layoutchange,
					&graphHeight);

				text = cp;

				if(graphHeight > lineinc)
				{
					viewport->draw.LineHeight = graphHeight;
				}
				else
				{
					viewport->draw.LineHeight = lineinc;
				}
				
				viewport->hzdata = hzdata;
				viewport->ColorNum = colr;
				viewport->layout.ColNum = coln;
				viewport->layout.LineAlignment = alin;
				viewport->layout.UnderLine = undl;

				linespacing = lineinc * viewport->page.PageLineSpacing / 100;

				if(yespacing) lineinc += linespacing;

				graphHeight = graphHeight * 110 / 100;

				if(graphHeight > lineinc)
				{
					lineinc = graphHeight;
				}

				lasthtmp = lineinc;
				
				if(linecur_y + lineinc > blockend_y &&
				   ((viewport->horOrder ? linecur_y - lastline_y : linecur_y) > (viewport->horOrder ? viewport->page.PageMarginHeight : viewport->page.PageMarginWidth)) )

/* && !yespacing && mycol == 1))
*/				{	
					if(actionid == SCANEND && coln > 1 && mycol < coln)
					{
						overcol = True;
					}

					if(mycol < coln)
					{
						linecur_x += col_width + viewport->page.PageColSpacing;
						if(viewport->horOrder)
						{
							if(blockend_y - lastline_y >= viewport->page.PageHeight - viewport->page.PageMarginHeight)
							lastheight += viewport->page.PageHeight - linecur_y + lastline_y +
							viewport->page.PageMarginHeight;
							else lastheight += blockend_y - linecur_y + lineinc;
						}
						else
						{
							if(blockend_y >= viewport->page.PageWidth - viewport->page.PageMarginWidth)
								lastheight = 0;
							else lastheight += blockend_y - linecur_y + lineinc;
						}
	
						linecur_y = blockstart_y;
						yespacing = False;
						mycol ++;

						continue;
					}
					else
					{
						if(viewport->horOrder)
						{
						   if(blockend_y - lastline_y >=  
						      viewport->page.PageHeight - viewport->page.PageMarginHeight)
						   {
							lastheight += viewport->page.PageHeight - linecur_y + lastline_y + viewport->page.PageMarginHeight;
							linecur_y += lineinc;
							break;
						   }
						}
						else
						{
						   if(blockend_y >=
						      viewport->page.PageWidth - viewport->page.PageMarginWidth)
						   {
							lastheight = 0;
							linecur_y += lineinc;
							break;
						   }	
						}
					}
				}

				if(yespacing) 
				{
					linecur_y += lineinc - viewport->draw.LineHeight;
				}
				else
				{
					yespacing = True;
				}

				if(updown == 1 && actionid == UPDOWNAR) 
				{ 
					updown = 2;
					break; 
				}

				switch(actionid)
				{
					case GIFLINEDRAW:

					gifset.draw.width = XmConvertUnits(viewport->resource.WorkArea, CONVERT_X, Xm100TH_POINTS,
					viewport->draw.LineWidth, XmPIXELS);
					gifset.draw.height = XmConvertUnits(viewport->resource.WorkArea, CONVERT_Y, Xm100TH_POINTS,
					viewport->draw.LineHeight, XmPIXELS);

					linestart_x = 0;
					linestart_y = 0;

					if(!viewport->horOrder) 
					{
						i = gifset.draw.width;
						gifset.draw.width = gifset.draw.height;
						gifset.draw.height = i;
					}

					if(gifset.draw.width > 0 && gifset.draw.height > 0)
					{
						gifset.pixmap = XCreatePixmap(viewport->resource.dpy, viewport->resource.wind,
								gifset.draw.width,
								gifset.draw.height,
								DisplayPlanes(viewport->resource.dpy, DefaultScreen(viewport->resource.dpy)));
						GifClear(viewport);
					}
					
					linestart_x = 0;
					linestart_y = 0;
					break;

					case GIFPAGEDRAW:

					linestart_x = linecur_x;
					if(viewport->horOrder) linestart_y = linecur_y;
					else linestart_y = viewport->page.PageWidth - linecur_y - viewport->draw.LineHeight;
					break;

					default:

					if(viewport->horOrder)
					{
						linestart_x = linecur_x - viewport->viewp.ViewPort_x;
						linestart_y = linecur_y - viewport->viewp.ViewPort_y;
					}
					else
					{
						linestart_x = linecur_x - viewport->viewp.ViewPort_y;
						linestart_y = viewport->page.PageWidth - linecur_y - viewport->viewp.ViewPort_x - viewport->draw.LineHeight;
					}
				}

				switch(alin)
				{
					case CenterAlign:

						linestart_x += (col_width - viewport->draw.LineWidth)/2;
						break;

					case RightAlign:

						linestart_x += col_width - viewport->draw.LineWidth;
						break;
				}

				layoutchange = 0;
				graphHeight = 0;

				lineinc = MyDrawLine(
				 	viewport, 
				  	linestart_x, 
				  	linestart_y, 
				  	&cp, 
				  	col_width,
				  	actionid,
					&layoutchange,
					&graphHeight);

				if(actionid == GIFLINEDRAW)
				{
					if(gifset.draw.width > 0 && gifset.draw.height > 0)
					{
						MyPutPixmapToGif(viewport, linegifnum);
						XFreePixmap(viewport->resource.dpy, gifset.pixmap);
						linegifnum++;
					}	
				}

				if(actionid == GIFLINEDRAW || actionid == GIFPAGEDRAW || actionid == PSDRAW)
                                {
                                        counter++;
 
                                        if( counter > CANCELCOUNTER )
                                        {
                                                while( XtAppPending(app) )
                        			{
                                			XtAppProcessEvent(app, XtIMAll);
                        			}

                                                counter = 0;
 
                                                if( LongProcCancelFlg )
                                                {
                                                        break;
                                                }
                                        }
                                }

				if(lineinc == 0) break;
				
				if(lineinc < 0)
				{
					lineinc = -lineinc;

					if(updown == 1 && actionid == SCANEND) updown = 2;
					
					if(updown == 0)
					{
						updown = 1;
						
						if(actionid == BIGAFF || actionid == SMALLAFF)
						{
							startcol = mycol;
							overcol = False;
							
							if(linestart_x < 0)
								viewport->draw.DrawPos_x = 0;
							else
								viewport->draw.DrawPos_x = linecur_x - 
							(viewport->horOrder ? viewport->viewp.ViewPort_x : viewport->viewp.ViewPort_y);
							
							viewport->draw.DrawLen_x = col_width + viewport->page.PageColSpacing/2;
							viewport->draw.DrawPos_y = linestart_y + (viewport->horOrder ? 0 : viewport->draw.LineHeight);
							inputlasth= lastheight;
						
							cp = text;
							viewport->hzdata = hzdata;
							viewport->ColorNum = colr;
							viewport->layout.ColNum = coln;
							viewport->layout.LineAlignment = alin;
							viewport->layout.UnderLine = undl;

							if(actionid == BIGAFF)
							{
								actionid = SCANEND;
								updown = 3;	
								break;	
							}
							actionid = SCANEND;
							continue;
						}
					}
				}
				
				linecur_y = linecur_y + viewport->draw.LineHeight;
				laslastheight = lastheight;
				lastheight = lasthtmp;

				if(viewport->horOrder) linestart_y += viewport->draw.LineHeight;

				if(updown >= 2) break;

				if(layoutchange > 0)
				{
					viewport->layout.ColNum = layoutchange;
					nofirst = False;
					if(blockend_y < linecur_y) blockend_y = linecur_y;
					break;
				}

				if(layoutchange < 0) nofirst = False;

			} while(*cp != '\0');
			
			if(lineinc == 0) break;

			if(actionid == GIFLINEDRAW || actionid == GIFPAGEDRAW || actionid == PSDRAW)
                        {
				if(LongProcCancelFlg) break;
			}

			blockstart = cp;
			if(blockend_y < linecur_y) blockend_y = linecur_y;

			if(actionid == SCANEND)
			{
				if(updown == 2)
				{
					viewport->draw.DrawLen_y = linestart_y - viewport->draw.DrawPos_y;
					if(!viewport->horOrder) 
					{
						viewport->draw.DrawLen_y = -viewport->draw.DrawLen_y;
						viewport->draw.DrawPos_y -= viewport->draw.DrawLen_y;
					}
				}
				break;
			}

			blockstart_y = blockend_y;

			if(((viewport->horOrder && ((blockend_y - lastline_y)/20 >= 
			   (viewport->page.PageHeight - viewport->page.PageMarginHeight)/20)) ||
			   (!viewport->horOrder && (blockend_y >=
			   viewport->page.PageWidth - viewport->page.PageMarginWidth)))
			   && *blockstart != '\0')
			{
				pagenum++;

				if(actionid == VIRDRAW || actionid == TRUEDRAW || actionid == ASIS || actionid == INVIRDRAW)
				{
					if(curpage->Next == NULL)
					{
						curpage->Next = (PAgedata *)malloc(sizeof(PAgedata)+1);
						curpage->Next->Last = curpage;
						curpage = curpage->Next;
						curpage->Next = NULL;
						curpage->LineAlignment = viewport->layout.LineAlignment;	
					} else
					{
						curpage = curpage->Next;
					}

					curpage->PageNum = pagenum;
					curpage->PageStart = blockstart;
					curpage->ColNum = viewport->layout.ColNum;
					curpage->LineAlignment = viewport->layout.LineAlignment;
					curpage->hzdata = viewport->hzdata;
					curpage->ColorNum = viewport->ColorNum; 
					curpage->UnderLine = viewport->layout.UnderLine;
				}

				lastline_y += viewport->page.PageHeight;
				nofirst = False;
				newpage = True;

				if(viewport->horOrder)
				{
					blockstart_y = lastline_y + viewport->page.PageMarginHeight;
				}
				else
				{
					blockstart_y = viewport->page.PageMarginWidth;
				}
	
				if(actionid == TRUEDRAW || actionid == ASIS)
				{
					DrawPageLine(viewport, lastline_y - viewport->viewp.ViewPort_y);
					DrawPageFooter(viewport, lastline_y - viewport->viewp.ViewPort_y, pagenum - 1, actionid);
				}

				if(actionid == PSDRAW)
				{
					char msg[64];

					if(!printset.AllPage)
					{
						if(pagenum > printset.EndPage) { pagenum--; break; }
					}

					PsWriteFooter(viewport, pagenum - 1);       

					fprintf(printset.psfile, "endpage\n%%%%Page: %d\nsave\n0.01 0.01 scale\n50 setlinewidth\n", pagenum);
					
					if(!viewport->origpage.Portrait) fprintf(printset.psfile, "0 %d translate -90 rotate\n",
					PageData[viewport->origpage.PageSetId][1] * 100);
					
					fprintf(printset.psfile, "/P {%d} J\n/F {%d} J\n/SZ {%d %d} J\n/TZ {%.1f %.1f} J\nW [%d 0 0 %d 0 0] Z\n/H {%d} J\n/K {%d} J\n",
					viewport->hzdata.point_width * (100 + viewport->page.CharSpacing) / 100,
					-viewport->hzdata.point_height * (100 + viewport->page.CharSpacing) / 100,
					viewport->hzdata.point_width, 
					viewport->hzdata.point_height, 
					(float)viewport->hzdata.point_width/1000,
					(float)viewport->hzdata.point_height/1000,
					viewport->hzdata.point_width*(100 +
					viewport->page.CharSpacing)/ENGLISHPSPARA, viewport->hzdata.point_height*5/4,
					viewport->hzdata.point_height/8,
					-viewport->hzdata.point_height/8);
				
        				if(printset.ColorPS)
					{
						XGCValues gc_value;
						XColor color;

						XGetGCValues(viewport->resource.dpy,
							     viewport->resource.reverse_gc[0], 
							     GCForeground, &gc_value);

						color.pixel = gc_value.foreground;
						XQueryColor(viewport->resource.dpy,
							    DefaultColormap(viewport->resource.dpy,
							    DefaultScreen(viewport->resource.dpy)),
							    &color);

						fprintf(printset.psfile, "%4.2f %4.2f %4.2f C\n", (float)color.red/65535.,
							(float)color.green/65535., (float)color.blue/65535.);

						fprintf(printset.psfile, "0 0 M ");

						if(viewport->origpage.Portrait)
						{
							fprintf(printset.psfile, "0 %d L %d %d L %d 0 L ",
								PageData[viewport->origpage.PageSetId][1] * 100,  
								PageData[viewport->origpage.PageSetId][0] * 100,
								PageData[viewport->origpage.PageSetId][1] * 100,
								PageData[viewport->origpage.PageSetId][0] * 100);
						}
						else
						{
							fprintf(printset.psfile, "0 %d L %d %d L %d 0 L ",
								PageData[viewport->origpage.PageSetId][0] * 100,
								PageData[viewport->origpage.PageSetId][1] * 100,
								PageData[viewport->origpage.PageSetId][0] * 100,
								PageData[viewport->origpage.PageSetId][1] * 100);
						}

						fprintf(printset.psfile, "closepath fill\n");

						XGetGCValues(viewport->resource.dpy,
						             viewport->resource.gc[viewport->ColorNum], 
							     GCForeground, &gc_value);

						color.pixel = gc_value.foreground;
						XQueryColor(viewport->resource.dpy,
							    DefaultColormap(viewport->resource.dpy,
							    DefaultScreen(viewport->resource.dpy)),
							    &color);

						fprintf(printset.psfile, "%4.2f %4.2f %4.2f C\n", (float)color.red/65535.,
						        (float)color.green/65535., (float)color.blue/65535.);

					}

                                        sprintf(msg, "Cancel Printing? (Page %d)", pagenum);
                                        ErrorChgMsg(msg);
				}

				if(actionid == GIFLINEDRAW || actionid == GIFPAGEDRAW)
				{
					char msg[64];

					if(!gifset.AllPage)
					{
						if(pagenum > gifset.EndPage) { pagenum--; break; }
					}

					if(actionid == GIFPAGEDRAW)
					{
						DrawPageFooter(viewport, viewport->page.PageHeight, pagenum - 1, actionid);
						MyPutPixmapToGif(viewport, pagenum-1);
						GifClear(viewport);
					}

					sprintf(msg, "Cancel GIF Generation? (Page %d)", pagenum);
					ErrorChgMsg(msg);

				}
		
				switch(actionid)
				{
					case VIRDRAW:
					case PSDRAW:
					case INVIRDRAW:
					case GIFLINEDRAW:
					case GIFPAGEDRAW:

					lastline_y = 0;
					blockstart_y = viewport->horOrder ? viewport->page.PageMarginHeight : viewport->page.PageMarginWidth;
				}
			}
			
			switch(actionid)
			{
				case VIRDRAW:
				case PSDRAW:
				case REVCURSEARCH:
				case INVIRDRAW:
			   	case GIFLINEDRAW:
				case GIFPAGEDRAW:
				
				continue;
			}
			
			if((viewport->horOrder ? blockstart_y : lastline_y) >= viewport->viewp.ViewPort_y + viewport->draw.DrawPos_y + viewport->draw.DrawLen_y + viewport->hzdata.point_height) break;

		} while(*blockstart != '\0' && lineinc != 0 && updown < 2);

		switch(actionid)
		{
			case VIRDRAW:
			case INVIRDRAW:
		
			viewport->page.MaxPageNum = pagenum;
			if(curpage->Next != NULL)
			{
				pagetmp = curpage->Next;
				curpage->Next = NULL;	
				curpage = pagetmp;
	
				do
				{
					pagetmp = curpage->Next;
					free(curpage);
					curpage = pagetmp;
				} while(curpage != NULL);
			}
	
			if(actionid == INVIRDRAW)
			{
				if(origpage != pagenum) VerScroBarExpose(viewport);
			
				sprintf(num, "Page: %d (of %d)\0", viewport->viewp.ViewPortPage, viewport->page.MaxPageNum);

				XtSetArg(args[0], XmNlabelString, XmStringCreate(num, XmSTRING_DEFAULT_CHARSET));
				XtSetValues(viewport->resource.PageBtn, args, 1);
			}
	
			UnBusyWindows();
			break;

			case TRUEDRAW:
			
			sprintf(num, "Page: %d (of %d)\0", viewport->viewp.ViewPortPage, viewport->page.MaxPageNum);

			XtSetArg(args[0], XmNlabelString, XmStringCreate(num, XmSTRING_DEFAULT_CHARSET));
			XtSetValues(viewport->resource.PageBtn, args, 1);

			case ASIS:
		
			DrawPageLine(viewport, lastline_y - viewport->viewp.ViewPort_y + viewport->page.PageHeight);
			DrawPageFooter(viewport, lastline_y - viewport->viewp.ViewPort_y + viewport->page.PageHeight, pagenum, actionid);
			HorScroBarPos(viewport);
			VerScroBarPos(viewport);
			DrawMyCursor(viewport, False);

			if(actionid != TRUEDRAW) break;

			case EXPOSEDR: 

			UnBusyWindows();

			break;
	
			case SCANEND:
		
			if(updown >= 1)
			{
				if(updown != 2)
				{
					if(viewport->cursor.ColNum == 1 && viewport->cursor.MoveColNum == 1 && coln == 1) viewport->draw.DrawPos_y += (viewport->horOrder ? -inputlasth : inputlasth);
					else
					{
						if(viewport->horOrder) 
							viewport->draw.DrawPos_y = blockstart_y - viewport->viewp.ViewPort_y;
						else 
							viewport->draw.DrawPos_y = viewport->page.PageWidth - blockstart_y - viewport->viewp.ViewPort_x;
						if(viewport->draw.DrawPos_y < 0) viewport->draw.DrawPos_y = 0;
						viewport->draw.DrawPos_x = 0;
						viewport->draw.DrawLen_x = (viewport->horOrder ? viewport->viewp.ViewPortWidth : viewport->viewp.ViewPortHeight);
					}

					if(viewport->horOrder) 
						viewport->draw.DrawLen_y = viewport->viewp.ViewPortHeight - viewport->draw.DrawPos_y;
					else
					{
						viewport->draw.DrawLen_y = viewport->draw.DrawPos_y;
						viewport->draw.DrawPos_y = 0;
					}
				}
				else
				{
					if(overcol)
					{
						viewport->draw.DrawLen_y = blockend_y - blockstart_y;

						if(viewport->horOrder) 
						{
							viewport->draw.DrawPos_y = blockstart_y - viewport->viewp.ViewPort_y;
						}
						else
						{
							viewport->draw.DrawPos_y = viewport->page.PageWidth - blockstart_y - viewport->viewp.ViewPort_x - viewport->draw.DrawLen_y;
						}

						if(viewport->draw.DrawPos_y < 0) 
						{
							viewport->draw.DrawLen_y += viewport->draw.DrawPos_y;
							viewport->draw.DrawPos_y = 0;
						}
						viewport->draw.DrawLen_x += (col_width + viewport->page.PageColSpacing) * (mycol - startcol);
					}
				}

				if(!viewport->horOrder) 
				{
					i = viewport->draw.DrawLen_x;
					viewport->draw.DrawLen_x = viewport->draw.DrawLen_y;
					viewport->draw.DrawLen_y = i;

					i = viewport->draw.DrawPos_x;
					viewport->draw.DrawPos_x = viewport->draw.DrawPos_y;
					viewport->draw.DrawPos_y = i;
				}

				if(viewport->draw.DrawLen_x + viewport->draw.DrawPos_x > viewport->viewp.ViewPortWidth)
					viewport->draw.DrawLen_x = viewport->viewp.ViewPortWidth - viewport->draw.DrawPos_x;
				if(viewport->draw.DrawLen_y + viewport->draw.DrawPos_y > viewport->viewp.ViewPortHeight)
					viewport->draw.DrawLen_y = viewport->viewp.ViewPortHeight - viewport->draw.DrawPos_y;

				if(viewport->draw.DrawPos_x == 0) x_s = 0;
				else x_s = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (viewport->draw.DrawPos_x * viewport->zoom
				/ 100), XmPIXELS);

				if(viewport->draw.DrawPos_y == 0) y_s = 0;
				else y_s = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (viewport->draw.DrawPos_y *
				viewport->zoom / 100), XmPIXELS);

				if(viewport->draw.DrawLen_x == 0) x_e = 0;
				else x_e = XmConvertUnits(viewport->resource.WorkArea, XmHORIZONTAL, Xm100TH_POINTS, (viewport->draw.DrawLen_x *
				viewport->zoom / 100), XmPIXELS) + 1;

				if(viewport->draw.DrawLen_y == 0) y_e = 0;
				else y_e = XmConvertUnits(viewport->resource.WorkArea, XmVERTICAL, Xm100TH_POINTS, (viewport->draw.DrawLen_y *
				viewport->zoom / 100), XmPIXELS) + 1;

				XClearArea(viewport->resource.dpy, viewport->resource.wind,
					   x_s, y_s, 
					   x_e, y_e,
					   False);
		
				viewport->cursor.CurPtr = viewport->cursor.newcurptr;
				viewport->cursor.MoveCurPtr = viewport->cursor.newcurptr;
				MyDrawPage(viewport, ASIS);
				viewport->cursor.MoveCurPtr = viewport->cursor.CurPtr;
				viewport->cursor.StartCurPtr = viewport->cursor.CurPtr;
				viewport->cursor.EndCurPtr = viewport->cursor.CurPtr;
			}

			break;

			case UPDOWNAR:
			
			UpDownAroInput(viewport, laslastheight, lastheight);
	
			break;
	
			case PSDRAW:
		
			PsWriteFooter(viewport, pagenum);

			fprintf(printset.psfile, "endpage\n%%%%Trailer\nend\n");
			UnBusyWindows();

			break;
	
			case GIFPAGEDRAW:

			DrawPageFooter(viewport, viewport->page.PageHeight, pagenum, actionid);
			MyPutPixmapToGif(viewport, pagenum);
			XFreePixmap(viewport->resource.dpy, gifset.pixmap);

			case GIFLINEDRAW:
			
			if(zoom != 100)
			{
				viewport->zoom = zoom;
				ZoomOpr(viewport, 0);
			}
			
			UnBusyWindows();
			break;
		}
	}
}	

