/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

int Global_Big;

int rmanysamecomponent();
int rmtypedcomponent();

unsigned short *insert(target, source, n)
unsigned short *target, *source;
int n;
{
	int i;
	unsigned short *copy;

	if(*target == 0)
	{
		target = DBcpy(target, source, n);
	}
	else
	{
		copy = (unsigned short *)DBdup(target);

		target = DBcpy(target, source, n);
		DBcat(target, copy);
		free(copy);
	}

	return(target);
}

unsigned short *delete(source, nbytes)
unsigned short *source;
int nbytes;
{
	int i;
	unsigned short *target, *text;

	target = source - 1;

	if(nbytes == 1 && *target == ']')
	{
		text = target;
			
		while(*text == ']')
		{	
			for(i=0; i < MAXIDNUM; i++)
			{
				if(*text-- == '[')
				{
					if(*text-- == '@') 
					{
						source = text + 1;
						target = text;
						break;
					}
				}
			}
		}
	}
	else
	{
		/*for(i=1; i < nbytes; i++, target--);
		*/
		target = source - nbytes; 
	}

	if(target < active_viewport->EditFile) target = active_viewport->EditFile;

	text = target;
	
	if(target == source) return(text);
	
	while(*source != 0) *target++ = *source++;

	*target = 0;

	return(text);
}

unsigned short *escbackhead(text)
unsigned short *text;
{
	int i;
	unsigned short *cp;

	text--;
	cp = text;	
	while(*text == ']')
	{	
		for(i=0; i < MAXIDNUM; i++)
		{
			if(*text-- == '[')
			{
				if(*text-- == '@')
				{
					cp = text;
					i = 0;
					break;
				}
			}
		}
	}
	return(cp);
}

unsigned short *escforehead(text)
unsigned short *text;
{
	int i;
	unsigned short *tmp;

	text++;
	while(*text == '@' && *(text+1) == '[')	
	{
		tmp = text;
		for(i = 0; *text != ']' && i < MAXIDNUM; text++, i++);
		if(*text != ']' && i >= MAXIDNUM) return(tmp);	
		text++;	
	}
	return(text);
}

int CheckCurrentPage(viewport)
VIewportdata *viewport;
{
	PAgedata *curpage;
	
	for(curpage = viewport->page.PageRoot; curpage->PageStart <= viewport->cursor.CurPtr && curpage->Next != NULL;
	    curpage = curpage->Next);

	if(curpage->Next == NULL && curpage->PageStart <= viewport->cursor.CurPtr)
	{
		if(viewport->cursor.CurPtr > viewport->EditFile + DBlen(viewport->EditFile))
		{
			viewport->cursor.CurPtr = viewport->EditFile + DBlen(viewport->EditFile);
		}
	}
	else if(curpage->Last != NULL) curpage = curpage->Last;

	if(viewport->viewp.ViewPort_y >= viewport->page.PageHeight - viewport->page.PageMarginHeight) viewport->viewp.ViewPort_y = 0;  

	if(viewport->viewp.CurPage == curpage) return(False);
	
	viewport->viewp.CurPage = curpage;
	viewport->viewp.ViewPortPage = curpage->PageNum;

	return(True);
}

int Input(viewport, actionid, str, num)
VIewportdata *viewport;
int actionid;
unsigned short *str;
int num;
{
	unsigned short *tmp, *searchprt, chrmem;
	int nextactionid = SMALLAFF, bigcut = False, i, j;
	static long int set_StartPtr, set_EndPtr, set_TmpSPtr, set_TmpEPtr;
	static long int cur_CurPtr, cur_newcurptr, cur_MoveCurPtr, cur_StartCurPtr, cur_EndCurPtr, cur_LastStartCurPtr, cur_LastEndCurPtr;
	GRaphe *picPrt;
	unsigned char *sp;
		
	if(DBlen(viewport->EditFile) + num >= viewport->sizeunit*(long)FILE_SIZE_UNIT)
	{
		set_StartPtr = viewport->set.StartPtr - viewport->EditFile;
		set_EndPtr = viewport->set.EndPtr - viewport->EditFile;
		set_TmpSPtr = viewport->set.TmpSPtr - viewport->EditFile;
		set_TmpEPtr = viewport->set.TmpEPtr - viewport->EditFile;
		cur_CurPtr = viewport->cursor.CurPtr - viewport->EditFile;
		cur_newcurptr = viewport->cursor.newcurptr - viewport->EditFile;
		cur_MoveCurPtr = viewport->cursor.MoveCurPtr - viewport->EditFile;
		cur_StartCurPtr = viewport->cursor.StartCurPtr - viewport->EditFile;
		cur_EndCurPtr = viewport->cursor.EndCurPtr - viewport->EditFile;
		cur_LastStartCurPtr = viewport->cursor.LastStartCurPtr - viewport->EditFile;
		cur_LastEndCurPtr = viewport->cursor.LastEndCurPtr - viewport->EditFile;
	
		while(DBlen(viewport->EditFile) + num >= viewport->sizeunit*(long)FILE_SIZE_UNIT) viewport->sizeunit++;
		tmp = (unsigned short *)realloc(viewport->EditFile, viewport->sizeunit*(long)FILE_SIZE_UNIT*sizeof(unsigned short));
		if(tmp == NULL) { ErrorPopup("Can not locate enough memory!"); return NONEACT; }

		viewport->set.StartPtr = tmp + set_StartPtr;
		viewport->set.EndPtr = tmp + set_EndPtr;
		viewport->set.TmpSPtr = tmp + set_TmpSPtr;
		viewport->set.TmpEPtr = tmp + set_TmpEPtr;
		viewport->cursor.CurPtr = tmp + cur_CurPtr;
		viewport->cursor.newcurptr = tmp + cur_newcurptr;
		viewport->cursor.MoveCurPtr =  tmp + cur_MoveCurPtr;
		viewport->cursor.StartCurPtr = tmp + cur_StartCurPtr;
		viewport->cursor.EndCurPtr = tmp + cur_EndCurPtr;
		viewport->cursor.LastStartCurPtr = tmp + cur_LastStartCurPtr;
		viewport->cursor.LastEndCurPtr = tmp + cur_LastEndCurPtr;
		viewport->cursor.RedrawCurPtr = viewport->cursor.CurPtr;

		viewport->EditFile = tmp;

		MyDrawPage(viewport, VIRDRAW);
	}
	
	if(num <= 0) return NONEACT;

	viewport->changed = True;
	viewport->autosavechanged = True;
	viewport->virdrawn = False;
	
	if(viewport->undo.ContentPtr != NULL) 
	{
		free(viewport->undo.ContentPtr);
		viewport->undo.ContentPtr = NULL;
	}

	viewport->undo.lastmode = UDNONE;

	if(actionid == KEYINPUT || actionid == VIRINPUT)
	{
		if(viewport->cursor.StartCurPtr != viewport->cursor.EndCurPtr)
		{
			chrmem = *viewport->cursor.EndCurPtr;
			*viewport->cursor.EndCurPtr = '\0';

			viewport->undo.ContentPtr = (unsigned short*)DBdup(viewport->cursor.StartCurPtr);
			viewport->undo.lastmode |= UDDELETE;

			*viewport->cursor.EndCurPtr = chrmem;

			i = (int)(viewport->cursor.EndCurPtr - viewport->cursor.StartCurPtr);

			if(viewport->viewp.CurPage->Next != NULL)
			{
				if(((int)(viewport->viewp.CurPage->Next->PageStart - viewport->viewp.CurPage->PageStart))/3 < i)
					bigcut = True;
			}
			else
			{
				if(viewport->viewp.CurPage->Last != NULL)
				{
					if(((int)(viewport->viewp.CurPage->PageStart - viewport->viewp.CurPage->Last->PageStart))/3 < i) bigcut = True;
				}
				else if(DBlen(viewport->viewp.CurPage->PageStart)/3 < i) bigcut = True;
			}
			
			for(tmp = viewport->cursor.StartCurPtr; tmp < viewport->cursor.EndCurPtr; tmp++)
				if(*tmp == '\n' || (*tmp == '@' && *(tmp + 1) == '[' && ( *(tmp + 2) == 'A' || *(tmp + 2) == 'C' || *(tmp + 2) == 'G' ))) { nextactionid = BIGAFF; break; }

			viewport->cursor.CurPtr = delete(viewport->cursor.EndCurPtr, i);
			
			if(viewport->cursor.StartCurPtr != viewport->cursor.MoveCurPtr)
				DeleteCharSet(viewport, &viewport->cursor.hzdata, &viewport->cursor.Mohzdata,
							viewport->cursor.ColNum, viewport->cursor.MoveColNum,
							viewport->cursor.LineAlignment, viewport->cursor.MoveLineAlignment,
							viewport->cursor.ColorNum, viewport->cursor.MoveColorNum,
							viewport->cursor.UnderLine, viewport->cursor.MoveUnderLine);
			else
				DeleteCharSet(viewport,	&viewport->cursor.Mohzdata, &viewport->cursor.hzdata,
							viewport->cursor.MoveColNum, viewport->cursor.ColNum,
							viewport->cursor.MoveLineAlignment, viewport->cursor.LineAlignment,
							viewport->cursor.MoveColorNum, viewport->cursor.ColorNum,
							viewport->cursor.MoveUnderLine, viewport->cursor.UnderLine);
			
			viewport->cursor.CurPtr -= rmanysamecomponent(viewport->cursor.CurPtr, WHOLESEARCHCL);

			viewport->undo.InsertPtr = viewport->cursor.EndCurPtr = viewport->cursor.newcurptr = viewport->cursor.StartCurPtr = viewport->cursor.CurPtr;
			
			if(bigcut && actionid != VIRINPUT) 
			{
				nextactionid = CLEARDRAW;
				CheckCurrentPage(viewport);
			}
			else if(nextactionid == SMALLAFF) nextactionid = BLOCKDELETED;
		}
	}

	*(str + num) = '\0';
	
	switch(actionid)
	{
		case KEYINPUT:
		case VIRINPUT:

			viewport->undo.InsertPtr = viewport->cursor.CurPtr;

			if(num == 1)
			{
				viewport->undo.numofinput = 1;
				viewport->undo.numofbyteinput = 1;

				switch(*str)	
				{
					case '\x7f':
					case '\b':
						if(nextactionid == SMALLAFF)
						{
							if(viewport->cursor.CurPtr <= viewport->EditFile)
							{
								nextactionid = NONEACT;
								break;
							}

							tmp = escbackhead(viewport->cursor.CurPtr);	
							viewport->cursor.CurPtr = tmp + 1;
							
							if(tmp >= viewport->EditFile)
							{
								if(*tmp == '\n') nextactionid = BIGAFF;

								viewport->undo.InsertPtr = tmp;
								viewport->undo.lastmode |= UDDELETE;
								
								tmp++;
								
								chrmem = *tmp;
								*tmp = '\0';
								
								viewport->undo.ContentPtr = (unsigned short*)DBdup(viewport->undo.InsertPtr);
								
								*tmp = chrmem;

								viewport->cursor.CurPtr = delete(viewport->cursor.CurPtr, 1);
						
								Global_Big = False;
								
								viewport->cursor.CurPtr -= rmanysamecomponent(viewport->cursor.CurPtr,
								WHOLESEARCHCL);
							
								viewport->cursor.newcurptr = viewport->cursor.CurPtr;

								if(Global_Big) nextactionid = CLEARDRAW;
								
								if(tmp == viewport->viewp.CurPage->PageStart && CheckCurrentPage(viewport))
									nextactionid = CLEARDRAW;
							}	
							else nextactionid = NONEACT;
						}
						break;
					case '\n':
					case '\r':
						*str = '\n';
						viewport->cursor.newcurptr = insert(viewport->cursor.CurPtr, str, num);
						viewport->undo.lastmode |= UDINPUT;	
						nextactionid = BIGAFF;
						break;
				
					default: 
						viewport->cursor.newcurptr = insert(viewport->cursor.CurPtr, str, num);
						viewport->undo.numofbyteinput = DBbytelen(str);
						viewport->undo.lastmode |= UDINPUT;
				}	
			}
			else 
			{
				for(i = 0, tmp = str; i < num; i++, tmp++)
				{
					if(*tmp == '@' && *(tmp + 1) == '[' && *(tmp + 2) == 'G')
					{
						i += 2;
						tmp += 2;
                                                for(searchprt = tmp, j = 0; *searchprt != '\0' && *searchprt != ']' && j < MAXIDNUM; searchprt++, j++);
 
                                                if(j >= MAXIDNUM)
                                                {
                                                        continue;
                                                }

						tmp++; 
                                                chrmem = *searchprt;
                                                *searchprt = '\0';
 
                                                sp = DBstrdup(tmp);
 
                                                *searchprt = chrmem;
						tmp = searchprt;
						i += j;

						if(sp)
						{
							if(! UpdatePicture(viewport, sp))
							{
								nextactionid = BIGAFF;
							}
							free(sp);
						}
					}
					else if(*tmp == '\n') { nextactionid = BIGAFF; }
				}

				viewport->cursor.newcurptr = insert(viewport->cursor.CurPtr, str, num);
				viewport->undo.numofbyteinput = DBbytelen(str);
				viewport->undo.numofinput = num;
				viewport->undo.lastmode |= UDINPUT;
			}

			break;

		case CHARSETINS1:
			viewport->set.TmpSPtr = viewport->cursor.CurPtr;	
			viewport->cursor.newcurptr = insert(viewport->cursor.CurPtr, str, num);
			viewport->set.TmpEPtr = viewport->cursor.newcurptr;
			viewport->cursor.CurPtr = viewport->cursor.newcurptr;
			break;

		case CHARSETINS2:
			viewport->set.TmpSPtr = viewport->cursor.CurPtr;	
			viewport->set.TmpEPtr = insert(viewport->cursor.CurPtr, str, num);
			break;
		
		case CHARSETINS3:
			viewport->set.TmpSPtr = viewport->cursor.MoveCurPtr;
			viewport->set.TmpEPtr = insert(viewport->cursor.MoveCurPtr, str, num);
			break;

	}

	if(actionid == KEYINPUT)
	{
		tmp = viewport->cursor.CurPtr;
		viewport->cursor.CurPtr = viewport->cursor.newcurptr;
		viewport->cursor.CurActionId = RIGHTSHIFTED;
		if(nextactionid == CLEARDRAW) LeftRightAroInput(viewport, False);
		else LeftRightAroInput(viewport, True);
		viewport->cursor.CurPtr = tmp;
	}

	if(nextactionid == BLOCKDELETED) nextactionid = SMALLAFF;

	return nextactionid;
}

int rmanysamecomponent(cp, mode) 
unsigned short *cp;
int mode;
{
	int i, sizeID = 0, fontID = 0, colID = 0, aliID = 0, colrID = 0, undrID = 0, del = 0, count = 0;
	unsigned short *start, *end, *source, *target, *tmp;

	if(mode == LEFTANY || mode == RIGHTANY)
	{
		sizeID = 1; fontID = 1; colID = 1; aliID = 1; colrID = 1; undrID = 1;
	
		if(mode == LEFTANY) mode = LEFTSEARCH;
		else	mode = RIGHTSEARCH;
	}

	end = cp;
	while(*end == '@' && *(end+1) == '[' && mode != LEFTSEARCH)
	{
		if(*(end+2) == 'G') break;
		tmp = end;
		for(i = 0, end += 2; *end != ']' && i < MAXIDNUM; end++, i++);
		
		if(*end != ']' && i >= MAXIDNUM)
		{
			end = tmp;
			break;
		}

		end++;	
		while (*end == '\n') end++; 
	}

	if(*end == '\0' || *(end+1)== '\0')
	{
		sizeID = 1; fontID = 1; colID = 1; aliID = 1; colrID = 1; undrID = 1;
	}

	end--;
	start = end;

	if(mode == RIGHTSEARCH && (start+1) <= cp) return 0;

	while(*start == ']' || *start == '\n')
	{
	
		if(start <= active_viewport->EditFile) break;

		if(*start == '\n') 
		{
			start--;
			end = start;	
		}
		else
		{
			for(i=0; i < MAXIDNUM; i++)
			{
				if(*start-- == '[')
				{
					if(*start == '@')
					{
						start += 2;

						if(*start >= '0' && *start <= '9') { del = sizeID; sizeID = 1;}
						if(*start >= 'a' && *start <= 'z') { del = fontID; fontID = 1;}
						if(*start == 'C') { if(colID) Global_Big = True; del = colID; colID = 1;}
						if(*start == 'A') { if(aliID) Global_Big = True; del = aliID; aliID = 1;}
						if(*start == 'Z') { del = colrID; colrID = 1;}
						if(*start == 'U') { del = undrID; undrID = 1;}
						if(*start == 'G') return(count); 

						if(del) 
						{
							source = end + 1;
							target = start - 2;
							
							if(target < active_viewport->EditFile) target = active_viewport->EditFile;
							if(target == source) return(count);

							while(*source != '\0') *target++ = *source++;
							
							*target = *source;
							
							del = 0;
							if(mode != WHOLESEARCHCL || (start-2) < cp) count += i + 2;	
						
							if(target <= active_viewport->EditFile) return(count);
						}
					
						start -= 3;
						end = start;    
						break;	
					}
				}
			
				if(mode == RIGHTSEARCH && (start+1) <= cp) return(count);
			}
		}

		if(mode == RIGHTSEARCH && (start+1) <= cp) return(count);
	}
	return(count);
}

int rmtypedcomponent(start, end, mask) 
unsigned short *start, *end;
int mask;
{
	int mymask = 0, count = 0, i;
	unsigned short *source, *target, *cp;

	while(start <= end)
	{
		for(; *start != '@' && start < end; start++);
		
		if(start <= (end-3))
		{
			if(*(start+1) != '[')
			{
				start++;
				continue;
			}
			else
			{
				target = start; 
				start += 2;
				
				if(*start >= '0' && *start <= '9') mymask |= SizeMask;
				if(*start >= 'a' && *start <= 'z') mymask |= FontMask;
				if(*start == 'C') mymask |= ColumnMask;
				if(*start == 'A') mymask |= AlignmentMask;
				if(*start == 'Z') mymask |= ColorMask;
				if(*start == 'U') mymask |= UnderLineMask;
				if(*start == 'G') mymask |= GraphicsMask;

				if(mymask & mask) 
				{
					start = target;
					cp = end;

					for(i = 0, source = start; *source != ']' && source <= end && i < MAXIDNUM; source++, cp--, count++, i++);
					
					if(*source != ']' && source > end) break;	
					else 
					{ 
						if(*source == ']')
						{
							cp--; 
							source++; 
							count++;

							while(*source != '\0') *target++ = *source++;
							
							*target = *source;
							end = cp;	
						}
					}
				}

				mymask = 0;
			}
		}
		else break;	
	}
	return(count);
}

