/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

void ChangeTypedSet(viewport, idtype, colnum, startcol, endcol, opid1, opid2)
VIewportdata *viewport;
char *idtype;
int colnum, startcol, endcol, opid1, opid2;
{
	unsigned char line[5];
	unsigned short InputPtr[20];
	int i, NumOfInput;

	InputPtr[0] = 0x00;

	if(colnum != startcol)
	{
		line[0] = '0' + colnum; line[1] = '\0';
		DBstrcat(InputPtr, "@[");
		DBstrcat(InputPtr, idtype);	
		DBstrcat(InputPtr, line);
		DBstrcat(InputPtr, "]");
	}

	NumOfInput = DBlen(InputPtr);

	if(NumOfInput > 0)
	{
		Input(viewport, opid1, InputPtr, NumOfInput);
		viewport->set.StartPtr = viewport->set.TmpEPtr;

		if(opid2 != CHARSETINS2)
		{
			viewport->cursor.EndCurPtr += NumOfInput;
			
			if(opid2 == CHARSETINS1)
				viewport->cursor.CurPtr = viewport->cursor.EndCurPtr;
			else
				viewport->cursor.MoveCurPtr = viewport->cursor.EndCurPtr;
		}
	}
	else
	{
		if(opid1 == CHARSETINS3) viewport->set.StartPtr = viewport->cursor.MoveCurPtr;
		else viewport->set.StartPtr = viewport->cursor.CurPtr;
	}

	InputPtr[0] = 0x00;

	if(colnum != endcol)
	{
		line[0] = '0' + endcol; line[1] = '\0';
		DBstrcat(InputPtr, "@[");
		DBstrcat(InputPtr, idtype);      
		DBstrcat(InputPtr, line);
		DBstrcat(InputPtr, "]");
	}

	NumOfInput = DBlen(InputPtr);
	if(NumOfInput > 0) 
	{
		Input(viewport, opid2, InputPtr, NumOfInput);
		viewport->set.EndPtr = viewport->set.TmpSPtr;
	}
	else
	{
		if(opid2 == CHARSETINS3) viewport->set.TmpEPtr = viewport->set.EndPtr = viewport->cursor.MoveCurPtr;
		else viewport->set.TmpEPtr = viewport->set.EndPtr = viewport->cursor.CurPtr;
	}
}

void LayoutSet(viewport, newvalue, id, pos, movepos, mask)
VIewportdata *viewport;
int newvalue, *pos, *movepos, mask;
char *id;
{
	int i, j;
	
	if(viewport->cursor.StartCurPtr == viewport->cursor.EndCurPtr)
	{
		ChangeTypedSet(viewport, id, newvalue, *pos, *pos, CHARSETINS1, CHARSETINS2);
		viewport->cursor.CurPtr -= rmanysamecomponent(viewport->cursor.CurPtr, LEFTSEARCH);
		viewport->cursor.MoveCurPtr = viewport->cursor.StartCurPtr = viewport->cursor.EndCurPtr = viewport->cursor.newcurptr = viewport->cursor.CurPtr;
		*pos = *movepos = newvalue;
	}
	else
	{
		viewport->cursor.RedrawCurPtr = viewport->cursor.StartCurPtr;
		
		if(viewport->cursor.StartCurPtr == viewport->cursor.CurPtr)
		{
			ChangeTypedSet(viewport, id, newvalue, *pos, *movepos, CHARSETINS1, CHARSETINS3);
			j = rmanysamecomponent(viewport->set.EndPtr, WHOLESEARCHCL);
			viewport->set.EndPtr -= j;
			j += rmtypedcomponent(viewport->set.StartPtr, viewport->set.EndPtr, mask);
			i = rmanysamecomponent(viewport->set.StartPtr, WHOLESEARCHCL);
			viewport->cursor.CurPtr = viewport->set.StartPtr - i;
			viewport->cursor.MoveCurPtr = viewport->set.TmpEPtr - i - j;
			viewport->cursor.StartCurPtr = viewport->cursor.CurPtr;
			viewport->cursor.EndCurPtr = viewport->cursor.MoveCurPtr;
			*pos = newvalue;
		}
		else
		{
			ChangeTypedSet(viewport, id, newvalue, *movepos, *pos, CHARSETINS3, CHARSETINS1);
			viewport->cursor.CurPtr = viewport->set.EndPtr;
			i = rmanysamecomponent(viewport->set.EndPtr, WHOLESEARCHCL);
			viewport->set.EndPtr -= i;
			i += rmtypedcomponent(viewport->set.StartPtr, viewport->set.EndPtr, mask);
			j = rmanysamecomponent(viewport->set.StartPtr, WHOLESEARCH);
			viewport->cursor.CurPtr = viewport->set.TmpEPtr - i - j;
			viewport->cursor.newcurptr -= i + j;
			viewport->cursor.MoveCurPtr = viewport->set.StartPtr - j;
			viewport->cursor.StartCurPtr = viewport->cursor.MoveCurPtr;
			viewport->cursor.EndCurPtr = viewport->cursor.CurPtr;
			*movepos = newvalue;
		}
	}
}

void ColumnSetCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	LayoutSet(active_viewport ,(int) client_data, "C", &active_viewport->cursor.ColNum, &active_viewport->cursor.MoveColNum, ColumnMask);
	MyDrawPage(active_viewport, INVIRDRAW);
	CheckCurrentPage(active_viewport);
	MyDrawPage(active_viewport, CLEARDRAW);
}

void AlignmentSetCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	LayoutSet(active_viewport ,(int) client_data, "A", &active_viewport->cursor.LineAlignment, &active_viewport->cursor.MoveLineAlignment, AlignmentMask);
	MyDrawPage(active_viewport, INVIRDRAW);
	CheckCurrentPage(active_viewport);
	MyDrawPage(active_viewport, CLEARDRAW);
}

void ColorSetCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	LayoutSet(active_viewport ,(int) client_data, "Z", &active_viewport->cursor.ColorNum, &active_viewport->cursor.MoveColorNum, ColorMask);
	MyDrawPage(active_viewport, INVIRDRAW);
	MyDrawPage(active_viewport, ONLYHILITE);
}

void UnderLineSetCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
        LayoutSet(active_viewport ,(int) client_data, "U", &active_viewport->cursor.UnderLine, &active_viewport->cursor.MoveUnderLine, UnderLineMask);
	MyDrawPage(active_viewport, INVIRDRAW);
	MyDrawPage(active_viewport, ONLYHILITE);
}

