/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

void ClosePageNumCB();
void DoPageGoNumCB();
int PageGoNum();

PageButton pagebtn;

int PageGoNum(viewport)
VIewportdata *viewport;
{	
	char *line = NULL;
	Arg args[1];
	int pagenum;
	PAgedata *curpage;

	if(viewport->virdrawn == False)
	{
		viewport->cursor.RedrawCurPtr = viewport->cursor.CurPtr;
		MyDrawPage(viewport, INVIRDRAW);
	}

	XtSetArg(args[0], XmNvalue, &line);
	XtGetValues(pagebtn.PageNumWg, args, 1);

	sscanf(line, "%d", &pagenum);

	XtFree(line);

	if(pagenum == viewport->viewp.ViewPortPage) return(True);
	if(pagenum < 1 || pagenum > viewport->page.MaxPageNum) { ErrorPopup("Wrong Page Number!"); return(False); }

	for(curpage = viewport->page.PageRoot; pagenum != curpage->PageNum && curpage->Next != NULL;
	    curpage = curpage->Next);

	if(pagenum != curpage->PageNum) return;

	viewport->viewp.CurPage = curpage;
	viewport->viewp.ViewPortPage = pagenum;

	MyDrawPage(viewport, CLEARDRAW);
	
	return(True);
}


void CreatePageNum(parent)
Widget parent;
{
	Widget Btn, label;

	Arg args[MAX_ARGS];
	register int n;

	pagebtn.PopUpWg = XtCreatePopupShell("page Button", transientShellWidgetClass, parent, NULL, 0);

	n = 0;
	XtSetArg(args[n], XmNheight, 80); n++;
	XtSetArg(args[n], XmNwidth, 180); n++;
	XtSetArg(args[n], XmNmarginHeight, 10); n++;
	XtSetArg(args[n], XmNmarginWidth, 10); n++;
	XtSetArg(args[n], XmNhorizontalSpacing, 0); n++;
	XtSetArg(args[n], XmNverticalSpacing, 5); n++;
	XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE); n++;
	pagebtn.Root = XmCreateForm(pagebtn.PopUpWg, "GotoPage", args, n);
	XtManageChild(pagebtn.Root);
	XtAddCallback(pagebtn.Root, XmNdestroyCallback, MainDestroyCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Goto Page:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
	label = XmCreateLabelGadget(pagebtn.Root, "GoLabel", args, n);
	XtManageChild(label);
							
	n = 0;
	XtSetArg(args[n], XmNwidth, 50); n++;
	XtSetArg(args[n], XmNscrollHorizontal, False); n++;
	XtSetArg(args[n], XmNscrollVertical, False); n++;
	XtSetArg(args[n], XmNresizeHeight, False); n++;
	XtSetArg(args[n], XmNresizeWidth, False); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetArg(args[n], XmNmaxLength, 3); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
	pagebtn.PageNumWg = XmCreateText(pagebtn.Root, "GoPage", args, n); 
	XtManageChild(pagebtn.PageNumWg);

	n = 0;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, pagebtn.PageNumWg); n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
	pagebtn.TotalLWg = XmCreateLabelGadget(pagebtn.Root, "TotalL", args, n);
	XtManageChild(pagebtn.TotalLWg);
							
	n = 0;
	XtSetArg(args[n], XmNwidth, 80); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Ok", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
	Btn = XmCreatePushButtonGadget(pagebtn.Root, "okBtn", args, n);
	XtManageChild(Btn);
	XtAddCallback(Btn, XmNactivateCallback, DoPageGoNumCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNwidth, 80); n++;   
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Cancel", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, Btn); n++;
	Btn = XmCreatePushButtonGadget(pagebtn.Root, "closeBtn", args, n);
	XtManageChild(Btn);
	XtAddCallback(Btn, XmNactivateCallback, ClosePageNumCB, NULL);

	XtRealizeWidget(pagebtn.PopUpWg);
}

void PageBtnCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	Arg args[1];
	char line[30];

	active_viewport = (VIewportdata *)client_data;	

	sprintf(line, "%d\0", active_viewport->viewp.ViewPortPage);
	XtSetArg(args[0], XmNvalue, line); 
	XtSetValues(pagebtn.PageNumWg, args, 1);

	sprintf(line, "of %d\0", active_viewport->page.MaxPageNum);
	XtSetArg(args[0], XmNlabelString, XmStringCreate(line, XmSTRING_DEFAULT_CHARSET));
	XtSetValues(pagebtn.TotalLWg, args, 1);

	PopupPosition(active_viewport->resource.PopUpShell, pagebtn.PopUpWg);	
	XtPopup(pagebtn.PopUpWg, XtGrabExclusive); 
}

void DoPageGoNumCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	if(!PageGoNum(active_viewport)) return;
	XtPopdown(pagebtn.PopUpWg);
}

void ClosePageNumCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	XtPopdown(pagebtn.PopUpWg);
}

