/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

void CancelPageDelCB();
void DoPageDelCB();
int PageDel();

PageDelMenu pagedel;

int PageDel(viewport)
VIewportdata *viewport;
{	
	char *line = NULL;
	Arg args[1];
	int strpg, endpg;
	PAgedata *curpage;

	if(viewport->virdrawn == False)
	{
		viewport->cursor.RedrawCurPtr = viewport->cursor.CurPtr;
		MyDrawPage(viewport, INVIRDRAW);
	}

	XtSetArg(args[0], XmNvalue, &line);
	XtGetValues(pagedel.StrPgWg, args, 1);

	sscanf(line, "%d", &strpg);

	XtFree(line);

	XtSetArg(args[0], XmNvalue, &line);
	XtGetValues(pagedel.EndPgWg, args, 1);

	sscanf(line, "%d", &endpg);

	XtFree(line);

	if(strpg < 1 || endpg > viewport->page.MaxPageNum || strpg > endpg) { ErrorPopup("Wrong Page Number!"); return(False); }
	
	for(curpage = viewport->page.PageRoot; curpage->PageNum < strpg && curpage->Next != NULL; curpage = curpage->Next);

	viewport->cursor.CurPtr = curpage->PageStart;
	viewport->cursor.hzdata = curpage->hzdata;
	viewport->cursor.ColNum = curpage->ColNum;
	viewport->cursor.LineAlignment = curpage->LineAlignment;
	viewport->cursor.ColorNum = curpage->ColorNum;	
	viewport->cursor.UnderLine = curpage->UnderLine;
	viewport->cursor.StartCurPtr = viewport->cursor.CurPtr;

	for(; curpage->PageNum < endpg && curpage->Next != NULL; curpage = curpage->Next);

	if(curpage->Next != NULL)
	{
		curpage = curpage->Next;
		viewport->cursor.MoveCurPtr = curpage->PageStart;
		viewport->cursor.Mohzdata = curpage->hzdata;
		viewport->cursor.MoveColNum = curpage->ColNum;
		viewport->cursor.MoveLineAlignment = curpage->LineAlignment;
		viewport->cursor.MoveColorNum = curpage->ColorNum; 
		viewport->cursor.MoveUnderLine = curpage->UnderLine;
		viewport->cursor.EndCurPtr = viewport->cursor.MoveCurPtr;
	}
	else
	{
		viewport->cursor.MoveCurPtr = curpage->PageStart + DBlen(curpage->PageStart);	
		viewport->cursor.Mohzdata = viewport->cursor.hzdata;
		viewport->cursor.MoveColNum = viewport->cursor.ColNum;
		viewport->cursor.MoveLineAlignment = viewport->cursor.MoveLineAlignment;
		viewport->cursor.MoveColorNum = viewport->cursor.ColorNum;	
		viewport->cursor.MoveUnderLine = viewport->cursor.UnderLine;
		viewport->cursor.EndCurPtr = viewport->cursor.MoveCurPtr;      
	}

	viewport->cursor.RedrawCurPtr = viewport->cursor.CurPtr;
	Input(viewport, KEYINPUT, delID, 1);
	MyDrawPage(viewport, INVIRDRAW);
	MyDrawPage(viewport, CLEARDRAW);

	return(True);
}


void CreatePageDel(parent)
Widget parent;
{
	Widget label;

	Arg args[MAX_ARGS];
	register int n;

	pagedel.PopUpWg = XtCreatePopupShell("pagedel Window", transientShellWidgetClass, parent, NULL, 0);

	n = 0;
	XtSetArg(args[n], XmNheight, 125); n++;
	XtSetArg(args[n], XmNwidth, 155); n++;
	XtSetArg(args[n], XmNhorizontalSpacing, 0); n++;
	XtSetArg(args[n], XmNverticalSpacing, 0); n++;
	XtSetArg(args[n], XmNrubberPositioning, True); n++;
	pagedel.Root = XmCreateForm(pagedel.PopUpWg, "CharDel", args, n);
	XtManageChild(pagedel.Root);
	XtAddCallback(pagedel.Root, XmNdestroyCallback, MainDestroyCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("From Page:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 20); n++;
	XtSetArg(args[n], XmNy, 20); n++;
	label = XmCreateLabelGadget(pagedel.Root, "StPLabel", args, n);
	XtManageChild(label);
							
	n = 0;
	XtSetArg(args[n], XmNwidth, 50); n++;
	XtSetArg(args[n], XmNscrollHorizontal, False); n++;
	XtSetArg(args[n], XmNscrollVertical, False); n++;
	XtSetArg(args[n], XmNresizeHeight, False); n++;
	XtSetArg(args[n], XmNresizeWidth, False); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetArg(args[n], XmNmaxLength, 3); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	XtSetArg(args[n], XmNy, 15); n++;
	pagedel.StrPgWg = XmCreateText(pagedel.Root, "StartP", args, n); 
	XtManageChild(pagedel.StrPgWg);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("  To Page:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 20); n++;
	XtSetArg(args[n], XmNy, 45); n++;
	label = XmCreateLabelGadget(pagedel.Root, "EndPLabel", args, n);
	XtManageChild(label);
							
	n = 0;
	XtSetArg(args[n], XmNwidth, 50); n++;
	XtSetArg(args[n], XmNscrollHorizontal, False); n++;
	XtSetArg(args[n], XmNscrollVertical, False); n++;
	XtSetArg(args[n], XmNresizeHeight, False); n++;
	XtSetArg(args[n], XmNresizeWidth, False); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetArg(args[n], XmNmaxLength, 3); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	XtSetArg(args[n], XmNy, 45); n++;
	pagedel.EndPgWg = XmCreateText(pagedel.Root, "EndPg", args, n); 
	XtManageChild(pagedel.EndPgWg);

	n = 0;
	XtSetArg(args[n], XmNwidth, 60); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Delete", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 20); n++;
	XtSetArg(args[n], XmNy, 80); n++;
	pagedel.DelBtn = XmCreatePushButtonGadget(pagedel.Root, "pgdelBtn", args, n);
	XtManageChild(pagedel.DelBtn);
	XtAddCallback(pagedel.DelBtn, XmNactivateCallback, DoPageDelCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNwidth, 60); n++;   
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Cancel", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, pagedel.DelBtn); n++;
	XtSetArg(args[n], XmNy, 80); n++;
	pagedel.CancelBtn = XmCreatePushButtonGadget(pagedel.Root, "closeBtn", args, n);
	XtManageChild(pagedel.CancelBtn);
	XtAddCallback(pagedel.CancelBtn, XmNactivateCallback, CancelPageDelCB, NULL);

	XtRealizeWidget(pagedel.PopUpWg);
}

void PageDelCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	Arg args[1];
	char line[10];

	active_viewport = (VIewportdata *)client_data;	

	sprintf(line, "%d\0", active_viewport->viewp.ViewPortPage);
	XtSetArg(args[0], XmNvalue, line); 
	XtSetValues(pagedel.StrPgWg, args, 1);

	XtSetArg(args[0], XmNvalue, line); 
	XtSetValues(pagedel.EndPgWg, args, 1);

	PopupPosition(active_viewport->resource.PopUpShell, pagedel.PopUpWg);
	XtPopup(pagedel.PopUpWg, XtGrabExclusive); 
}

void DoPageDelCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	if(!PageDel(active_viewport)) return;
	XtPopdown(pagedel.PopUpWg);
}

void CancelPageDelCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	XtPopdown(pagedel.PopUpWg);
}

