/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

void CancelPrintCB();
void DoPrintCB();
int PsPrint();

PrintMenu printset;

void PsPopup(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
        XtPopup(printset.PopUpWg, XtGrabExclusive);
}

void PsScanTitler(mystat, FontNum, cp)
unsigned char mystat[];
int FontNum;
unsigned short *cp;
{
	int i;

	if(FontNum == 0) FontNum = 1;
	
	for(; *cp != '\0'; cp++)
	{
		if(ISHZ(*cp))
		{
			mystat[(FontNum-1)*HZ_TOTAL_NUM + *cp] = 0xff;
		}
	}
}

void psscan(viewport)
VIewportdata *viewport;
{
	char *FontID, FontSid;
	HBF *hbf;
	HZdata hzdata;
	int i, j, k, ok, pagenum, TotalNum = 6, FontNum = SearchFontList(GlobalDefaults.fontname), TotalFontNum = TotalNumOfFont();
	int FontType, width, height, x_disp, y_disp;
	unsigned short *cp, *searchprt, chrmem;
	PAgedata *curpage;
	unsigned char *sp, *mystat = (unsigned char *)malloc(TotalFontNum*HZ_TOTAL_NUM);
	static unsigned char image[12*96];

	if(mystat == NULL) return;
	for(i = 0; i < TotalFontNum*HZ_TOTAL_NUM; i++)  mystat[i] = 0x00;

	if(printset.AllPage) cp = viewport->EditFile;
	else
	{
		for(curpage = viewport->page.PageRoot, pagenum = curpage->PageNum; pagenum < printset.StartPage && curpage->Next != NULL;
		    curpage = curpage->Next, pagenum = curpage->PageNum);
		cp = curpage->PageStart;
		FontNum = SearchFontList(curpage->hzdata.FontId);	
	}

	if(FontNum == 0) FontNum = 1;

	for(; *cp != '\0'; cp++)
	{
		if(!printset.AllPage)
		{
			if(cp > curpage->PageStart && curpage->Next != NULL) 
			{
				pagenum++;
				if(curpage->Next != NULL) curpage = curpage->Next;
				if(pagenum > printset.EndPage + 1) break;	
			}
		}

		if(ISHZ(*cp))
		{
			mystat[(FontNum-1)*HZ_TOTAL_NUM + *cp] = 0xff;
		}
		
		if(*cp == '@' )
		{
			searchprt = cp;
			searchprt++;

			if(*searchprt++ == '[')
			{
				if(*searchprt >= 'a' && *searchprt <= 'z')
				{
					cp += 2;
					for(searchprt = cp, i = 0; *searchprt != '\0' && *searchprt != ']' && i < MAXIDNUM; searchprt++, i++);
					if(i >= MAXIDNUM) continue;

					chrmem = *searchprt;
					*searchprt = '\0';
					sp = (unsigned char *)DBstrdup(cp);

					i = SearchFontList(sp);
					if(i > 0) FontNum = i;
					*searchprt = chrmem;
					cp = searchprt;
					free(sp);	
				}
			}
		}
	}

	if(viewport->titler.text) PsScanTitler(mystat, SearchFontList(viewport->titler.hzdata.FontId), viewport->titler.text);
	if(viewport->footer.text) PsScanTitler(mystat, SearchFontList(viewport->footer.hzdata.FontId), viewport->footer.text);
	if(viewport->pndata.texta) PsScanTitler(mystat, SearchFontList(viewport->pndata.hzdata.FontId), viewport->pndata.texta);
	if(viewport->pndata.textb) PsScanTitler(mystat, SearchFontList(viewport->pndata.hzdata.FontId), viewport->pndata.textb);

	
	for(i = 0; i < TotalFontNum; i++)
	{
		FontType = GetFontType(i+1);
		k = i*HZ_TOTAL_NUM;

	        while( XtAppPending(app) )
                {
                        XtAppProcessEvent(app, XtIMAll);
                }

		if( LongProcCancelFlg ) break;
 

		for(j = 0; j < HZ_TOTAL_NUM; j++)
		{
			if(mystat[k+j])
			{
				if(FontType == HBFONT || ttfset.Font[i].BitMap) TotalNum++;
				else TotalNum += 2;
			}
		}
	}

	fprintf(printset.psfile, "/CHdict %d dict def\n\
CHdict begin\n", TotalNum);
	
	for(i = 1; i <= TotalFontNum; i++)
	{	
                while( XtAppPending(app) )
                {
                        XtAppProcessEvent(app, XtIMAll);
                }
 
		if( LongProcCancelFlg ) break;

		hbf = GetFontHandleFrIndex(i);
		FontID = GetFontId(i);
		FontType = GetFontType(i);
		
		if(FontType == HBFONT) 
		{
			HBF_GetBitmapBoundingBox(hbf, &width, &height, &x_disp, &y_disp);
		}
		else
		{
			width = ttfset.Font[i-1].Size;
			hzdata.hbf = hbf;
			hzdata.hz_sheight = width;
			hzdata.hz_swidth = width;
		}

		switch(width)
		{
			case 96: FontSid = 'Z'; break;
			case 88: FontSid = 'Y'; break;
			case 80: FontSid = 'X'; break;
			case 72: FontSid = 'W'; break;
			case 64: FontSid = 'A'; break;
			case 56: FontSid = 'B'; break; 
			case 48: FontSid = 'C'; break; 
			case 40: FontSid = 'D'; break; 
			case 32: FontSid = 'E'; break; 
			case 24: FontSid = 'F'; break;  
			case 16: FontSid = 'U'; break;  
			default: FontSid = 'F';
		}

		for(j = 0; j < HZ_TOTAL_NUM; j++)
		{
			if(mystat[(i-1)*HZ_TOTAL_NUM + j])
			{
				if(FontType == HBFONT)
				{
					fprintf(printset.psfile, "/%sx%x {%cA <", FontID, j, FontSid);
					ok = (HBF_GetBitmap(hbf, j, image) == 0);

					if (!ok)
					{
						ok = HBF_GetBitmap(hbf, GB_SQUARE, image);
					}
					for(k=0; k < width*((width+7)/8); k++)
						fprintf(printset.psfile, "%02x", image[k]);
					fprintf(printset.psfile, "> I G} J\n");
				}
				else
				{
					if(ttfset.Font[i-1].BitMap)
					{
						fprintf(printset.psfile, "/%sx%x {%cA <", FontID, j, FontSid);

						TTF_GetBitmap(&hzdata, image, j, MSBFirst);

						for(k=0; k < width*((width+7)/8); k++)
							fprintf(printset.psfile, "%02x", image[k]);
						fprintf(printset.psfile, "> I G} J\n");
					}
					else
					{
						while( XtAppPending(app) )
                        			{
                                			XtAppProcessEvent(app, XtIMAll);
                        			}
 
						if( LongProcCancelFlg ) break;

						fprintf(printset.psfile, "/%sx%x {OA ", FontID, j);
						if(PS_TTF_GetChar(hbf, j, printset.psfile, FontID, j) == -1)
						{
							fprintf(printset.psfile, "G} J\n");
							fprintf(printset.psfile, "/%sx%xdict 1 dict def %sx%xdict begin end\n", FontID, j, FontID, j);
						}
					}
				}
			}
		}
	}

	free(mystat);
	fprintf(printset.psfile, "%%%%EndProlog\n");
}

void psheader(order)
int order;
{
	fprintf(printset.psfile, "%%!PS-Adobe-3.0\n\
%%%%Title\n\
%%%%BeginProlog\n\
/J {bind def} bind def\n\
/endpage {showpage restore} J\n\
/B /begin load def\n\
/E /end load def\n\
/G /grestore load def\n\
/I /imagemask load def\n\
/M /moveto load def\n\
/R /rmoveto load def\n\
/L /lineto load def\n\
/N /curveto load def\n\
/S /show load def\n\
/Q /fill load def\n\
/ZA {gsave currentpoint translate SZ scale 96 96 true [96 0 0 -96 0 96]} J\n\
/YA {gsave currentpoint translate SZ scale 88 88 true [88 0 0 -88 0 88]} J\n\
/XA {gsave currentpoint translate SZ scale 80 80 true [80 0 0 -80 0 80]} J\n\
/WA {gsave currentpoint translate SZ scale 72 72 true [72 0 0 -72 0 72]} J\n\
/AA {gsave currentpoint translate SZ scale 64 64 true [64 0 0 -64 0 64]} J\n\
/BA {gsave currentpoint translate SZ scale 56 56 true [56 0 0 -56 0 56]} J\n\
/CA {gsave currentpoint translate SZ scale 48 48 true [48 0 0 -48 0 48]} J\n\
/DA {gsave currentpoint translate SZ scale 40 40 true [40 0 0 -40 0 40]} J\n\
/EA {gsave currentpoint translate SZ scale 32 32 true [32 0 0 -32 0 32]} J\n\
/FA {gsave currentpoint translate SZ scale 24 24 true [24 0 0 -24 0 24]} J\n\
/UA {gsave currentpoint translate SZ scale 16 16 true [16 0 0 -16 0 16]} J\n\
/OA {gsave currentpoint translate TZ scale} J\n\
/W {/Courier-Bold findfont} J\n\
/Z {makefont setfont} J\n\
/RS {rlineto stroke} J\n\
/C /setrgbcolor load def\n\
/X {P 0 rmoveto} J\n\
/Y {0 H rmoveto} J\n\
/T {0 K rmoveto} J\n\
");

	if(!order)
	{
		fprintf(printset.psfile, "/V {0 F rmoveto} J\n\
/vshowdict 1 dict def\n\
/vshow\n\
{vshowdict begin\n\
/thestring exch def\n\
gsave currentpoint translate -90 rotate\n\
Y thestring show\n\
grestore\n\
end\n\
}def\n\
/VS {dup vshow stringwidth pop neg 0 exch rmoveto} J\n\
");
	}

}

int PsPrint(viewport)
VIewportdata *viewport;
{	
	char *line = NULL;
	Arg args[1];
	FILE *fp;
	char *cp, msg[100];
	int updateprtcmd = False;

	if(!printset.AllPage)
	{
		XtSetArg(args[0], XmNvalue, &line);
		XtGetValues(printset.StartPgWg, args, 1);

		sscanf(line, "%d", &printset.StartPage);
	
		XtFree(line);

		XtSetArg(args[0], XmNvalue, &line);
		XtGetValues(printset.EndPgWg, args, 1);

		sscanf(line, "%d", &printset.EndPage);

		XtFree(line);
	
		if(printset.StartPage < 1 || printset.EndPage > viewport->page.MaxPageNum || printset.StartPage > printset.EndPage)
		{
			ErrorFuncPopup("Wrong Page Number!", PsPopup, NULL);
			return(True);
		}
	}
	
	if(printset.Printer) 
	{
		XtSetArg(args[0], XmNvalue, &line);
		XtGetValues(printset.PrintCmdWg, args, 1);
		
		if(printset.PrCmd)
		{
			updateprtcmd = strcmp(line, printset.PrCmd);
			if(updateprtcmd)
			{
				free(printset.PrCmd);
				printset.PrCmd = NULL;
			}
		}
		else updateprtcmd = True;
		
		if(updateprtcmd) 
		{
			if(strlen(line))
			{
				printset.PrCmd = strdup(line);
		
				if((fp = My_path_open(getenv(CONF_FILE_PATH), PRINT_CMD_FILE, "w")))
				{
					fprintf(fp, "%s\n", line);
					fclose(fp);
				}
			}
			else printset.PrCmd = NULL;
		}
		
		XtFree(line);

		if(printset.PrCmd == NULL || strlen(printset.PrCmd) == 0) 
		{ 
			ErrorFuncPopup("No Print Commond!", PsPopup, NULL);
			return(True);
		}

		printset.psfile = fopen("/tmp/chpowerprt.tmp", "w");
	
		if(printset.psfile == NULL)
		{
			ErrorFuncPopup("Print Commond Error!", PsPopup, NULL);
			return(True);
		}
	}
	else
	{
		XtSetArg(args[0], XmNvalue, &line);
		XtGetValues(printset.PsFileWg, args, 1);
	
		if(line == NULL)
		{
			ErrorFuncPopup("No PS File Name!", PsPopup, NULL);
			return(True);
		}

		if(strlen(line) == 0)
		{
			XtFree(line);
			ErrorFuncPopup("No PS File Name!", PsPopup, NULL);
			return(True);
		}
		
		printset.psfile = fopen(line, "w"); 	
		
		if(printset.psfile == NULL)
		{
			XtFree(line);
			ErrorFuncPopup("PS File Open Failure!", PsPopup, NULL);
			return(True);
		}    
	}
	
	BusyWindows();

        if(viewport->virdrawn == False)
        {
                viewport->cursor.RedrawCurPtr = viewport->cursor.CurPtr;
                MyDrawPage(viewport, INVIRDRAW);
        };

	LongProcCancelFlg = False;

	if(printset.AllPage)

		sprintf(msg, "Cancel Printing? (Page 1)");
	else
		sprintf(msg, "Cancel Printing? (Page %d)", printset.StartPage);

        ErrorFuncPopup(msg, LongProcCancelCB, &LongProcCancelFlg);

	psheader(viewport->horOrder);
	psscan(viewport);

	if( !LongProcCancelFlg ) MyDrawPage(viewport, PSDRAW);

	CriticalGoing = False;

	fclose(printset.psfile);

	if( LongProcCancelFlg )
	{
		if(printset.Printer)
		{
			unlink("/tmp/chpowerprt.tmp");
		}
		else
		{
			unlink(line);
			XtFree(line);
		}

		return(False);
	}
	
	if(printset.Printer) 
	{
		*msg = '\0';
		strcat(msg, printset.PrCmd);
		strcat(msg, " /tmp/chpowerprt.tmp 1>/tmp/chpowerprt.rpt 2>&1");

		if(!((fp = popen(msg, "r"))))
		{
			unlink("/tmp/chpowerprt.tmp");
			ErrorFuncPopup("Print Commond Error!", PsPopup, NULL);
			return(True);
		}
		else
		{
			while((cp = fgets(msg, 99, fp)))
			{
				if(ferror(fp) != 0)
				{
					pclose(fp);
					unlink("/tmp/chpowerprt.tmp");
					ErrorFuncPopup(msg, PsPopup, NULL);
					return(True);
				}
			}
		        pclose(fp);	
		}

		unlink("/tmp/chpowerprt.tmp");

		if(!(fp = fopen("/tmp/chpowerprt.rpt", "r")))
		{
			ErrorFuncPopup("Print Commond Error!", PsPopup, NULL);
			return(True);
		}
		else
		{
			*msg = '\0';
			cp = fgets(msg, 100, fp);
			fclose(fp);
	
			for(cp = msg; *cp != '\0' && *cp != '\n'; cp++);
			*cp = '\0';

			if(strlen(msg) > 0) 
			{ 
				ErrorPopup(msg);
				unlink("/tmp/chpowerprt.rpt");
				return(True);	
			}	
		}	

		unlink("/tmp/chpowerprt.rpt");
	}	
	else
	{
		XtFree(line);
	}

	ErrOkCB();
	
	return(True);
}

void PsFileTextCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	Arg args[1];

	printset.Printer = False;

	XtSetArg(args[0], XmNset, True);
	XtSetValues(printset.FileBtn, args, 1);

	XtSetArg(args[0], XmNset, False);
	XtSetValues(printset.PrinterBtn, args, 1);
}

void PrinterTextCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	Arg args[1];

	printset.Printer = True;

	XtSetArg(args[0], XmNset, True);
	XtSetValues(printset.PrinterBtn, args, 1);

	XtSetArg(args[0], XmNset, False);
	XtSetValues(printset.FileBtn, args, 1);
}

void PartPageTextCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	Arg args[1];

	printset.AllPage = False;

	XtSetArg(args[0], XmNset, True);
	XtSetValues(printset.PartPgBtn, args, 1);

	XtSetArg(args[0], XmNset, False);
	XtSetValues(printset.AllPgBtn, args, 1);
}

void AllPageCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	Arg args[1];

	printset.AllPage = True;
		
	XtSetArg(args[0], XmNset, True);
	XtSetValues(printset.AllPgBtn, args, 1);
		
	XtSetArg(args[0], XmNset, False);
	XtSetValues(printset.PartPgBtn, args, 1);
}

void CreatePrintSet(parent)
Widget parent;
{
	Widget label;
	
	Arg args[MAX_ARGS];
	register int n;
	FILE *fp;
	char *cp, line[50];

	printset.PopUpWg = XtCreatePopupShell("Print Window", transientShellWidgetClass, parent, NULL, 0);
	printset.AllPage = True;
	printset.Printer = True;
	printset.ColorPS = False;

	n = 0;
	XtSetArg(args[n], XmNheight, 175); n++;
	XtSetArg(args[n], XmNwidth, 350); n++;
	XtSetArg(args[n], XmNhorizontalSpacing, 0); n++;
	XtSetArg(args[n], XmNverticalSpacing, 0); n++;
	XtSetArg(args[n], XmNrubberPositioning, True); n++;
	printset.Root = XmCreateForm(printset.PopUpWg, "CharSet", args, n);
	XtManageChild(printset.Root);
	XtAddCallback(printset.Root, XmNdestroyCallback, MainDestroyCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNset, True); n++;
	XtSetArg(args[n], XmNindicatorType, XmONE_OF_MANY); n++;
	XtSetArg(args[n], XmNvisibleWhenOff, True); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("All Pages", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 15); n++;
	printset.AllPgBtn = XmCreateToggleButtonGadget(printset.Root, "AllPg", args,n);
	XtManageChild(printset.AllPgBtn);
	XtAddCallback(printset.AllPgBtn, XmNvalueChangedCallback, AllPageCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNset, False); n++;
	XtSetArg(args[n], XmNindicatorType, XmN_OF_MANY); n++;
	XtSetArg(args[n], XmNvisibleWhenOff, True); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Color", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 40); n++;
	label = XmCreateToggleButtonGadget(printset.Root, "ColPS", args,n);
	XtManageChild(label);
	XtAddCallback(label, XmNvalueChangedCallback, GifToggleCB, &printset.ColorPS);

	n = 0;
	XtSetArg(args[n], XmNset, False); n++;
	XtSetArg(args[n], XmNindicatorType, XmONE_OF_MANY); n++;
	XtSetArg(args[n], XmNvisibleWhenOff, True); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("From:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 130); n++;
	XtSetArg(args[n], XmNy, 15); n++;
	printset.PartPgBtn = XmCreateToggleButtonGadget(printset.Root, "FromPg", args,n);
	XtManageChild(printset.PartPgBtn);
	XtAddCallback(printset.PartPgBtn, XmNvalueChangedCallback, PartPageTextCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNwidth, 50); n++;
	XtSetArg(args[n], XmNscrollHorizontal, False); n++;
	XtSetArg(args[n], XmNscrollVertical, False); n++;
	XtSetArg(args[n], XmNresizeHeight, False); n++;
	XtSetArg(args[n], XmNresizeWidth, False); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetArg(args[n], XmNmaxLength, 3); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, printset.PartPgBtn); n++;
	XtSetArg(args[n], XmNy, 15); n++;
	printset.StartPgWg = XmCreateText(printset.Root, "StartPg", args, n);
	XtManageChild(printset.StartPgWg);
	XtAddCallback(printset.StartPgWg, XmNfocusCallback, PartPageTextCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("To:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 163); n++;
	XtSetArg(args[n], XmNy, 40); n++;
	label = XmCreateLabelGadget(printset.Root, "ToLabel", args, n);
	XtManageChild(label);

	n = 0;
	XtSetArg(args[n], XmNwidth, 50); n++;
	XtSetArg(args[n], XmNscrollHorizontal, False); n++;
	XtSetArg(args[n], XmNscrollVertical, False); n++;
	XtSetArg(args[n], XmNresizeHeight, False); n++;
	XtSetArg(args[n], XmNresizeWidth, False); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetArg(args[n], XmNmaxLength, 3); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	XtSetArg(args[n], XmNy, 40); n++;
	printset.EndPgWg = XmCreateText(printset.Root, "EndPg", args, n); 
	XtManageChild(printset.EndPgWg);
	XtAddCallback(printset.EndPgWg, XmNfocusCallback, PartPageTextCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Set TTF...", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 260); n++;
	XtSetArg(args[n], XmNy, 20); n++;
	label = XmCreatePushButtonGadget(printset.Root, "Btn", args, n);
	XtManageChild(label);
	XtAddCallback(label, XmNactivateCallback, TTFSetCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNset, True);
	XtSetArg(args[n], XmNindicatorType, XmONE_OF_MANY); n++;
	XtSetArg(args[n], XmNvisibleWhenOff, True); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Print Cmd:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 75); n++;
	printset.PrinterBtn = XmCreateToggleButtonGadget(printset.Root, "To Printerg", args,n);
	XtManageChild(printset.PrinterBtn);
	XtAddCallback(printset.PrinterBtn, XmNvalueChangedCallback, PrinterTextCB, NULL);   

	n = 0;
	XtSetArg(args[n], XmNwidth, 240); n++;
	XtSetArg(args[n], XmNscrollHorizontal, False); n++;
	XtSetArg(args[n], XmNscrollVertical, False); n++;
	XtSetArg(args[n], XmNresizeHeight, False); n++;
	XtSetArg(args[n], XmNresizeWidth, False); n++;
	XtSetArg(args[n], XmNmarginHeight, 2); n++;
	XtSetArg(args[n], XmNmarginWidth, 2); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, printset.PrinterBtn); n++;
	XtSetArg(args[n], XmNy, 73); n++;
	printset.PrintCmdWg = XmCreateText(printset.Root, "PrintCmd", args, n); 
	XtManageChild(printset.PrintCmdWg);
	XtAddCallback(printset.PrintCmdWg, XmNfocusCallback, PrinterTextCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNset, False);
	XtSetArg(args[n], XmNindicatorType, XmONE_OF_MANY); n++;
	XtSetArg(args[n], XmNvisibleWhenOff, True); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("To File  :", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 100); n++;
	printset.FileBtn = XmCreateToggleButtonGadget(printset.Root, "To File", args,n);
	XtManageChild(printset.FileBtn);
	XtAddCallback(printset.FileBtn, XmNvalueChangedCallback, PsFileTextCB, NULL);   

	n = 0;
	XtSetArg(args[n], XmNwidth, 240); n++;
	XtSetArg(args[n], XmNscrollHorizontal, False); n++;
	XtSetArg(args[n], XmNscrollVertical, False); n++;
	XtSetArg(args[n], XmNresizeHeight, False); n++;
	XtSetArg(args[n], XmNresizeWidth, False); n++;
	XtSetArg(args[n], XmNmarginHeight, 2); n++;
	XtSetArg(args[n], XmNmarginWidth, 2); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, printset.FileBtn); n++;
	XtSetArg(args[n], XmNy, 98); n++;
	printset.PsFileWg = XmCreateText(printset.Root, "PsFile", args, n); 
	XtManageChild(printset.PsFileWg);
	XtAddCallback(printset.PsFileWg, XmNfocusCallback, PsFileTextCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNwidth, 160); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Print", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 135); n++;
	printset.PrintBtn = XmCreatePushButtonGadget(printset.Root, "printBtn", args, n);
	XtManageChild(printset.PrintBtn);
	XtAddCallback(printset.PrintBtn, XmNactivateCallback, DoPrintCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNwidth, 160); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Cancel", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, printset.PrintBtn); n++;
	XtSetArg(args[n], XmNy, 135); n++;
	printset.CancelBtn = XmCreatePushButtonGadget(printset.Root, "closeBtn", args, n);
	XtManageChild(printset.CancelBtn);
	XtAddCallback(printset.CancelBtn, XmNactivateCallback, CancelPrintCB, NULL);

	if ((fp = My_path_open(getenv(CONF_FILE_PATH), PRINT_CMD_FILE, "r")))
	{
		if((cp=fgets(line,49, fp)))
		{
			for(; *cp != '\n' && *cp != '\0'; cp++);
			*cp = '\0';
			printset.PrCmd = strdup(line);
		}
		else printset.PrCmd = NULL;
		
		fclose(fp);
	}
	else printset.PrCmd = NULL;

	XtRealizeWidget(printset.PopUpWg);
}

void PrintSetCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	Arg args[3];
	char line[80];
	long curpos;

	active_viewport = (VIewportdata *)client_data;	
	
	if(printset.AllPage)
	{
		XtSetArg(args[0], XmNset, True);
		XtSetValues(printset.AllPgBtn, args, 1);

		XtSetArg(args[0], XmNset, False);
		XtSetValues(printset.PartPgBtn, args, 1);
	}
	else
	{
		XtSetArg(args[0], XmNset, True);
		XtSetValues(printset.PartPgBtn, args, 1);

		XtSetArg(args[0], XmNset, False);
		XtSetValues(printset.AllPgBtn, args, 1);
	}

	if(printset.Printer)
	{
		XtSetArg(args[0], XmNset, True);
		XtSetValues(printset.PrinterBtn, args, 1);

		XtSetArg(args[0], XmNset, False);
		XtSetValues(printset.FileBtn, args, 1);
	}
	else
	{
		XtSetArg(args[0], XmNset, True);
		XtSetValues(printset.FileBtn, args, 1);

		XtSetArg(args[0], XmNset, False);
		XtSetValues(printset.PrinterBtn, args, 1);
	}

	curpos = 0;
	
	if(active_viewport->filename) 
	{
		sprintf(line, "%s.ps\0", active_viewport->filename);
		if(strlen(line) > 38)
		{
			curpos = strlen(line) - 38;
		}
	}	
	else line[0] = '\0';

	XtSetArg(args[0], XmNvalue, line);
	XtSetArg(args[1], XmNtopCharacter, (long) curpos);	
	XtSetArg(args[2], XmNcursorPosition, (long) strlen(line));	
	XtSetValues(printset.PsFileWg, args, 3);

	sprintf(line, "%d\0", active_viewport->viewp.CurPage->PageNum);
	XtSetArg(args[0], XmNvalue, line);
	XtSetValues(printset.StartPgWg, args, 1);
	XtSetValues(printset.EndPgWg, args, 1);

	if(printset.PrCmd != NULL)
	{
		curpos = 0;
		if(strlen(printset.PrCmd) > 38)
		{
			curpos = strlen(printset.PrCmd) - 38;
		}

		XtSetArg(args[0], XmNvalue, printset.PrCmd);
		XtSetArg(args[1], XmNtopCharacter, (long) curpos);
		XtSetArg(args[2], XmNcursorPosition, (long) strlen(printset.PrCmd));     
		XtSetValues(printset.PrintCmdWg, args, 3);
	}

	PopupPosition(active_viewport->resource.PopUpShell, printset.PopUpWg);
	XtPopup(printset.PopUpWg, XtGrabExclusive); 
}

void DoPrintCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	XtPopdown(printset.PopUpWg);

	if(!PsPrint(active_viewport))
	{
		XtPopup(printset.PopUpWg, XtGrabExclusive);
	}
}

void CancelPrintCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	
	XtPopdown(printset.PopUpWg);
}

