/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

void ShwDrawCursor(viewport, clear)
SImpleHzWin *viewport;
int clear;
{
	XSegment seg[6];
	int x, y;
	int size;

	x = viewport->cursor.CurPos - viewport->viewp.firstnum;
	y = 2;
	size = SHZW_FONT_SIZE;

	if(x >= 0 && x <= viewport->viewp.width)
	{
		x *= SHZW_FONT_SIZE / 2;

		seg[0].x1 = x; seg[0].y1 = y;
		seg[0].x2 = x; seg[0].y2 = y + size;
		seg[1].x1 = x - 6; seg[1].y1 = y + size;
		seg[1].x2 = x + 6; seg[1].y2 = y + size;
		seg[2].x1 = x - 2; seg[2].y1 = y + size - 1;
		seg[2].x2 = x - 1; seg[2].y2 = y + size - 2;
		seg[3].x1 = x + 2; seg[3].y1 = y + size - 1;
		seg[3].x2 = x + 1; seg[3].y2 = y + size - 2;
	
		if(clear) 
		{
			XDrawSegments(viewport->resource.dpy, viewport->resource.wind, viewport->resource.reverse_gc, seg, 4);
			viewport->cursor.Shown = False;
		}
		else 
		{
			XDrawSegments(viewport->resource.dpy, viewport->resource.wind, viewport->resource.gc, seg, 4);
			viewport->cursor.Shown = True;
		}
	}
}

void SimCurFlash(viewport, id)
SImpleHzWin *viewport;
XtIntervalId *id;
{
	if(viewport->cursor.Shown) ShwDrawCursor(viewport, True);
	else ShwDrawCursor(viewport, False);

	viewport->cursor.TimerId =
	XtAppAddTimeOut(XtWidgetToApplicationContext(viewport->resource.WorkArea),
	500, SimCurFlash, viewport);
}

void HzSimCurFlash(viewport, id)
SImpleHzWin *viewport;
XtIntervalId *id;
{
	if(viewport->cursor.Shown) ShwDrawCursor(viewport, True);
	else ShwDrawCursor(viewport, False);

	HzTimerId = XtAppAddTimeOut(XtWidgetToApplicationContext(viewport->resource.WorkArea), 500, HzSimCurFlash,
	viewport);
}

