/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower 1.0
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#ifndef _SIMPLEHZ_H_
#define _SIMPLEHZ_H_

#define SHZW_FONT_SIZE	16
#define SHZW_MEM_UNIT	256

typedef struct
{
	struct
	{
		int height;
		int width;
		int currentnum;
		int DBcurrentnum;
		int firstnum;	
	} viewp;

	struct
	{
		int Shown;
		int Focused;
		XtIntervalId TimerId;
		int CurPos;
		int DBCurPos;	
		int CurActionId;
		int MoveDir;	
		int MovePos;
		int DBMovePos;	
		int StartPos;
		int DBStartPos;	
		int EndPos;
		int DBEndPos;	
		int LastStartPos;
		int LastEndPos;
	} cursor;

	struct
	{
		Widget WorkArea;
		Display *dpy;
		Window  wind;                   /* drawing toplevel window */
		GC gc;                          /* default GC */
		GC reverse_gc;	
	} resource;
	
	unsigned short *EditFile;
} SImpleHzWin;

#endif /*_SIMPLEHZ_H_*/

