/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include 	"chpower.h"

HZdata ShwHzdata;

void DrawSimpleHzWin();

void InitialSimpleHZWin()
{
	InitSingleFont(&ShwHzdata, GlobalDefaults.fontname, SHZW_FONT_SIZE, SHZW_FONT_SIZE);
}

int SimpleHzWinMoveLeft(viewport, offset)
SImpleHzWin *viewport;
int offset;
{
	if(viewport->viewp.firstnum == 0) return(False);

	if(viewport->viewp.firstnum > offset)
	{
		viewport->viewp.firstnum -= offset;
		viewport->cursor.MovePos -= offset;
	}
	else
	{
		viewport->viewp.firstnum = 0;
		viewport->cursor.MovePos = 0;
	}

	DrawSimpleHzWin(viewport, REVCURSEARCH);
	DrawSimpleHzWin(viewport, MOVESEARCH);

	return(True);
}

int SimpleHzWinMoveRight(viewport, offset)
SImpleHzWin *viewport;
int offset;
{
	if(viewport->viewp.firstnum >= viewport->viewp.currentnum - viewport->viewp.width + 10) return(False);

	if(viewport->viewp.firstnum + offset < viewport->viewp.currentnum - viewport->viewp.width + 10)
	{
		viewport->viewp.firstnum += offset;
		viewport->cursor.MovePos += offset;
	}
	else
	{
		viewport->viewp.firstnum = viewport->viewp.currentnum - viewport->viewp.width + 10;
		viewport->cursor.MovePos = viewport->viewp.currentnum;
	}

	DrawSimpleHzWin(viewport, REVCURSEARCH);
	DrawSimpleHzWin(viewport, MOVESEARCH);

	return(True);
}

void ShwLeftCurMove(viewport)
SImpleHzWin *viewport;
{
	viewport->cursor.DBCurPos--;
	viewport->cursor.CurPos = DBbytenlen(viewport->EditFile, viewport->cursor.DBCurPos);
}

void ShwRightCurMove(viewport)
SImpleHzWin *viewport;
{
	viewport->cursor.DBCurPos++;
	viewport->cursor.CurPos = DBbytenlen(viewport->EditFile, viewport->cursor.DBCurPos);
}

void ShwLeftRightAroInput(viewport)
SImpleHzWin *viewport;
{
	int escout = 1;
	
	switch(viewport->cursor.CurActionId)
	{
		case LEFT:  
			if(viewport->cursor.DBCurPos > 0)
			{
				ShwDrawCursor(viewport, True);
				ShwLeftCurMove(viewport);
			}
			break;
		case RIGHT:
			if(viewport->cursor.DBCurPos < viewport->viewp.DBcurrentnum)
			{
				ShwDrawCursor(viewport, True); 
				ShwRightCurMove(viewport);
			}
			break;
	}
	
	if(viewport->cursor.StartPos != viewport->cursor.EndPos) 
	{
		DrawSimpleHzWin(viewport, UNHIGHLITE);
	}
	
	ShwDrawCursor(viewport, False); 

	viewport->cursor.StartPos = viewport->cursor.EndPos = viewport->cursor.CurPos;

	if(viewport->cursor.CurPos < viewport->viewp.firstnum)
	{
		SimpleHzWinMoveLeft(viewport, 10);
		DrawSimpleHzWin(viewport, TRUEDRAW);
	}
	
	if(viewport->cursor.CurPos  >= viewport->viewp.firstnum + viewport->viewp.width) 
	{
		SimpleHzWinMoveRight(viewport, 10);
		DrawSimpleHzWin(viewport, TRUEDRAW);
	}

	viewport->cursor.EndPos = viewport->cursor.StartPos = viewport->cursor.MovePos = viewport->cursor.CurPos;
	viewport->cursor.LastStartPos = viewport->cursor.LastEndPos = viewport->cursor.CurPos;
}

void DrawSimpleHzWin(viewport, actionid)
SImpleHzWin *viewport;
int actionid;
{
	int cur_length = 0, charwidth, i, x = - viewport->viewp.firstnum * SHZW_FONT_SIZE / 2, y = 2;
	int DBcount = 0;
	
	unsigned short *cp;

	if(actionid == NONEACT) return;

	switch(actionid)
	{
		case TRUEDRAW:
		case BIGAFF:
		case SMALLAFF:
		XClearWindow(viewport->resource.dpy, viewport->resource.wind);
		actionid = TRUEDRAW;
	
		case EXPOSEDR:

		actionid = TRUEDRAW;
		break;

		case VIRDRAW:

		viewport->viewp.currentnum = DBbytelen(viewport->EditFile);
		viewport->viewp.DBcurrentnum = DBlen(viewport->EditFile);
		return;

		case LEFTRIGHTAR:

		ShwLeftRightAroInput(viewport);
		return;
	}

	cp = viewport->EditFile;

	if ISHZ(*cp)
		charwidth = 2;
	else
		charwidth = 1;

	while(*cp != '\0')
	{
		
		if(cur_length >= viewport->viewp.firstnum && cur_length <= viewport->viewp.firstnum + viewport->viewp.width)
		{
			switch(actionid)
			{
				case HIGHLITE:
				
				if(viewport->cursor.LastStartPos == viewport->cursor.StartPos)
				{
					if(viewport->cursor.LastEndPos > viewport->cursor.EndPos)
					{
						if(cur_length >= viewport->cursor.EndPos && cur_length < viewport->cursor.LastEndPos)
						{
							MyDrawCharacter(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.gc,
									x + cur_length * SHZW_FONT_SIZE / 2,
									y,
									*cp,
									&(ShwHzdata),
									1);
						}
						else if(cur_length >= viewport->cursor.LastEndPos) return;
					}
					else
					{
						if(cur_length >= viewport->cursor.LastEndPos && cur_length < viewport->cursor.EndPos)
						{
							MyDrawCharacter(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.reverse_gc,
									x + cur_length * SHZW_FONT_SIZE / 2,
									y,
									*cp,
									&(ShwHzdata),
									1);
						}
						else if(cur_length >= viewport->cursor.EndPos) return;
					}
				}
				else
				{
					if(viewport->cursor.LastEndPos == viewport->cursor.EndPos)
					{
						if(viewport->cursor.LastStartPos < viewport->cursor.StartPos)
						{
							if(cur_length >= viewport->cursor.LastStartPos && cur_length <
							viewport->cursor.StartPos)
							{
								MyDrawCharacter(viewport->resource.dpy,
										viewport->resource.wind,
										viewport->resource.gc,
										x + cur_length * SHZW_FONT_SIZE / 2,
										y,
										*cp,
										&(ShwHzdata),
										1);
							}
							else if(cur_length >= viewport->cursor.StartPos) return;
						}
						else
						{
							if(cur_length >= viewport->cursor.StartPos && cur_length <
							viewport->cursor.LastStartPos)
							{
								MyDrawCharacter(viewport->resource.dpy,
										viewport->resource.wind,
										viewport->resource.reverse_gc,
										x + cur_length * SHZW_FONT_SIZE / 2,
										y,
										*cp,
										&(ShwHzdata),
										1 );
							}
							else if(cur_length >= viewport->cursor.LastStartPos) return;
						}
					}
					else
					{
						if(cur_length >= viewport->cursor.StartPos && cur_length < viewport->cursor.EndPos)
						{
							MyDrawCharacter(viewport->resource.dpy,
									viewport->resource.wind,
									viewport->resource.reverse_gc,
									x + cur_length * SHZW_FONT_SIZE / 2,
									y,
									*cp,
									&(ShwHzdata),
									1 );
						}
						else
						{
							if(cur_length >= viewport->cursor.LastStartPos && cur_length <
							viewport->cursor.LastEndPos)
							{
								MyDrawCharacter(viewport->resource.dpy,
										viewport->resource.wind,
										viewport->resource.gc,
										x + cur_length * SHZW_FONT_SIZE / 2,
										y,
										*cp,
										&(ShwHzdata),
										1 );
							}
							else
							{
								if(viewport->cursor.LastStartPos == viewport->cursor.EndPos)
									if(cur_length >= viewport->cursor.LastEndPos) return;
								else
									if(cur_length >= viewport->cursor.EndPos) return;
							}
						}
					}
				}
				break;

				case UNHIGHLITE:

				if(cur_length >= viewport->cursor.StartPos && cur_length < viewport->cursor.EndPos)
					MyDrawCharacter(viewport->resource.dpy,
							viewport->resource.wind,
							viewport->resource.gc,
							x + cur_length * SHZW_FONT_SIZE / 2,
							y,
							*cp,
							&(ShwHzdata),
							1 );
				else if(cur_length >= viewport->cursor.EndPos) return;
				break;

				case TRUEDRAW:

				if(cur_length >= viewport->cursor.StartPos && cur_length < viewport->cursor.EndPos)
					MyDrawCharacter(viewport->resource.dpy, 
							viewport->resource.wind, 
							viewport->resource.reverse_gc, 
							x + cur_length * SHZW_FONT_SIZE / 2,
							y,
							*cp,
							&(ShwHzdata),
							1 );
				else
					MyDrawCharacter(viewport->resource.dpy,
							viewport->resource.wind,
							viewport->resource.gc,
							x + cur_length * SHZW_FONT_SIZE / 2,
							y,
							*cp,
							&(ShwHzdata),
							1 );

				break;

				case CURSEARCH:

				if(viewport->cursor.CurPos >= cur_length && viewport->cursor.CurPos < cur_length + charwidth)
				{
					viewport->cursor.CurPos = cur_length;
					viewport->cursor.DBCurPos = DBcount;	
					return;
				}
				break;

				case MOVESEARCH:

				if(viewport->cursor.MovePos >= cur_length && viewport->cursor.MovePos < cur_length + charwidth)
				{
					viewport->cursor.MovePos = cur_length;
					viewport->cursor.DBMovePos = DBcount;	
					return;
				}	
			}
		}
		else
		{
			switch(actionid)
			{
				case REVCURSEARCH:

				if(viewport->viewp.firstnum >= cur_length && viewport->viewp.firstnum < cur_length + charwidth)
				{
					viewport->viewp.firstnum = cur_length;
					return;
				}
				break;
			}
		}
		
		cur_length += charwidth;

		cp++;
		DBcount++;

		if ISHZ(*cp)
			charwidth = 2;
		else
			charwidth = 1;
		
	}
	
	switch(actionid)
	{
		case TRUEDRAW:
	
		ShwDrawCursor(viewport, False);
		break;

		case CURSEARCH:
							
		viewport->cursor.CurPos = cur_length;
		viewport->cursor.DBCurPos = DBcount;	
		break;

		case MOVESEARCH:
	
		viewport->cursor.MovePos = cur_length;
		viewport->cursor.DBMovePos = DBcount;	
		break;
	}
	
	viewport->viewp.currentnum = DBbytelen(viewport->EditFile);
	viewport->viewp.DBcurrentnum = DBlen(viewport->EditFile);
}

