/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

int shwinsert(target, offset, source, nbytes)
unsigned short *target, *source;
int offset, nbytes;
{
	int i;
	unsigned short *tmp = target, *copy;

	target += offset;

	if(*target == '\0')
	{
		for(i=0; i < nbytes; i++)
		{
			*target++ = *source++;
		}
		*target = '\0';
	}
	else
	{
		copy = (unsigned short *)DBdup(target);

		for(i=0; i < nbytes; i++)
		{
			*target++ = *source++;
		}	
		*target = '\0';
		DBcat(target, copy);
		free(copy);
	}

	return(offset+nbytes);
}

int shwdelete(source, offset, nbytes)
unsigned short *source;
int offset, nbytes;
{
	unsigned short *tmp = source, *target, *text;

	source += offset;
	target = source - nbytes;

	text = target;

	do { *target++ = *source++;
	} while(*source != '\0');

	*target = *source;

	return((int)(text-tmp));
}

int SimpleHzWinInput(viewport, actionid, str, num)
SImpleHzWin *viewport;
int actionid;
unsigned short *str;
int num;
{
	int nextactionid = SMALLAFF;

	if(viewport->viewp.DBcurrentnum + num > SHZW_MEM_UNIT)
	{
		num = SHZW_MEM_UNIT - viewport->viewp.DBcurrentnum - 1;
		XBell(viewport->resource.dpy, 0);
	}
	
	if(num <= 0) return NONEACT;
	
	if(viewport->cursor.StartPos != viewport->cursor.EndPos)
	{
		viewport->cursor.DBCurPos = shwdelete(viewport->EditFile, viewport->cursor.DBEndPos, viewport->cursor.DBEndPos - viewport->cursor.DBStartPos);
		nextactionid = BIGAFF;
	}

	switch(actionid)
	{
		case KEYINPUT:
			if(num == 1)
			{
				switch(*str)	
				{
					case '\x7f':
					case '\b':
						if(nextactionid == SMALLAFF)
						{
							if(viewport->cursor.DBCurPos > 0)
							{
								viewport->cursor.DBCurPos = shwdelete(viewport->EditFile, viewport->cursor.DBCurPos, 1);
							}	
							else nextactionid = NONEACT;	
						}
						break;
					
					default: viewport->cursor.DBCurPos = shwinsert(viewport->EditFile, viewport->cursor.DBCurPos, str, num);
				}	
			}
			else viewport->cursor.DBCurPos = shwinsert(viewport->EditFile, viewport->cursor.DBCurPos, str, num);
			break;
	}

	viewport->cursor.EndPos = viewport->cursor.StartPos = viewport->cursor.CurPos = DBbytenlen(viewport->EditFile, viewport->cursor.DBCurPos);

	viewport->cursor.CurActionId = RIGHTSHIFTED;
	ShwLeftRightAroInput(viewport);

	return nextactionid;
}

