/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

void CancelTitlerCB();
void OkTitlerCB();
void TitlerColorCB();
void TitlerAlignCB();

SHwPopup titlerset;

int TitlerSet(mytitler)
MYViewSHW *mytitler;
{	
	Arg args[5];
	register int n;
	XmString *newfont = NULL;
	char *name = NULL;
	int width, height;

	VIewportdata *viewport = (VIewportdata *) mytitler->viewport;
	
	n = 0;
	XtSetArg(args[n], XmNvalue, &name); n++;
	XtGetValues(titlerset.WidthWg, args, n);

	if(name)
	{
		sscanf(name, "%d", &width);
		XtFree(name); 
	}

	n = 0;
	XtSetArg(args[n], XmNvalue, &name); n++;
	XtGetValues(titlerset.HeightWg, args, n);

	if(name)
	{
		sscanf(name, "%d", &height);
		XtFree(name);
	}
	
	if(height > MAX_FONT_SIZE || width > MAX_FONT_SIZE)     
	{
		ErrorPopup("Font Size is Too Big!");
		return(False);
	}

	if(height < MIN_FONT_SIZE || width < MIN_FONT_SIZE)     
	{
		ErrorPopup("Font Size is Too Small!");
		return(False);
	}

	mytitler->hzdata.point_width = width * 100;
	mytitler->hzdata.point_height = height * 100;

	n = 0;
	XtSetArg(args[n], XmNselectedItems, &newfont); n++;
	XtGetValues(titlerset.HzFontLstWg, args, n);
	if(newfont) XmStringGetLtoR(*newfont, XmSTRING_DEFAULT_CHARSET, &name);

	if(name)
	{
		mytitler->hzdata.hbf = GetFontHandle(name, &mytitler->hzdata.FontId, &mytitler->hzdata.FontType);
		
		if(mytitler->hzdata.FontType == HBFONT) HBF_GetBitmapBoundingBox(mytitler->hzdata.hbf, &(mytitler->hzdata.hz_width), &(mytitler->hzdata.hz_height),
		&width, &height);
		else mytitler->hzdata.hz_width = mytitler->hzdata.hz_height = 24;

		XtFree(name); 
	}

	FontCalc(viewport->resource.WorkArea, &mytitler->hzdata, viewport->zoom);

	mytitler->underline = titlerset.underline;
	mytitler->ColorNum = titlerset.ColorNum;
	mytitler->Position = titlerset.Position;

	if(mytitler->text) 
	{
		free(mytitler->text);
		mytitler->text = NULL;
	}
	
	if(DBlen(titlerset.sviewport.EditFile) > 0)
	{
		mytitler->text = (unsigned short*)DBdup(titlerset.sviewport.EditFile);
	}
	
	viewport->changed = True;
	viewport->autosavechanged = True;

	MyDrawPage(viewport, TRUEDRAW);

	return(True);
}


void CreateTitler(parent)
Widget parent;
{
	Widget label, submenu;

	Arg args[MAX_ARGS];
	register int n;

	titlerset.mapped = False;
	titlerset.underline = False;

	titlerset.PopUpWg = XtCreatePopupShell("Titler Window", transientShellWidgetClass, parent, NULL, 0);

	n = 0;
	XtSetArg(args[n], XmNheight, 310); n++;
	XtSetArg(args[n], XmNwidth, 360); n++;
	XtSetArg(args[n], XmNhorizontalSpacing, 0); n++;
	XtSetArg(args[n], XmNverticalSpacing, 0); n++;
	XtSetArg(args[n], XmNrubberPositioning, True); n++;
	titlerset.Root = XmCreateForm(titlerset.PopUpWg, "TitlSet", args, n);
	XtManageChild(titlerset.Root);
	XtAddCallback(titlerset.Root, XmNdestroyCallback, MainDestroyCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("FOOT NOTE", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 150); n++;
	XtSetArg(args[n], XmNy, 15); n++;
	titlerset.Title = XmCreateLabelGadget(titlerset.Root, "TiLabel", args, n);
	XtManageChild(titlerset.Title);
							
	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Font Type:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 65); n++;
	XtSetArg(args[n], XmNy, 35); n++;
	label = XmCreateLabelGadget(titlerset.Root, "Ftype", args, n);
	XtManageChild(label);
	
	n = 0;
	XtSetArg(args[n], XmNitems, charset.fontlist); n++;
	XtSetArg(args[n], XmNitemCount, TotalNumOfFont()+1); n++;
	XtSetArg(args[n], XmNx, 65); n++;
	XtSetArg(args[n], XmNy, 50); n++;
	XtSetArg(args[n], XmNheight, 150); n++;
	XtSetArg(args[n], XmNwidth, 100); n++;
	titlerset.HzFontLstWg = XmCreateScrolledList(titlerset.Root, "HZfontlist", args, n);
	XtManageChild(titlerset.HzFontLstWg);
	
	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate(" Width:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 185); n++;
	XtSetArg(args[n], XmNy, 50); n++;
	label = XmCreateLabelGadget(titlerset.Root, "Width", args, n);
	XtManageChild(label);

	n = 0;
	XtSetArg(args[n], XmNwidth, 50); n++;
	XtSetArg(args[n], XmNscrollHorizontal, False); n++;
	XtSetArg(args[n], XmNscrollVertical, False); n++;
	XtSetArg(args[n], XmNresizeHeight, False); n++;
	XtSetArg(args[n], XmNresizeWidth, False); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetArg(args[n], XmNmaxLength, 3); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	XtSetArg(args[n], XmNy, 50); n++;
	titlerset.WidthWg = XmCreateText(titlerset.Root, "width", args, n);
	XtManageChild(titlerset.WidthWg);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Height:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 185); n++;
	XtSetArg(args[n], XmNy, 80); n++;
	label = XmCreateLabelGadget(titlerset.Root, "Height", args, n);
	XtManageChild(label);

	n = 0;
	XtSetArg(args[n], XmNwidth, 50); n++;
	XtSetArg(args[n], XmNscrollHorizontal, False); n++;
	XtSetArg(args[n], XmNscrollVertical, False); n++;
	XtSetArg(args[n], XmNresizeHeight, False); n++;
	XtSetArg(args[n], XmNresizeWidth, False); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetArg(args[n], XmNmaxLength, 3); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	XtSetArg(args[n], XmNy, 80); n++;
	titlerset.HeightWg = XmCreateText(titlerset.Root, "height", args, n);
	XtManageChild(titlerset.HeightWg);

	n = 0;
	XtSetArg(args[n], XmNindicatorType, XmN_OF_MANY); n++;
	XtSetArg(args[n], XmNvisibleWhenOff, True); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Underlined", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 200); n++;
	XtSetArg(args[n], XmNy, 170); n++;
	titlerset.UnderLineWg = XmCreateToggleButtonGadget(titlerset.Root, "Tog", args, n);
	XtAddCallback(titlerset.UnderLineWg, XmNvalueChangedCallback, GifToggleCB, &titlerset.underline);
	XtManageChild(titlerset.UnderLineWg);

	submenu = (Widget) XmCreatePulldownMenu(titlerset.Root, "Pull", NULL, 0);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Standard", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.ColorBtn[0] = XmCreatePushButtonGadget(submenu, "Co", args, n);
	XtAddCallback(titlerset.ColorBtn[0], XmNactivateCallback, TitlerColorCB, (caddr_t *)0);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Color 1", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.ColorBtn[1] = XmCreatePushButtonGadget(submenu, "Co", args, n); 
	XtAddCallback(titlerset.ColorBtn[1], XmNactivateCallback, TitlerColorCB, (caddr_t *)1);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Color 2", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.ColorBtn[2] = XmCreatePushButtonGadget(submenu, "Co", args, n); 
	XtAddCallback(titlerset.ColorBtn[2], XmNactivateCallback, TitlerColorCB, (caddr_t *)2);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Color 3", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.ColorBtn[3] = XmCreatePushButtonGadget(submenu, "Co", args, n); 
	XtAddCallback(titlerset.ColorBtn[3], XmNactivateCallback, TitlerColorCB, (caddr_t *)3);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Color 4", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.ColorBtn[4] = XmCreatePushButtonGadget(submenu, "Co", args, n); 
	XtAddCallback(titlerset.ColorBtn[4], XmNactivateCallback, TitlerColorCB, (caddr_t *)4);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Color 5", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.ColorBtn[5] = XmCreatePushButtonGadget(submenu, "Co", args, n); 
	XtAddCallback(titlerset.ColorBtn[5], XmNactivateCallback, TitlerColorCB, (caddr_t *)5);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Color 6", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.ColorBtn[6] = XmCreatePushButtonGadget(submenu, "Co", args, n); 
	XtAddCallback(titlerset.ColorBtn[6], XmNactivateCallback, TitlerColorCB, (caddr_t *)6);

	XtManageChildren(titlerset.ColorBtn, 7);

	n = 0;
	XtSetArg(args[n], XmNsubMenuId, submenu); n++;
	XtSetArg(args[n], XmNmenuHistory, titlerset.ColorBtn[0]); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetArg(args[n], XmNspacing, 0); n++;
	XtSetArg(args[n], XmNpacking, XmPACK_TIGHT); n++;
	XtSetArg(args[n], XmNx, 185); n++;
	XtSetArg(args[n], XmNy, 110); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Color:", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.ColorOpWg = XmCreateOptionMenu(titlerset.Root, "Pull", args, n);
	XtManageChild(titlerset.ColorOpWg);

	submenu = (Widget) XmCreatePulldownMenu(titlerset.Root, "Pull", NULL, 0);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Left", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.AlignBtn[0] = XmCreatePushButtonGadget(submenu, "Co", args, n);
	XtAddCallback(titlerset.AlignBtn[0], XmNactivateCallback, TitlerAlignCB, (caddr_t *)0);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Center", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.AlignBtn[1] = XmCreatePushButtonGadget(submenu, "Co", args, n); 
	XtAddCallback(titlerset.AlignBtn[1], XmNactivateCallback, TitlerAlignCB, (caddr_t *)1);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Right", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.AlignBtn[2] = XmCreatePushButtonGadget(submenu, "Co", args, n); 
	XtAddCallback(titlerset.AlignBtn[2], XmNactivateCallback, TitlerAlignCB, (caddr_t *)2);

	XtManageChildren(titlerset.AlignBtn, 3);

	n = 0;
	XtSetArg(args[n], XmNsubMenuId, submenu); n++;
	XtSetArg(args[n], XmNmenuHistory, titlerset.AlignBtn[0]); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetArg(args[n], XmNspacing, 0); n++;
	XtSetArg(args[n], XmNpacking, XmPACK_TIGHT); n++;
	XtSetArg(args[n], XmNx, 185); n++;
	XtSetArg(args[n], XmNy, 140); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Align:", XmSTRING_DEFAULT_CHARSET)); n++;
	titlerset.AlignOpWg = XmCreateOptionMenu(titlerset.Root, "Pull", args, n);
	XtManageChild(titlerset.AlignOpWg);

	n = 0;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Text:", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 210); n++;
	label = XmCreateLabelGadget(titlerset.Root, "Text", args, n);
	XtManageChild(label);

	n = 0;
	XtSetArg(args[n], XmNwidth, 330); n++;
	XtSetArg(args[n], XmNheight,23); n++;
	XtSetArg(args[n], XmNx, 15); n++;
	XtSetArg(args[n], XmNy, 225); n++;
	titlerset.TextWg = CreateSimpleHzWin(titlerset.Root, "TitlerText", args, n, &titlerset.sviewport); 
	XtManageChild(titlerset.TextWg);

	n = 0;
	XtSetArg(args[n], XmNwidth, 100); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Ok", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 80); n++;
	XtSetArg(args[n], XmNy, 270); n++;
	titlerset.OkBtn = XmCreatePushButtonGadget(titlerset.Root, "TitlerBtn", args, n);
	XtManageChild(titlerset.OkBtn);

	n = 0;
	XtSetArg(args[n], XmNwidth, 100); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Cancel", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNy, 270); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, titlerset.OkBtn); n++;
	titlerset.CancelBtn = XmCreatePushButtonGadget(titlerset.Root, "cancelBtn", args, n);
	XtManageChild(titlerset.CancelBtn);

	XtRealizeWidget(titlerset.PopUpWg);

	AddSHwCallbacks(&titlerset.sviewport);
}

void MyTitlePopup(viewport, title)
VIewportdata *viewport;
int title;
{
	Arg args[5];
	register int n;
	MYViewSHW *mytitler;
	int i;
	char line[10];

	if(titlerset.mapped) 
	{
		XRaiseWindow(XtDisplay(titlerset.PopUpWg), XtWindow(titlerset.PopUpWg));
		ErrorPopup("Close Another Header or Foot Window First!");
		return;
	}

	active_viewport = viewport;
	
	if(title) mytitler = &viewport->titler;
	else mytitler = &viewport->footer;

	mytitler->mapped = True;

	i = SearchFontList(mytitler->hzdata.FontId);

	n = 0;
	XtSetArg(args[n], XmNselectedItems, &charset.fontlist[i]); n++;
	XtSetArg(args[n], XmNselectedItemCount, 1); n++;
	XtSetValues(titlerset.HzFontLstWg, args, n);

	sprintf(line, "%d\0", mytitler->hzdata.point_width/100);
	
	n = 0;
	XtSetArg(args[n], XmNvalue, line); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetValues(titlerset.WidthWg, args, n);

	sprintf(line, "%d\0", mytitler->hzdata.point_height/100);

	n = 0;
	XtSetArg(args[n], XmNvalue, line); n++;
	XtSetArg(args[n], XmNmarginHeight, 0); n++;
	XtSetArg(args[n], XmNmarginWidth, 0); n++;
	XtSetValues(titlerset.HeightWg, args, n);

	if(mytitler->underline) XtSetArg(args[0], XmNset, True);
	else XtSetArg(args[0], XmNset, False);

	XtSetValues(titlerset.UnderLineWg, args, 1);

	titlerset.underline = mytitler->underline;

	titlerset.ColorNum = mytitler->ColorNum;

	XtSetArg(args[0], XmNmenuHistory, titlerset.ColorBtn[titlerset.ColorNum]); 
	XtSetValues(titlerset.ColorOpWg, args, 1);

	titlerset.Position = mytitler->Position;

	XtSetArg(args[0], XmNmenuHistory, titlerset.AlignBtn[titlerset.Position]);
	XtSetValues(titlerset.AlignOpWg, args, 1);

	if(mytitler->text) 
	{
		DBcpy(titlerset.sviewport.EditFile, mytitler->text, SHZW_MEM_UNIT);
		titlerset.sviewport.EditFile[SHZW_MEM_UNIT] = '\0';    
		titlerset.sviewport.viewp.currentnum = DBbytelen(titlerset.sviewport.EditFile);	
		titlerset.sviewport.viewp.DBcurrentnum = DBlen(titlerset.sviewport.EditFile);	
	}
	else
	{
		*titlerset.sviewport.EditFile = '\0';
		titlerset.sviewport.viewp.currentnum = 0;
		titlerset.sviewport.viewp.DBcurrentnum = 0;	
	}
	
	titlerset.sviewport.viewp.firstnum = 0; 
	titlerset.sviewport.cursor.CurPos = 0;
	titlerset.sviewport.cursor.MovePos = 0;
	titlerset.sviewport.cursor.StartPos = 0;
	titlerset.sviewport.cursor.EndPos = 0;
	titlerset.sviewport.cursor.DBCurPos = 0;
	titlerset.sviewport.cursor.DBMovePos = 0;
	titlerset.sviewport.cursor.DBStartPos = 0;
	titlerset.sviewport.cursor.DBEndPos = 0;
	titlerset.mapped = True;

	if(title) XtSetArg(args[0], XmNlabelString, XmStringCreate("HEADER", XmSTRING_DEFAULT_CHARSET));
	else XtSetArg(args[0], XmNlabelString, XmStringCreate("FOOT NOTE", XmSTRING_DEFAULT_CHARSET));
	
	XtSetValues(titlerset.Title, args, 1);
	
	XtRemoveAllCallbacks(titlerset.OkBtn, XmNactivateCallback);
	XtAddCallback(titlerset.OkBtn, XmNactivateCallback, OkTitlerCB, mytitler);
	
	XtRemoveAllCallbacks(titlerset.CancelBtn, XmNactivateCallback);	
	XtAddCallback(titlerset.CancelBtn, XmNactivateCallback, CancelTitlerCB, mytitler);

	PopupPosition(viewport->resource.PopUpShell, titlerset.PopUpWg);
	XtPopup(titlerset.PopUpWg, XtGrabNone); 
}

void TitlerPopupCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	MyTitlePopup((VIewportdata *)client_data, True);
}

void FooterPopupCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	MyTitlePopup((VIewportdata *)client_data, False);
}

void TitlerColorCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	titlerset.ColorNum = (int) client_data;
}

void TitlerAlignCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	titlerset.Position = (int) client_data;
}

void OkTitlerCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	MYViewSHW *mytitler = (MYViewSHW *) client_data;
	
	if(!TitlerSet(mytitler)) return;
	titlerset.mapped = False;
	mytitler->mapped = False;
	simple_active = False;
	active_simphzwin = NULL;
	XtPopdown(titlerset.PopUpWg);
}

void CancelTitlerCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	MYViewSHW *mytitler = (MYViewSHW *) client_data;
	
	titlerset.mapped = False;
	mytitler->mapped = False;
	simple_active = False;
	active_simphzwin = NULL;
	XtPopdown(titlerset.PopUpWg);
}

void FileReadSetTitler(viewport, cp, titler, id)
VIewportdata *viewport;
char *cp;
MYViewSHW *titler;
int id;
{
	if(id) ReadSetTitler(viewport, cp, titler);
	else 
	{
		titler->text = (unsigned short*)strDBdup(cp);
	}
}

void ReadSetTitler(viewport, cp, titler)
VIewportdata *viewport;
char *cp;
MYViewSHW *titler;
{
	int font_height = GlobalDefaults.fontheight;
	int font_width = GlobalDefaults.fontwidth;
	char *fontname = NULL, *searchprt;
	int i, j;

	titler->underline = False;
	titler->ColorNum = 0;
	titler->Position = 0;

	for(searchprt = cp; *searchprt != '\n' && *searchprt != '\0'; searchprt++);

	*searchprt = '\0';

	if(titler->text) 
	{
		free(titler->text);
		titler->text = NULL;
	}

	while(*cp == '@' && *(cp+1) == '[')
	{
		cp += 2;
		if(*cp >= '0' && *cp <= '9')
		{
			for(searchprt = cp; *searchprt != '\0' && *searchprt != ']'; searchprt++);
			
			if(*searchprt == '\0') break;

			*searchprt = '\0';

			if(sscanf(cp, "%d,%d", &i, &j) == 2)
			{
				if(i*j <= MAX_FONT_SIZE)
				{
					font_width = i;
					font_height = j;
				}	
			}
			else
			{
				if(i*i <= MAX_FONT_SIZE) font_width = font_height = i;
			}

			cp = searchprt + 1;
	
			continue;
		}
			
		if(*cp >= 'a' && *cp <= 'z')
		{
			for(searchprt = cp; *searchprt != '\0' && *searchprt != ']'; searchprt++);
				
			if(*searchprt == '\0') break;

			*searchprt = '\0';

			fontname = cp;
			
			cp = searchprt + 1;
		
			continue;
		}
				
		if(*cp == 'Z')
		{
			cp++;
			searchprt = cp + 1;

			if(*cp >= '0' && *cp <= '6' && *searchprt == ']')
			{
				titler->ColorNum = (int)(*cp) - (int)('0');
			}

			cp = searchprt + 1;
			
			continue;
		}
					
		if(*cp == 'U' && *(cp+1) == ']')
		{
			titler->underline = True;
			cp += 2;
			
			continue;
		}
						
		if(*cp == 'A')
		{
			cp++;
			searchprt = cp + 1;
			
			if(*cp >= '0' && *cp <= '2' && *searchprt == ']')
			{
				titler->Position = (int)(*cp) - (int)('0');
			}

			cp = searchprt + 1;
		
			continue;
		}
	}
				
	if(*cp != '\0') titler->text = (unsigned short*)strDBdup(cp);

	if(fontname) InitPointFont(viewport->resource.WorkArea, &titler->hzdata, fontname, font_width, font_height, viewport->zoom);
	else InitPointFont(viewport->resource.WorkArea, &titler->hzdata, GlobalDefaults.fontname, font_width, font_height, viewport->zoom);
}

void ResetTitler(viewport, titler)
VIewportdata *viewport;
MYViewSHW *titler;
{
	if(titler->text)
	{
		free(titler->text);
		titler->text = NULL;
	}

	titler->underline = False;
	titler->ColorNum = 0;
	titler->Position = 0;

	InitPointFont(viewport->resource.WorkArea, &titler->hzdata, GlobalDefaults.fontname, GlobalDefaults.fontwidth, 
	GlobalDefaults.fontheight, viewport->zoom);
}

void WriteTitlerToFile(viewport, titler, note)
VIewportdata *viewport;
MYViewSHW *titler;
char *note;
{
	unsigned char *sp;

	if(titler->text == NULL) return;
	
	fprintf(viewport->fp, "%s@[%d,%d]@[%s]@[Z%d]@[A%d]", note, titler->hzdata.point_width/100, titler->hzdata.point_height/100, 
		titler->hzdata.FontId, titler->ColorNum, titler->Position);	
	if(titler->underline) fprintf(viewport->fp, "@[U]");

	sp = DBstrdup(titler->text);
	fprintf(viewport->fp, "%s\n", sp);
	free(sp);
}


