/*
 * Copyright 1995, 1996, 1997 by Jun Yei.       All Rights Reserved
 *
 * Permission to retain, use, modify, copy, and distribute ChinesePower
 * in source or binary and its documentation (hereafter, the Software)
 * for noncommercial purpose is hereby granted to you without a fee,
 * provided that this entire copyright and permission notice appear in
 * all such copies, that no charge be associated with such copies,
 * that distribution of derivative works (including value-added
 * distributions such as with additional input dictionaries or fonts)
 * include clarification that such added or derived parts are not from
 * the original Software, and that the names of the author(s) not be
 * used to endorse or promote such works. The author(s) of the software
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) OF THE SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR(S) OF THE SOFTWARE BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Jun Yei, Ottawa, ON, Canada
 */

#include "chpower.h"

void CancelTTFSetCB();
void DoTTFSetCB();
void TTFSetCB();

TTFMenu ttfset;

int TTFSet()
{	
	char *line = NULL;
	Arg args[1];
	int size, numoffont;
	MYfontlist *search;
/*	char out[10];
*/
	numoffont = 0;

	for(search = FontListRoot; search != NULL; search = search->Next)
	{
		if(search->FontType == TTFONT)
		{
			XtSetArg(args[0], XmNset, &ttfset.Font[numoffont].BitMap);
			XtGetValues(ttfset.Font[numoffont].AsBit, args, 1);
		
			XtSetArg(args[0], XmNvalue, &line);
			XtGetValues(ttfset.Font[numoffont].Text, args, 1);

			sscanf(line, "%d", &size);

			XtFree(line);
			
			if(size < 16) size = 16;
			if(size > 16 && size < 24) size = 24;
			if(size > 24 && size < 32) size = 32;
			if(size > 32 && size < 40) size = 40;
			if(size > 40 && size < 48) size = 48;
			if(size > 48 && size < 56) size = 56;
			if(size > 56 && size < 64) size = 64;
			if(size > 64 && size < 72) size = 72;
			if(size > 72 && size < 80) size = 80;
			if(size > 80 && size < 88) size = 88;
			if(size > 88) size = 96;

			ttfset.Font[numoffont].Size = size;
		
/*			sprintf(out, "%d", ttfset.Font[numoffont].Size);        

			XtSetArg(args[0], XmNvalue, out);
			XtSetValues(ttfset.Font[numoffont].Text, args, 1);
*/		}

		numoffont++;
	}
	
	return(True);
}


void CreateTTFSet(parent)
Widget parent;
{
	Widget label;
	MYfontlist *search;
	int numofttf, numoffont;

	Arg args[MAX_ARGS];
	register int n;

	ttfset.PopUpWg = XtCreatePopupShell("page Window", transientShellWidgetClass, parent, NULL, 0);

	numofttf = 0;
	numoffont = 0;

	for(search = FontListRoot; search != NULL; search = search->Next)
	{
		numoffont++;
		if(search->FontType == TTFONT) numofttf++;
	}

	ttfset.Font = (TTFWig *)calloc(sizeof(TTFWig), numoffont);

	n = 0;
	XtSetArg(args[n], XmNheight, 30*numofttf + 60); n++;
	XtSetArg(args[n], XmNwidth, 245); n++;
	XtSetArg(args[n], XmNhorizontalSpacing, 0); n++;
	XtSetArg(args[n], XmNverticalSpacing, 0); n++;
	XtSetArg(args[n], XmNrubberPositioning, True); n++;
	ttfset.Root = XmCreateForm(ttfset.PopUpWg, "TTFSet", args, n);
	XtManageChild(ttfset.Root);
	XtAddCallback(ttfset.Root, XmNdestroyCallback, MainDestroyCB, NULL);

	numoffont = 0;
	numofttf = 0;

	for(search = FontListRoot; search != NULL; search = search->Next)
	{
		ttfset.Font[numoffont].BitMap = GlobalDefaults.ttf_as_bitmap;
		ttfset.Font[numoffont].Size = 40;
		
		if(search->FontType == TTFONT)
		{
			n = 0;
			XtSetArg(args[n], XmNlabelString, XmStringCreate(search->FontId, XmSTRING_DEFAULT_CHARSET)); n++;
			XtSetArg(args[n], XmNx, 15); n++;
			XtSetArg(args[n], XmNy, 15 + numofttf * 30); n++;
			label = XmCreateLabelGadget(ttfset.Root, "Label", args, n);
			XtManageChild(label);
	
			n = 0;
			XtSetArg(args[n], XmNset, True); n++;
			XtSetArg(args[n], XmNindicatorType, XmN_OF_MANY); n++;
			XtSetArg(args[n], XmNvisibleWhenOff, True); n++;
			XtSetArg(args[n], XmNlabelString, XmStringCreate("As BitMap", XmSTRING_DEFAULT_CHARSET)); n++;
			XtSetArg(args[n], XmNx, 55); n++;
			XtSetArg(args[n], XmNy, 11 + numofttf * 30); n++;
			ttfset.Font[numoffont].AsBit = XmCreateToggleButtonGadget(ttfset.Root, "Land", args,n);
			XtManageChild(ttfset.Font[numoffont].AsBit);

			n = 0;
			XtSetArg(args[n], XmNlabelString, XmStringCreate("Size:", XmSTRING_DEFAULT_CHARSET)); n++;
			XtSetArg(args[n], XmNx, 140); n++;
			XtSetArg(args[n], XmNy, 15 + numofttf * 30); n++;
			label = XmCreateLabelGadget(ttfset.Root, "Label", args, n);
			XtManageChild(label);
			
			n = 0;
			XtSetArg(args[n], XmNwidth, 40); n++;
			XtSetArg(args[n], XmNscrollHorizontal, False); n++;
			XtSetArg(args[n], XmNscrollVertical, False); n++;
			XtSetArg(args[n], XmNresizeHeight, False); n++;
			XtSetArg(args[n], XmNresizeWidth, False); n++;
			XtSetArg(args[n], XmNmarginHeight, 0); n++;
			XtSetArg(args[n], XmNmarginWidth, 0); n++;
			XtSetArg(args[n], XmNmaxLength, 3); n++;
			XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
			XtSetArg(args[n], XmNleftWidget, label); n++;
			XtSetArg(args[n], XmNrightAttachment, XmATTACH_NONE); n++;	
			XtSetArg(args[n], XmNy, 15 + numofttf * 30); n++;
			ttfset.Font[numoffont].Text = XmCreateText(ttfset.Root, "Text", args, n); 
			XtManageChild(ttfset.Font[numoffont].Text);
			
			numofttf++;
		}
		else
		{
			ttfset.Font[numoffont].AsBit = NULL;
			ttfset.Font[numoffont].Text = NULL;
		}

		numoffont++;
	}
	
	n = 0;
	XtSetArg(args[n], XmNwidth, 100); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Ok", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNx, 20); n++;
	XtSetArg(args[n], XmNy, 30 + numofttf * 30); n++;
	label = XmCreatePushButtonGadget(ttfset.Root, "Btn", args, n);
	XtManageChild(label);
	XtAddCallback(label, XmNactivateCallback, DoTTFSetCB, NULL);

	n = 0;
	XtSetArg(args[n], XmNwidth, 100); n++;
	XtSetArg(args[n], XmNlabelString, XmStringCreate("Cancel", XmSTRING_DEFAULT_CHARSET)); n++;
	XtSetArg(args[n], XmNy, 30 + numofttf * 30); n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNleftWidget, label); n++;
	label = XmCreatePushButtonGadget(ttfset.Root, "Btn", args, n);
	XtManageChild(label);
	XtAddCallback(label, XmNactivateCallback, CancelTTFSetCB, NULL);

	XtRealizeWidget(ttfset.PopUpWg);
}

void TTFSetCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	MYfontlist *search;
	int numoffont, numofttf;
	Arg args[1];
	char line[10];

	numoffont = 0;
	numofttf = 0;

	for(search = FontListRoot; search != NULL; search = search->Next)
	{
		if(search->FontType == TTFONT)
		{
			if(ttfset.Font[numoffont].BitMap) XtSetArg(args[0], XmNset, True); 
			else XtSetArg(args[0], XmNset, False);

			XtSetValues(ttfset.Font[numoffont].AsBit, args, 1);
			
			sprintf(line, "%d", ttfset.Font[numoffont].Size);
			
			XtSetArg(args[0], XmNvalue, line);
			XtSetValues(ttfset.Font[numoffont].Text, args, 1);
		
			numofttf++;	
		}

		numoffont++;
	}

	if(numofttf == 0) { ErrorPopup("No TTF available!"); return; }

	PopupPosition(active_viewport->resource.PopUpShell, ttfset.PopUpWg);
	XtPopup(ttfset.PopUpWg, XtGrabExclusive); 
}

void DoTTFSetCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	TTFSet();
	XtPopdown(ttfset.PopUpWg);
}

void CancelTTFSetCB(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
	XtPopdown(ttfset.PopUpWg);
}

void DestroyTTFSet()
{
	free(ttfset.Font);
}

